#!/usr/bin/env python

import sys, base64

VERSIONEER_b64 = """
CiMgVmVyc2lvbjogMC4yNQoKIiIiVGhlIFZlcnNpb25lZXIgLSBsaWtlIGEg
cm9ja2V0ZWVyLCBidXQgZm9yIHZlcnNpb25zLgoKVGhlIFZlcnNpb25lZXIK
PT09PT09PT09PT09PT0KCiogbGlrZSBhIHJvY2tldGVlciwgYnV0IGZvciB2
ZXJzaW9ucyEKKiBodHRwczovL2dpdGh1Yi5jb20vcHl0aG9uLXZlcnNpb25l
ZXIvcHl0aG9uLXZlcnNpb25lZXIKKiBCcmlhbiBXYXJuZXIKKiBMaWNlbnNl
OiBQdWJsaWMgRG9tYWluIChVbmxpY2Vuc2UpCiogQ29tcGF0aWJsZSB3aXRo
OiBQeXRob24gMy43LCAzLjgsIDMuOSwgMy4xMCBhbmQgcHlweTMKKiBbIVtM
YXRlc3QgVmVyc2lvbl1bcHlwaS1pbWFnZV1dW3B5cGktdXJsXQoqIFshW0J1
aWxkIFN0YXR1c11bdHJhdmlzLWltYWdlXV1bdHJhdmlzLXVybF0KClRoaXMg
aXMgYSB0b29sIGZvciBtYW5hZ2luZyBhIHJlY29yZGVkIHZlcnNpb24gbnVt
YmVyIGluIHNldHVwdG9vbHMtYmFzZWQKcHl0aG9uIHByb2plY3RzLiBUaGUg
Z29hbCBpcyB0byByZW1vdmUgdGhlIHRlZGlvdXMgYW5kIGVycm9yLXByb25l
ICJ1cGRhdGUKdGhlIGVtYmVkZGVkIHZlcnNpb24gc3RyaW5nIiBzdGVwIGZy
b20geW91ciByZWxlYXNlIHByb2Nlc3MuIE1ha2luZyBhIG5ldwpyZWxlYXNl
IHNob3VsZCBiZSBhcyBlYXN5IGFzIHJlY29yZGluZyBhIG5ldyB0YWcgaW4g
eW91ciB2ZXJzaW9uLWNvbnRyb2wKc3lzdGVtLCBhbmQgbWF5YmUgbWFraW5n
IG5ldyB0YXJiYWxscy4KCgojIyBRdWljayBJbnN0YWxsCgpWZXJzaW9uZWVy
IHByb3ZpZGVzIHR3byBpbnN0YWxsYXRpb24gbW9kZXMuIFRoZSAiY2xhc3Np
YyIgdmVuZG9yZWQgbW9kZSBpbnN0YWxscwphIGNvcHkgb2YgdmVyc2lvbmVl
ciBpbnRvIHlvdXIgcmVwb3NpdG9yeS4gVGhlIGV4cGVyaW1lbnRhbCBidWls
ZC10aW1lIGRlcGVuZGVuY3kgbW9kZQppcyBpbnRlbmRlZCB0byBhbGxvdyB5
b3UgdG8gc2tpcCB0aGlzIHN0ZXAgYW5kIHNpbXBsaWZ5IHRoZSBwcm9jZXNz
IG9mIHVwZ3JhZGluZy4KCiMjIyBWZW5kb3JlZCBtb2RlCgoqIGBwaXAgaW5z
dGFsbCB2ZXJzaW9uZWVyYCB0byBzb21ld2hlcmUgaW4geW91ciAkUEFUSAoq
IGFkZCBhIGBbdmVyc2lvbmVlcl1gIHNlY3Rpb24gdG8geW91ciBzZXR1cC5j
ZmcgKHNlZSBbSW5zdGFsbF0oSU5TVEFMTC5tZCkpCiogcnVuIGB2ZXJzaW9u
ZWVyIGluc3RhbGwgLS12ZW5kb3JgIGluIHlvdXIgc291cmNlIHRyZWUsIGNv
bW1pdCB0aGUgcmVzdWx0cwoqIHZlcmlmeSB2ZXJzaW9uIGluZm9ybWF0aW9u
IHdpdGggYHB5dGhvbiBzZXR1cC5weSB2ZXJzaW9uYAoKIyMjIEJ1aWxkLXRp
bWUgZGVwZW5kZW5jeSBtb2RlCgoqIGBwaXAgaW5zdGFsbCB2ZXJzaW9uZWVy
YCB0byBzb21ld2hlcmUgaW4geW91ciAkUEFUSAoqIGFkZCBhIGBbdmVyc2lv
bmVlcl1gIHNlY3Rpb24gdG8geW91ciBzZXR1cC5jZmcgKHNlZSBbSW5zdGFs
bF0oSU5TVEFMTC5tZCkpCiogYWRkIGB2ZXJzaW9uZWVyYCB0byB0aGUgYHJl
cXVpcmVzYCBrZXkgb2YgdGhlIGBidWlsZC1zeXN0ZW1gIHRhYmxlIGluCiAg
YHB5cHJvamVjdC50b21sYDoKICBgYGB0b21sCiAgW2J1aWxkLXN5c3RlbV0K
ICByZXF1aXJlcyA9IFsic2V0dXB0b29scyIsICJ2ZXJzaW9uZWVyIl0KICBi
dWlsZC1iYWNrZW5kID0gInNldHVwdG9vbHMuYnVpbGRfbWV0YSIKICBgYGAK
KiBydW4gYHZlcnNpb25lZXIgaW5zdGFsbCAtLW5vLXZlbmRvcmAgaW4geW91
ciBzb3VyY2UgdHJlZSwgY29tbWl0IHRoZSByZXN1bHRzCiogdmVyaWZ5IHZl
cnNpb24gaW5mb3JtYXRpb24gd2l0aCBgcHl0aG9uIHNldHVwLnB5IHZlcnNp
b25gCgojIyBWZXJzaW9uIElkZW50aWZpZXJzCgpTb3VyY2UgdHJlZXMgY29t
ZSBmcm9tIGEgdmFyaWV0eSBvZiBwbGFjZXM6CgoqIGEgdmVyc2lvbi1jb250
cm9sIHN5c3RlbSBjaGVja291dCAobW9zdGx5IHVzZWQgYnkgZGV2ZWxvcGVy
cykKKiBhIG5pZ2h0bHkgdGFyYmFsbCwgcHJvZHVjZWQgYnkgYnVpbGQgYXV0
b21hdGlvbgoqIGEgc25hcHNob3QgdGFyYmFsbCwgcHJvZHVjZWQgYnkgYSB3
ZWItYmFzZWQgVkNTIGJyb3dzZXIsIGxpa2UgZ2l0aHViJ3MKICAidGFyYmFs
bCBmcm9tIHRhZyIgZmVhdHVyZQoqIGEgcmVsZWFzZSB0YXJiYWxsLCBwcm9k
dWNlZCBieSAic2V0dXAucHkgc2Rpc3QiLCBkaXN0cmlidXRlZCB0aHJvdWdo
IFB5UEkKCldpdGhpbiBlYWNoIHNvdXJjZSB0cmVlLCB0aGUgdmVyc2lvbiBp
ZGVudGlmaWVyIChlaXRoZXIgYSBzdHJpbmcgb3IgYSBudW1iZXIsCnRoaXMg
dG9vbCBpcyBmb3JtYXQtYWdub3N0aWMpIGNhbiBjb21lIGZyb20gYSB2YXJp
ZXR5IG9mIHBsYWNlczoKCiogYXNrIHRoZSBWQ1MgdG9vbCBpdHNlbGYsIGUu
Zy4gImdpdCBkZXNjcmliZSIgKGZvciBjaGVja291dHMpLCB3aGljaCBrbm93
cwogIGFib3V0IHJlY2VudCAidGFncyIgYW5kIGFuIGFic29sdXRlIHJldmlz
aW9uLWlkCiogdGhlIG5hbWUgb2YgdGhlIGRpcmVjdG9yeSBpbnRvIHdoaWNo
IHRoZSB0YXJiYWxsIHdhcyB1bnBhY2tlZAoqIGFuIGV4cGFuZGVkIFZDUyBr
ZXl3b3JkICgkSWQkLCBldGMpCiogYSBgX3ZlcnNpb24ucHlgIGNyZWF0ZWQg
Ynkgc29tZSBlYXJsaWVyIGJ1aWxkIHN0ZXAKCkZvciByZWxlYXNlZCBzb2Z0
d2FyZSwgdGhlIHZlcnNpb24gaWRlbnRpZmllciBpcyBjbG9zZWx5IHJlbGF0
ZWQgdG8gYSBWQ1MKdGFnLiBTb21lIHByb2plY3RzIHVzZSB0YWcgbmFtZXMg
dGhhdCBpbmNsdWRlIG1vcmUgdGhhbiBqdXN0IHRoZSB2ZXJzaW9uCnN0cmlu
ZyAoZS5nLiAibXlwcm9qZWN0LTEuMiIgaW5zdGVhZCBvZiBqdXN0ICIxLjIi
KSwgaW4gd2hpY2ggY2FzZSB0aGUgdG9vbApuZWVkcyB0byBzdHJpcCB0aGUg
dGFnIHByZWZpeCB0byBleHRyYWN0IHRoZSB2ZXJzaW9uIGlkZW50aWZpZXIu
IEZvcgp1bnJlbGVhc2VkIHNvZnR3YXJlIChiZXR3ZWVuIHRhZ3MpLCB0aGUg
dmVyc2lvbiBpZGVudGlmaWVyIHNob3VsZCBwcm92aWRlCmVub3VnaCBpbmZv
cm1hdGlvbiB0byBoZWxwIGRldmVsb3BlcnMgcmVjcmVhdGUgdGhlIHNhbWUg
dHJlZSwgd2hpbGUgYWxzbwpnaXZpbmcgdGhlbSBhbiBpZGVhIG9mIHJvdWdo
bHkgaG93IG9sZCB0aGUgdHJlZSBpcyAoYWZ0ZXIgdmVyc2lvbiAxLjIsIGJl
Zm9yZQp2ZXJzaW9uIDEuMykuIE1hbnkgVkNTIHN5c3RlbXMgY2FuIHJlcG9y
dCBhIGRlc2NyaXB0aW9uIHRoYXQgY2FwdHVyZXMgdGhpcywKZm9yIGV4YW1w
bGUgYGdpdCBkZXNjcmliZSAtLXRhZ3MgLS1kaXJ0eSAtLWFsd2F5c2AgcmVw
b3J0cyB0aGluZ3MgbGlrZQoiMC43LTEtZzU3NGFiOTgtZGlydHkiIHRvIGlu
ZGljYXRlIHRoYXQgdGhlIGNoZWNrb3V0IGlzIG9uZSByZXZpc2lvbiBwYXN0
IHRoZQowLjcgdGFnLCBoYXMgYSB1bmlxdWUgcmV2aXNpb24gaWQgb2YgIjU3
NGFiOTgiLCBhbmQgaXMgImRpcnR5IiAoaXQgaGFzCnVuY29tbWl0dGVkIGNo
YW5nZXMpLgoKVGhlIHZlcnNpb24gaWRlbnRpZmllciBpcyB1c2VkIGZvciBt
dWx0aXBsZSBwdXJwb3NlczoKCiogdG8gYWxsb3cgdGhlIG1vZHVsZSB0byBz
ZWxmLWlkZW50aWZ5IGl0cyB2ZXJzaW9uOiBgbXlwcm9qZWN0Ll9fdmVyc2lv
bl9fYAoqIHRvIGNob29zZSBhIG5hbWUgYW5kIHByZWZpeCBmb3IgYSAnc2V0
dXAucHkgc2Rpc3QnIHRhcmJhbGwKCiMjIFRoZW9yeSBvZiBPcGVyYXRpb24K
ClZlcnNpb25lZXIgd29ya3MgYnkgYWRkaW5nIGEgc3BlY2lhbCBgX3ZlcnNp
b24ucHlgIGZpbGUgaW50byB5b3VyIHNvdXJjZQp0cmVlLCB3aGVyZSB5b3Vy
IGBfX2luaXRfXy5weWAgY2FuIGltcG9ydCBpdC4gVGhpcyBgX3ZlcnNpb24u
cHlgIGtub3dzIGhvdyB0bwpkeW5hbWljYWxseSBhc2sgdGhlIFZDUyB0b29s
IGZvciB2ZXJzaW9uIGluZm9ybWF0aW9uIGF0IGltcG9ydCB0aW1lLgoKYF92
ZXJzaW9uLnB5YCBhbHNvIGNvbnRhaW5zIGAkUmV2aXNpb24kYCBtYXJrZXJz
LCBhbmQgdGhlIGluc3RhbGxhdGlvbgpwcm9jZXNzIG1hcmtzIGBfdmVyc2lv
bi5weWAgdG8gaGF2ZSB0aGlzIG1hcmtlciByZXdyaXR0ZW4gd2l0aCBhIHRh
ZyBuYW1lCmR1cmluZyB0aGUgYGdpdCBhcmNoaXZlYCBjb21tYW5kLiBBcyBh
IHJlc3VsdCwgZ2VuZXJhdGVkIHRhcmJhbGxzIHdpbGwKY29udGFpbiBlbm91
Z2ggaW5mb3JtYXRpb24gdG8gZ2V0IHRoZSBwcm9wZXIgdmVyc2lvbi4KClRv
IGFsbG93IGBzZXR1cC5weWAgdG8gY29tcHV0ZSBhIHZlcnNpb24gdG9vLCBh
IGB2ZXJzaW9uZWVyLnB5YCBpcyBhZGRlZCB0bwp0aGUgdG9wIGxldmVsIG9m
IHlvdXIgc291cmNlIHRyZWUsIG5leHQgdG8gYHNldHVwLnB5YCBhbmQgdGhl
IGBzZXR1cC5jZmdgCnRoYXQgY29uZmlndXJlcyBpdC4gVGhpcyBvdmVycmlk
ZXMgc2V2ZXJhbCBkaXN0dXRpbHMvc2V0dXB0b29scyBjb21tYW5kcyB0bwpj
b21wdXRlIHRoZSB2ZXJzaW9uIHdoZW4gaW52b2tlZCwgYW5kIGNoYW5nZXMg
YHNldHVwLnB5IGJ1aWxkYCBhbmQgYHNldHVwLnB5CnNkaXN0YCB0byByZXBs
YWNlIGBfdmVyc2lvbi5weWAgd2l0aCBhIHNtYWxsIHN0YXRpYyBmaWxlIHRo
YXQgY29udGFpbnMganVzdAp0aGUgZ2VuZXJhdGVkIHZlcnNpb24gZGF0YS4K
CiMjIEluc3RhbGxhdGlvbgoKU2VlIFtJTlNUQUxMLm1kXSguL0lOU1RBTEwu
bWQpIGZvciBkZXRhaWxlZCBpbnN0YWxsYXRpb24gaW5zdHJ1Y3Rpb25zLgoK
IyMgVmVyc2lvbi1TdHJpbmcgRmxhdm9ycwoKQ29kZSB3aGljaCB1c2VzIFZl
cnNpb25lZXIgY2FuIGxlYXJuIGFib3V0IGl0cyB2ZXJzaW9uIHN0cmluZyBh
dCBydW50aW1lIGJ5CmltcG9ydGluZyBgX3ZlcnNpb25gIGZyb20geW91ciBt
YWluIGBfX2luaXRfXy5weWAgZmlsZSBhbmQgcnVubmluZyB0aGUKYGdldF92
ZXJzaW9ucygpYCBmdW5jdGlvbi4gRnJvbSB0aGUgIm91dHNpZGUiIChlLmcu
IGluIGBzZXR1cC5weWApLCB5b3UgY2FuCmltcG9ydCB0aGUgdG9wLWxldmVs
IGB2ZXJzaW9uZWVyLnB5YCBhbmQgcnVuIGBnZXRfdmVyc2lvbnMoKWAuCgpC
b3RoIGZ1bmN0aW9ucyByZXR1cm4gYSBkaWN0aW9uYXJ5IHdpdGggZGlmZmVy
ZW50IGZsYXZvcnMgb2YgdmVyc2lvbgppbmZvcm1hdGlvbjoKCiogYFsndmVy
c2lvbiddYDogQSBjb25kZW5zZWQgdmVyc2lvbiBzdHJpbmcsIHJlbmRlcmVk
IHVzaW5nIHRoZSBzZWxlY3RlZAogIHN0eWxlLiBUaGlzIGlzIHRoZSBtb3N0
IGNvbW1vbmx5IHVzZWQgdmFsdWUgZm9yIHRoZSBwcm9qZWN0J3MgdmVyc2lv
bgogIHN0cmluZy4gVGhlIGRlZmF1bHQgInBlcDQ0MCIgc3R5bGUgeWllbGRz
IHN0cmluZ3MgbGlrZSBgMC4xMWAsCiAgYDAuMTErMi5nMTA3NmM5N2AsIG9y
IGAwLjExKzIuZzEwNzZjOTcuZGlydHlgLiBTZWUgdGhlICJTdHlsZXMiIHNl
Y3Rpb24KICBiZWxvdyBmb3IgYWx0ZXJuYXRpdmUgc3R5bGVzLgoKKiBgWydm
dWxsLXJldmlzaW9uaWQnXWA6IGRldGFpbGVkIHJldmlzaW9uIGlkZW50aWZp
ZXIuIEZvciBHaXQsIHRoaXMgaXMgdGhlCiAgZnVsbCBTSEExIGNvbW1pdCBp
ZCwgZS5nLiAiMTA3NmM5NzhhOGQzY2ZjNzBmNDA4ZmU1OTc0YWE2YzA5MmM5
NDlhYyIuCgoqIGBbJ2RhdGUnXWA6IERhdGUgYW5kIHRpbWUgb2YgdGhlIGxh
dGVzdCBgSEVBRGAgY29tbWl0LiBGb3IgR2l0LCBpdCBpcyB0aGUKICBjb21t
aXQgZGF0ZSBpbiBJU08gODYwMSBmb3JtYXQuIFRoaXMgd2lsbCBiZSBOb25l
IGlmIHRoZSBkYXRlIGlzIG5vdAogIGF2YWlsYWJsZS4KCiogYFsnZGlydHkn
XWA6IGEgYm9vbGVhbiwgVHJ1ZSBpZiB0aGUgdHJlZSBoYXMgdW5jb21taXR0
ZWQgY2hhbmdlcy4gTm90ZSB0aGF0CiAgdGhpcyBpcyBvbmx5IGFjY3VyYXRl
IGlmIHJ1biBpbiBhIFZDUyBjaGVja291dCwgb3RoZXJ3aXNlIGl0IGlzIGxp
a2VseSB0bwogIGJlIEZhbHNlIG9yIE5vbmUKCiogYFsnZXJyb3InXWA6IGlm
IHRoZSB2ZXJzaW9uIHN0cmluZyBjb3VsZCBub3QgYmUgY29tcHV0ZWQsIHRo
aXMgd2lsbCBiZSBzZXQKICB0byBhIHN0cmluZyBkZXNjcmliaW5nIHRoZSBw
cm9ibGVtLCBvdGhlcndpc2UgaXQgd2lsbCBiZSBOb25lLiBJdCBtYXkgYmUK
ICB1c2VmdWwgdG8gdGhyb3cgYW4gZXhjZXB0aW9uIGluIHNldHVwLnB5IGlm
IHRoaXMgaXMgc2V0LCB0byBhdm9pZCBlLmcuCiAgY3JlYXRpbmcgdGFyYmFs
bHMgd2l0aCBhIHZlcnNpb24gc3RyaW5nIG9mICJ1bmtub3duIi4KClNvbWUg
dmFyaWFudHMgYXJlIG1vcmUgdXNlZnVsIHRoYW4gb3RoZXJzLiBJbmNsdWRp
bmcgYGZ1bGwtcmV2aXNpb25pZGAgaW4gYQpidWcgcmVwb3J0IHNob3VsZCBh
bGxvdyBkZXZlbG9wZXJzIHRvIHJlY29uc3RydWN0IHRoZSBleGFjdCBjb2Rl
IGJlaW5nIHRlc3RlZAoob3IgaW5kaWNhdGUgdGhlIHByZXNlbmNlIG9mIGxv
Y2FsIGNoYW5nZXMgdGhhdCBzaG91bGQgYmUgc2hhcmVkIHdpdGggdGhlCmRl
dmVsb3BlcnMpLiBgdmVyc2lvbmAgaXMgc3VpdGFibGUgZm9yIGRpc3BsYXkg
aW4gYW4gImFib3V0IiBib3ggb3IgYSBDTEkKYC0tdmVyc2lvbmAgb3V0cHV0
OiBpdCBjYW4gYmUgZWFzaWx5IGNvbXBhcmVkIGFnYWluc3QgcmVsZWFzZSBu
b3RlcyBhbmQgbGlzdHMKb2YgYnVncyBmaXhlZCBpbiB2YXJpb3VzIHJlbGVh
c2VzLgoKVGhlIGluc3RhbGxlciBhZGRzIHRoZSBmb2xsb3dpbmcgdGV4dCB0
byB5b3VyIGBfX2luaXRfXy5weWAgdG8gcGxhY2UgYSBiYXNpYwp2ZXJzaW9u
IGluIGBZT1VSUFJPSkVDVC5fX3ZlcnNpb25fX2A6CgogICAgZnJvbSAuX3Zl
cnNpb24gaW1wb3J0IGdldF92ZXJzaW9ucwogICAgX192ZXJzaW9uX18gPSBn
ZXRfdmVyc2lvbnMoKVsndmVyc2lvbiddCiAgICBkZWwgZ2V0X3ZlcnNpb25z
CgojIyBTdHlsZXMKClRoZSBzZXR1cC5jZmcgYHN0eWxlPWAgY29uZmlndXJh
dGlvbiBjb250cm9scyBob3cgdGhlIFZDUyBpbmZvcm1hdGlvbiBpcwpyZW5k
ZXJlZCBpbnRvIGEgdmVyc2lvbiBzdHJpbmcuCgpUaGUgZGVmYXVsdCBzdHls
ZSwgInBlcDQ0MCIsIHByb2R1Y2VzIGEgUEVQNDQwLWNvbXBsaWFudCBzdHJp
bmcsIGVxdWFsIHRvIHRoZQp1bi1wcmVmaXhlZCB0YWcgbmFtZSBmb3IgYWN0
dWFsIHJlbGVhc2VzLCBhbmQgY29udGFpbmluZyBhbiBhZGRpdGlvbmFsICJs
b2NhbAp2ZXJzaW9uIiBzZWN0aW9uIHdpdGggbW9yZSBkZXRhaWwgZm9yIGlu
LWJldHdlZW4gYnVpbGRzLiBGb3IgR2l0LCB0aGlzIGlzClRBR1srRElTVEFO
Q0UuZ0hFWFsuZGlydHldXSAsIHVzaW5nIGluZm9ybWF0aW9uIGZyb20gYGdp
dCBkZXNjcmliZSAtLXRhZ3MKLS1kaXJ0eSAtLWFsd2F5c2AuIEZvciBleGFt
cGxlICIwLjExKzIuZzEwNzZjOTcuZGlydHkiIGluZGljYXRlcyB0aGF0IHRo
ZQp0cmVlIGlzIGxpa2UgdGhlICIxMDc2Yzk3IiBjb21taXQgYnV0IGhhcyB1
bmNvbW1pdHRlZCBjaGFuZ2VzICgiLmRpcnR5IiksIGFuZAp0aGF0IHRoaXMg
Y29tbWl0IGlzIHR3byByZXZpc2lvbnMgKCIrMiIpIGJleW9uZCB0aGUgIjAu
MTEiIHRhZy4gRm9yIHJlbGVhc2VkCnNvZnR3YXJlIChleGFjdGx5IGVxdWFs
IHRvIGEga25vd24gdGFnKSwgdGhlIGlkZW50aWZpZXIgd2lsbCBvbmx5IGNv
bnRhaW4gdGhlCnN0cmlwcGVkIHRhZywgZS5nLiAiMC4xMSIuCgpPdGhlciBz
dHlsZXMgYXJlIGF2YWlsYWJsZS4gU2VlIFtkZXRhaWxzLm1kXShkZXRhaWxz
Lm1kKSBpbiB0aGUgVmVyc2lvbmVlcgpzb3VyY2UgdHJlZSBmb3IgZGVzY3Jp
cHRpb25zLgoKIyMgRGVidWdnaW5nCgpWZXJzaW9uZWVyIHRyaWVzIHRvIGF2
b2lkIGZhdGFsIGVycm9yczogaWYgc29tZXRoaW5nIGdvZXMgd3JvbmcsIGl0
IHdpbGwgdGVuZAp0byByZXR1cm4gYSB2ZXJzaW9uIG9mICIwK3Vua25vd24i
LiBUbyBpbnZlc3RpZ2F0ZSB0aGUgcHJvYmxlbSwgcnVuIGBzZXR1cC5weQp2
ZXJzaW9uYCwgd2hpY2ggd2lsbCBydW4gdGhlIHZlcnNpb24tbG9va3VwIGNv
ZGUgaW4gYSB2ZXJib3NlIG1vZGUsIGFuZCB3aWxsCmRpc3BsYXkgdGhlIGZ1
bGwgY29udGVudHMgb2YgYGdldF92ZXJzaW9ucygpYCAoaW5jbHVkaW5nIHRo
ZSBgZXJyb3JgIHN0cmluZywKd2hpY2ggbWF5IGhlbHAgaWRlbnRpZnkgd2hh
dCB3ZW50IHdyb25nKS4KCiMjIEtub3duIExpbWl0YXRpb25zCgpTb21lIHNp
dHVhdGlvbnMgYXJlIGtub3duIHRvIGNhdXNlIHByb2JsZW1zIGZvciBWZXJz
aW9uZWVyLiBUaGlzIGRldGFpbHMgdGhlCm1vc3Qgc2lnbmlmaWNhbnQgb25l
cy4gTW9yZSBjYW4gYmUgZm91bmQgb24gR2l0aHViCltpc3N1ZXMgcGFnZV0o
aHR0cHM6Ly9naXRodWIuY29tL3B5dGhvbi12ZXJzaW9uZWVyL3B5dGhvbi12
ZXJzaW9uZWVyL2lzc3VlcykuCgojIyMgU3VicHJvamVjdHMKClZlcnNpb25l
ZXIgaGFzIGxpbWl0ZWQgc3VwcG9ydCBmb3Igc291cmNlIHRyZWVzIGluIHdo
aWNoIGBzZXR1cC5weWAgaXMgbm90IGluCnRoZSByb290IGRpcmVjdG9yeSAo
ZS5nLiBgc2V0dXAucHlgIGFuZCBgLmdpdC9gIGFyZSAqbm90KiBzaWJsaW5n
cykuIFRoZSBhcmUKdHdvIGNvbW1vbiByZWFzb25zIHdoeSBgc2V0dXAucHlg
IG1pZ2h0IG5vdCBiZSBpbiB0aGUgcm9vdDoKCiogU291cmNlIHRyZWVzIHdo
aWNoIGNvbnRhaW4gbXVsdGlwbGUgc3VicHJvamVjdHMsIHN1Y2ggYXMKICBb
QnVpbGRib3RdKGh0dHBzOi8vZ2l0aHViLmNvbS9idWlsZGJvdC9idWlsZGJv
dCksIHdoaWNoIGNvbnRhaW5zIGJvdGgKICAibWFzdGVyIiBhbmQgInNsYXZl
IiBzdWJwcm9qZWN0cywgZWFjaCB3aXRoIHRoZWlyIG93biBgc2V0dXAucHlg
LAogIGBzZXR1cC5jZmdgLCBhbmQgYHRveC5pbmlgLiBQcm9qZWN0cyBsaWtl
IHRoZXNlIHByb2R1Y2UgbXVsdGlwbGUgUHlQSQogIGRpc3RyaWJ1dGlvbnMg
KGFuZCB1cGxvYWQgbXVsdGlwbGUgaW5kZXBlbmRlbnRseS1pbnN0YWxsYWJs
ZSB0YXJiYWxscykuCiogU291cmNlIHRyZWVzIHdob3NlIG1haW4gcHVycG9z
ZSBpcyB0byBjb250YWluIGEgQyBsaWJyYXJ5LCBidXQgd2hpY2ggYWxzbwog
IHByb3ZpZGUgYmluZGluZ3MgdG8gUHl0aG9uIChhbmQgcGVyaGFwcyBvdGhl
ciBsYW5ndWFnZXMpIGluIHN1YmRpcmVjdG9yaWVzLgoKVmVyc2lvbmVlciB3
aWxsIGxvb2sgZm9yIGAuZ2l0YCBpbiBwYXJlbnQgZGlyZWN0b3JpZXMsIGFu
ZCBtb3N0IG9wZXJhdGlvbnMKc2hvdWxkIGdldCB0aGUgcmlnaHQgdmVyc2lv
biBzdHJpbmcuIEhvd2V2ZXIgYHBpcGAgYW5kIGBzZXR1cHRvb2xzYCBoYXZl
IGJ1Z3MKYW5kIGltcGxlbWVudGF0aW9uIGRldGFpbHMgd2hpY2ggZnJlcXVl
bnRseSBjYXVzZSBgcGlwIGluc3RhbGwgLmAgZnJvbSBhCnN1YnByb2plY3Qg
ZGlyZWN0b3J5IHRvIGZhaWwgdG8gZmluZCBhIGNvcnJlY3QgdmVyc2lvbiBz
dHJpbmcgKHNvIGl0IHVzdWFsbHkKZGVmYXVsdHMgdG8gYDArdW5rbm93bmAp
LgoKYHBpcCBpbnN0YWxsIC0tZWRpdGFibGUgLmAgc2hvdWxkIHdvcmsgY29y
cmVjdGx5LiBgc2V0dXAucHkgaW5zdGFsbGAgbWlnaHQKd29yayB0b28uCgpQ
aXAtOC4xLjEgaXMga25vd24gdG8gaGF2ZSB0aGlzIHByb2JsZW0sIGJ1dCBo
b3BlZnVsbHkgaXQgd2lsbCBnZXQgZml4ZWQgaW4Kc29tZSBsYXRlciB2ZXJz
aW9uLgoKW0J1ZyAjMzhdKGh0dHBzOi8vZ2l0aHViLmNvbS9weXRob24tdmVy
c2lvbmVlci9weXRob24tdmVyc2lvbmVlci9pc3N1ZXMvMzgpIGlzIHRyYWNr
aW5nCnRoaXMgaXNzdWUuIFRoZSBkaXNjdXNzaW9uIGluCltQUiAjNjFdKGh0
dHBzOi8vZ2l0aHViLmNvbS9weXRob24tdmVyc2lvbmVlci9weXRob24tdmVy
c2lvbmVlci9wdWxsLzYxKSBkZXNjcmliZXMgdGhlCmlzc3VlIGZyb20gdGhl
IFZlcnNpb25lZXIgc2lkZSBpbiBtb3JlIGRldGFpbC4KW3BpcCBQUiMzMTc2
XShodHRwczovL2dpdGh1Yi5jb20vcHlwYS9waXAvcHVsbC8zMTc2KSBhbmQK
W3BpcCBQUiMzNjE1XShodHRwczovL2dpdGh1Yi5jb20vcHlwYS9waXAvcHVs
bC8zNjE1KSBjb250YWluIHdvcmsgdG8gaW1wcm92ZQpwaXAgdG8gbGV0IFZl
cnNpb25lZXIgd29yayBjb3JyZWN0bHkuCgpWZXJzaW9uZWVyLTAuMTYgYW5k
IGVhcmxpZXIgb25seSBsb29rZWQgZm9yIGEgYC5naXRgIGRpcmVjdG9yeSBu
ZXh0IHRvIHRoZQpgc2V0dXAuY2ZnYCwgc28gc3VicHJvamVjdHMgd2VyZSBj
b21wbGV0ZWx5IHVuc3VwcG9ydGVkIHdpdGggdGhvc2UgcmVsZWFzZXMuCgoj
IyMgRWRpdGFibGUgaW5zdGFsbHMgd2l0aCBzZXR1cHRvb2xzIDw9IDE4LjUK
CmBzZXR1cC5weSBkZXZlbG9wYCBhbmQgYHBpcCBpbnN0YWxsIC0tZWRpdGFi
bGUgLmAgYWxsb3cgeW91IHRvIGluc3RhbGwgYQpwcm9qZWN0IGludG8gYSB2
aXJ0dWFsZW52IG9uY2UsIHRoZW4gY29udGludWUgZWRpdGluZyB0aGUgc291
cmNlIGNvZGUgKGFuZAp0ZXN0KSB3aXRob3V0IHJlLWluc3RhbGxpbmcgYWZ0
ZXIgZXZlcnkgY2hhbmdlLgoKIkVudHJ5LXBvaW50IHNjcmlwdHMiIChgc2V0
dXAoZW50cnlfcG9pbnRzPXsiY29uc29sZV9zY3JpcHRzIjogLi59KWApIGFy
ZSBhCmNvbnZlbmllbnQgd2F5IHRvIHNwZWNpZnkgZXhlY3V0YWJsZSBzY3Jp
cHRzIHRoYXQgc2hvdWxkIGJlIGluc3RhbGxlZCBhbG9uZwp3aXRoIHRoZSBw
eXRob24gcGFja2FnZS4KClRoZXNlIGJvdGggd29yayBhcyBleHBlY3RlZCB3
aGVuIHVzaW5nIG1vZGVybiBzZXR1cHRvb2xzLiBXaGVuIHVzaW5nCnNldHVw
dG9vbHMtMTguNSBvciBlYXJsaWVyLCBob3dldmVyLCBjZXJ0YWluIG9wZXJh
dGlvbnMgd2lsbCBjYXVzZQpgcGtnX3Jlc291cmNlcy5EaXN0cmlidXRpb25O
b3RGb3VuZGAgZXJyb3JzIHdoZW4gcnVubmluZyB0aGUgZW50cnlwb2ludApz
Y3JpcHQsIHdoaWNoIG11c3QgYmUgcmVzb2x2ZWQgYnkgcmUtaW5zdGFsbGlu
ZyB0aGUgcGFja2FnZS4gVGhpcyBoYXBwZW5zCndoZW4gdGhlIGluc3RhbGwg
aGFwcGVucyB3aXRoIG9uZSB2ZXJzaW9uLCB0aGVuIHRoZSBlZ2dfaW5mbyBk
YXRhIGlzCnJlZ2VuZXJhdGVkIHdoaWxlIGEgZGlmZmVyZW50IHZlcnNpb24g
aXMgY2hlY2tlZCBvdXQuIE1hbnkgc2V0dXAucHkgY29tbWFuZHMKY2F1c2Ug
ZWdnX2luZm8gdG8gYmUgcmVidWlsdCAoaW5jbHVkaW5nIGBzZGlzdGAsIGB3
aGVlbGAsIGFuZCBpbnN0YWxsaW5nIGludG8KYSBkaWZmZXJlbnQgdmlydHVh
bGVudiksIHNvIHRoaXMgY2FuIGJlIHN1cnByaXNpbmcuCgpbQnVnICM4M10o
aHR0cHM6Ly9naXRodWIuY29tL3B5dGhvbi12ZXJzaW9uZWVyL3B5dGhvbi12
ZXJzaW9uZWVyL2lzc3Vlcy84MykgZGVzY3JpYmVzCnRoaXMgb25lLCBidXQg
dXBncmFkaW5nIHRvIGEgbmV3ZXIgdmVyc2lvbiBvZiBzZXR1cHRvb2xzIHNo
b3VsZCBwcm9iYWJseQpyZXNvbHZlIGl0LgoKCiMjIFVwZGF0aW5nIFZlcnNp
b25lZXIKClRvIHVwZ3JhZGUgeW91ciBwcm9qZWN0IHRvIGEgbmV3IHJlbGVh
c2Ugb2YgVmVyc2lvbmVlciwgZG8gdGhlIGZvbGxvd2luZzoKCiogaW5zdGFs
bCB0aGUgbmV3IFZlcnNpb25lZXIgKGBwaXAgaW5zdGFsbCAtVSB2ZXJzaW9u
ZWVyYCBvciBlcXVpdmFsZW50KQoqIGVkaXQgYHNldHVwLmNmZ2AsIGlmIG5l
Y2Vzc2FyeSwgdG8gaW5jbHVkZSBhbnkgbmV3IGNvbmZpZ3VyYXRpb24gc2V0
dGluZ3MKICBpbmRpY2F0ZWQgYnkgdGhlIHJlbGVhc2Ugbm90ZXMuIFNlZSBb
VVBHUkFESU5HXSguL1VQR1JBRElORy5tZCkgZm9yIGRldGFpbHMuCiogcmUt
cnVuIGB2ZXJzaW9uZWVyIGluc3RhbGwgLS1bbm8tXXZlbmRvcmAgaW4geW91
ciBzb3VyY2UgdHJlZSwgdG8gcmVwbGFjZQogIGBTUkMvX3ZlcnNpb24ucHlg
CiogY29tbWl0IGFueSBjaGFuZ2VkIGZpbGVzCgojIyBGdXR1cmUgRGlyZWN0
aW9ucwoKVGhpcyB0b29sIGlzIGRlc2lnbmVkIHRvIG1ha2UgaXQgZWFzaWx5
IGV4dGVuZGVkIHRvIG90aGVyIHZlcnNpb24tY29udHJvbApzeXN0ZW1zOiBh
bGwgVkNTLXNwZWNpZmljIGNvbXBvbmVudHMgYXJlIGluIHNlcGFyYXRlIGRp
cmVjdG9yaWVzIGxpa2UKc3JjL2dpdC8gLiBUaGUgdG9wLWxldmVsIGB2ZXJz
aW9uZWVyLnB5YCBzY3JpcHQgaXMgYXNzZW1ibGVkIGZyb20gdGhlc2UKY29t
cG9uZW50cyBieSBydW5uaW5nIG1ha2UtdmVyc2lvbmVlci5weSAuIEluIHRo
ZSBmdXR1cmUsIG1ha2UtdmVyc2lvbmVlci5weQp3aWxsIHRha2UgYSBWQ1Mg
bmFtZSBhcyBhbiBhcmd1bWVudCwgYW5kIHdpbGwgY29uc3RydWN0IGEgdmVy
c2lvbiBvZgpgdmVyc2lvbmVlci5weWAgdGhhdCBpcyBzcGVjaWZpYyB0byB0
aGUgZ2l2ZW4gVkNTLiBJdCBtaWdodCBhbHNvIHRha2UgdGhlCmNvbmZpZ3Vy
YXRpb24gYXJndW1lbnRzIHRoYXQgYXJlIGN1cnJlbnRseSBwcm92aWRlZCBt
YW51YWxseSBkdXJpbmcKaW5zdGFsbGF0aW9uIGJ5IGVkaXRpbmcgc2V0dXAu
cHkgLiBBbHRlcm5hdGl2ZWx5LCBpdCBtaWdodCBnbyB0aGUgb3RoZXIKZGly
ZWN0aW9uIGFuZCBpbmNsdWRlIGNvZGUgZnJvbSBhbGwgc3VwcG9ydGVkIFZD
UyBzeXN0ZW1zLCByZWR1Y2luZyB0aGUKbnVtYmVyIG9mIGludGVybWVkaWF0
ZSBzY3JpcHRzLgoKIyMgU2ltaWxhciBwcm9qZWN0cwoKKiBbc2V0dXB0b29s
c19zY21dKGh0dHBzOi8vZ2l0aHViLmNvbS9weXBhL3NldHVwdG9vbHNfc2Nt
LykgLSBhIG5vbi12ZW5kb3JlZCBidWlsZC10aW1lCiAgZGVwZW5kZW5jeQoq
IFttaW52ZXJdKGh0dHBzOi8vZ2l0aHViLmNvbS9qYndlc3Rvbi9taW5pdmVy
KSAtIGEgbGlnaHR3ZWlnaHQgcmVpbXBsZW1lbnRhdGlvbiBvZgogIHZlcnNp
b25lZXIKKiBbdmVyc2lvbmluZ2l0XShodHRwczovL2dpdGh1Yi5jb20vandv
ZGRlci92ZXJzaW9uaW5naXQpIC0gYSBQRVAgNTE4LWJhc2VkIHNldHVwdG9v
bHMKICBwbHVnaW4KCiMjIExpY2Vuc2UKClRvIG1ha2UgVmVyc2lvbmVlciBl
YXNpZXIgdG8gZW1iZWQsIGFsbCBpdHMgY29kZSBpcyBkZWRpY2F0ZWQgdG8g
dGhlIHB1YmxpYwpkb21haW4uIFRoZSBgX3ZlcnNpb24ucHlgIHRoYXQgaXQg
Y3JlYXRlcyBpcyBhbHNvIGluIHRoZSBwdWJsaWMgZG9tYWluLgpTcGVjaWZp
Y2FsbHksIGJvdGggYXJlIHJlbGVhc2VkIHVuZGVyIHRoZSBDcmVhdGl2ZSBD
b21tb25zICJQdWJsaWMgRG9tYWluCkRlZGljYXRpb24iIGxpY2Vuc2UgKEND
MC0xLjApLCBhcyBkZXNjcmliZWQgaW4KaHR0cHM6Ly9jcmVhdGl2ZWNvbW1v
bnMub3JnL3B1YmxpY2RvbWFpbi96ZXJvLzEuMC8gLgoKW3B5cGktaW1hZ2Vd
OiBodHRwczovL2ltZy5zaGllbGRzLmlvL3B5cGkvdi92ZXJzaW9uZWVyLnN2
ZwpbcHlwaS11cmxdOiBodHRwczovL3B5cGkucHl0aG9uLm9yZy9weXBpL3Zl
cnNpb25lZXIvClt0cmF2aXMtaW1hZ2VdOgpodHRwczovL2ltZy5zaGllbGRz
LmlvL3RyYXZpcy9jb20vcHl0aG9uLXZlcnNpb25lZXIvcHl0aG9uLXZlcnNp
b25lZXIuc3ZnClt0cmF2aXMtdXJsXTogaHR0cHM6Ly90cmF2aXMtY2kuY29t
L2dpdGh1Yi9weXRob24tdmVyc2lvbmVlci9weXRob24tdmVyc2lvbmVlcgoK
IiIiCiMgcHlsaW50OmRpc2FibGU9aW52YWxpZC1uYW1lLGltcG9ydC1vdXRz
aWRlLXRvcGxldmVsLG1pc3NpbmctZnVuY3Rpb24tZG9jc3RyaW5nCiMgcHls
aW50OmRpc2FibGU9bWlzc2luZy1jbGFzcy1kb2NzdHJpbmcsdG9vLW1hbnkt
YnJhbmNoZXMsdG9vLW1hbnktc3RhdGVtZW50cwojIHB5bGludDpkaXNhYmxl
PXJhaXNlLW1pc3NpbmctZnJvbSx0b28tbWFueS1saW5lcyx0b28tbWFueS1s
b2NhbHMsaW1wb3J0LWVycm9yCiMgcHlsaW50OmRpc2FibGU9dG9vLWZldy1w
dWJsaWMtbWV0aG9kcyxyZWRlZmluZWQtb3V0ZXItbmFtZSxjb25zaWRlci11
c2luZy13aXRoCiMgcHlsaW50OmRpc2FibGU9YXR0cmlidXRlLWRlZmluZWQt
b3V0c2lkZS1pbml0LHRvby1tYW55LWFyZ3VtZW50cwoKaW1wb3J0IGNvbmZp
Z3BhcnNlcgppbXBvcnQgZXJybm8KaW1wb3J0IGpzb24KaW1wb3J0IG9zCmlt
cG9ydCByZQppbXBvcnQgc3VicHJvY2VzcwppbXBvcnQgc3lzCmZyb20gdHlw
aW5nIGltcG9ydCBDYWxsYWJsZSwgRGljdAppbXBvcnQgZnVuY3Rvb2xzCgoK
Y2xhc3MgVmVyc2lvbmVlckNvbmZpZzoKICAgICIiIkNvbnRhaW5lciBmb3Ig
VmVyc2lvbmVlciBjb25maWd1cmF0aW9uIHBhcmFtZXRlcnMuIiIiCgoKZGVm
IGdldF9yb290KCk6CiAgICAiIiJHZXQgdGhlIHByb2plY3Qgcm9vdCBkaXJl
Y3RvcnkuCgogICAgV2UgcmVxdWlyZSB0aGF0IGFsbCBjb21tYW5kcyBhcmUg
cnVuIGZyb20gdGhlIHByb2plY3Qgcm9vdCwgaS5lLiB0aGUKICAgIGRpcmVj
dG9yeSB0aGF0IGNvbnRhaW5zIHNldHVwLnB5LCBzZXR1cC5jZmcsIGFuZCB2
ZXJzaW9uZWVyLnB5IC4KICAgICIiIgogICAgcm9vdCA9IG9zLnBhdGgucmVh
bHBhdGgob3MucGF0aC5hYnNwYXRoKG9zLmdldGN3ZCgpKSkKICAgIHNldHVw
X3B5ID0gb3MucGF0aC5qb2luKHJvb3QsICJzZXR1cC5weSIpCiAgICB2ZXJz
aW9uZWVyX3B5ID0gb3MucGF0aC5qb2luKHJvb3QsICJ2ZXJzaW9uZWVyLnB5
IikKICAgIGlmIG5vdCAob3MucGF0aC5leGlzdHMoc2V0dXBfcHkpIG9yIG9z
LnBhdGguZXhpc3RzKHZlcnNpb25lZXJfcHkpKToKICAgICAgICAjIGFsbG93
ICdweXRob24gcGF0aC90by9zZXR1cC5weSBDT01NQU5EJwogICAgICAgIHJv
b3QgPSBvcy5wYXRoLmRpcm5hbWUob3MucGF0aC5yZWFscGF0aChvcy5wYXRo
LmFic3BhdGgoc3lzLmFyZ3ZbMF0pKSkKICAgICAgICBzZXR1cF9weSA9IG9z
LnBhdGguam9pbihyb290LCAic2V0dXAucHkiKQogICAgICAgIHZlcnNpb25l
ZXJfcHkgPSBvcy5wYXRoLmpvaW4ocm9vdCwgInZlcnNpb25lZXIucHkiKQog
ICAgaWYgbm90IChvcy5wYXRoLmV4aXN0cyhzZXR1cF9weSkgb3Igb3MucGF0
aC5leGlzdHModmVyc2lvbmVlcl9weSkpOgogICAgICAgIGVyciA9ICgiVmVy
c2lvbmVlciB3YXMgdW5hYmxlIHRvIHJ1biB0aGUgcHJvamVjdCByb290IGRp
cmVjdG9yeS4gIgogICAgICAgICAgICAgICAiVmVyc2lvbmVlciByZXF1aXJl
cyBzZXR1cC5weSB0byBiZSBleGVjdXRlZCBmcm9tICIKICAgICAgICAgICAg
ICAgIml0cyBpbW1lZGlhdGUgZGlyZWN0b3J5IChsaWtlICdweXRob24gc2V0
dXAucHkgQ09NTUFORCcpLCAiCiAgICAgICAgICAgICAgICJvciBpbiBhIHdh
eSB0aGF0IGxldHMgaXQgdXNlIHN5cy5hcmd2WzBdIHRvIGZpbmQgdGhlIHJv
b3QgIgogICAgICAgICAgICAgICAiKGxpa2UgJ3B5dGhvbiBwYXRoL3RvL3Nl
dHVwLnB5IENPTU1BTkQnKS4iKQogICAgICAgIHJhaXNlIFZlcnNpb25lZXJC
YWRSb290RXJyb3IoZXJyKQogICAgdHJ5OgogICAgICAgICMgQ2VydGFpbiBy
dW50aW1lIHdvcmtmbG93cyAoc2V0dXAucHkgaW5zdGFsbC9kZXZlbG9wIGlu
IGEgc2V0dXB0b29scwogICAgICAgICMgdHJlZSkgZXhlY3V0ZSBhbGwgZGVw
ZW5kZW5jaWVzIGluIGEgc2luZ2xlIHB5dGhvbiBwcm9jZXNzLCBzbwogICAg
ICAgICMgInZlcnNpb25lZXIiIG1heSBiZSBpbXBvcnRlZCBtdWx0aXBsZSB0
aW1lcywgYW5kIHB5dGhvbidzIHNoYXJlZAogICAgICAgICMgbW9kdWxlLWlt
cG9ydCB0YWJsZSB3aWxsIGNhY2hlIHRoZSBmaXJzdCBvbmUuIFNvIHdlIGNh
bid0IHVzZQogICAgICAgICMgb3MucGF0aC5kaXJuYW1lKF9fZmlsZV9fKSwg
YXMgdGhhdCB3aWxsIGZpbmQgd2hpY2hldmVyCiAgICAgICAgIyB2ZXJzaW9u
ZWVyLnB5IHdhcyBmaXJzdCBpbXBvcnRlZCwgZXZlbiBpbiBsYXRlciBwcm9q
ZWN0cy4KICAgICAgICBteV9wYXRoID0gb3MucGF0aC5yZWFscGF0aChvcy5w
YXRoLmFic3BhdGgoX19maWxlX18pKQogICAgICAgIG1lX2RpciA9IG9zLnBh
dGgubm9ybWNhc2Uob3MucGF0aC5zcGxpdGV4dChteV9wYXRoKVswXSkKICAg
ICAgICB2c3JfZGlyID0gb3MucGF0aC5ub3JtY2FzZShvcy5wYXRoLnNwbGl0
ZXh0KHZlcnNpb25lZXJfcHkpWzBdKQogICAgICAgIGlmIG1lX2RpciAhPSB2
c3JfZGlyIGFuZCAiVkVSU0lPTkVFUl9QRVA1MTgiIG5vdCBpbiBnbG9iYWxz
KCk6CiAgICAgICAgICAgIHByaW50KCJXYXJuaW5nOiBidWlsZCBpbiAlcyBp
cyB1c2luZyB2ZXJzaW9uZWVyLnB5IGZyb20gJXMiCiAgICAgICAgICAgICAg
ICAgICUgKG9zLnBhdGguZGlybmFtZShteV9wYXRoKSwgdmVyc2lvbmVlcl9w
eSkpCiAgICBleGNlcHQgTmFtZUVycm9yOgogICAgICAgIHBhc3MKICAgIHJl
dHVybiByb290CgoKZGVmIGdldF9jb25maWdfZnJvbV9yb290KHJvb3QpOgog
ICAgIiIiUmVhZCB0aGUgcHJvamVjdCBzZXR1cC5jZmcgZmlsZSB0byBkZXRl
cm1pbmUgVmVyc2lvbmVlciBjb25maWcuIiIiCiAgICAjIFRoaXMgbWlnaHQg
cmFpc2UgT1NFcnJvciAoaWYgc2V0dXAuY2ZnIGlzIG1pc3NpbmcpLCBvcgog
ICAgIyBjb25maWdwYXJzZXIuTm9TZWN0aW9uRXJyb3IgKGlmIGl0IGxhY2tz
IGEgW3ZlcnNpb25lZXJdIHNlY3Rpb24pLCBvcgogICAgIyBjb25maWdwYXJz
ZXIuTm9PcHRpb25FcnJvciAoaWYgaXQgbGFja3MgIlZDUz0iKS4gU2VlIHRo
ZSBkb2NzdHJpbmcgYXQKICAgICMgdGhlIHRvcCBvZiB2ZXJzaW9uZWVyLnB5
IGZvciBpbnN0cnVjdGlvbnMgb24gd3JpdGluZyB5b3VyIHNldHVwLmNmZyAu
CiAgICBzZXR1cF9jZmcgPSBvcy5wYXRoLmpvaW4ocm9vdCwgInNldHVwLmNm
ZyIpCiAgICBwYXJzZXIgPSBjb25maWdwYXJzZXIuQ29uZmlnUGFyc2VyKCkK
ICAgIHdpdGggb3BlbihzZXR1cF9jZmcsICJyIikgYXMgY2ZnX2ZpbGU6CiAg
ICAgICAgcGFyc2VyLnJlYWRfZmlsZShjZmdfZmlsZSkKICAgIFZDUyA9IHBh
cnNlci5nZXQoInZlcnNpb25lZXIiLCAiVkNTIikgICMgbWFuZGF0b3J5Cgog
ICAgIyBEaWN0LWxpa2UgaW50ZXJmYWNlIGZvciBub24tbWFuZGF0b3J5IGVu
dHJpZXMKICAgIHNlY3Rpb24gPSBwYXJzZXJbInZlcnNpb25lZXIiXQoKICAg
IGNmZyA9IFZlcnNpb25lZXJDb25maWcoKQogICAgY2ZnLlZDUyA9IFZDUwog
ICAgY2ZnLnN0eWxlID0gc2VjdGlvbi5nZXQoInN0eWxlIiwgIiIpCiAgICBj
ZmcudmVyc2lvbmZpbGVfc291cmNlID0gc2VjdGlvbi5nZXQoInZlcnNpb25m
aWxlX3NvdXJjZSIpCiAgICBjZmcudmVyc2lvbmZpbGVfYnVpbGQgPSBzZWN0
aW9uLmdldCgidmVyc2lvbmZpbGVfYnVpbGQiKQogICAgY2ZnLnRhZ19wcmVm
aXggPSBzZWN0aW9uLmdldCgidGFnX3ByZWZpeCIpCiAgICBpZiBjZmcudGFn
X3ByZWZpeCBpbiAoIicnIiwgJyIiJywgTm9uZSk6CiAgICAgICAgY2ZnLnRh
Z19wcmVmaXggPSAiIgogICAgY2ZnLnBhcmVudGRpcl9wcmVmaXggPSBzZWN0
aW9uLmdldCgicGFyZW50ZGlyX3ByZWZpeCIpCiAgICBjZmcudmVyYm9zZSA9
IHNlY3Rpb24uZ2V0KCJ2ZXJib3NlIikKICAgIHJldHVybiBjZmcKCgpjbGFz
cyBOb3RUaGlzTWV0aG9kKEV4Y2VwdGlvbik6CiAgICAiIiJFeGNlcHRpb24g
cmFpc2VkIGlmIGEgbWV0aG9kIGlzIG5vdCB2YWxpZCBmb3IgdGhlIGN1cnJl
bnQgc2NlbmFyaW8uIiIiCgoKIyB0aGVzZSBkaWN0aW9uYXJpZXMgY29udGFp
biBWQ1Mtc3BlY2lmaWMgdG9vbHMKTE9OR19WRVJTSU9OX1BZOiBEaWN0W3N0
ciwgc3RyXSA9IHt9CkhBTkRMRVJTOiBEaWN0W3N0ciwgRGljdFtzdHIsIENh
bGxhYmxlXV0gPSB7fQoKCmRlZiByZWdpc3Rlcl92Y3NfaGFuZGxlcih2Y3Ms
IG1ldGhvZCk6ICAjIGRlY29yYXRvcgogICAgIiIiQ3JlYXRlIGRlY29yYXRv
ciB0byBtYXJrIGEgbWV0aG9kIGFzIHRoZSBoYW5kbGVyIG9mIGEgVkNTLiIi
IgogICAgZGVmIGRlY29yYXRlKGYpOgogICAgICAgICIiIlN0b3JlIGYgaW4g
SEFORExFUlNbdmNzXVttZXRob2RdLiIiIgogICAgICAgIEhBTkRMRVJTLnNl
dGRlZmF1bHQodmNzLCB7fSlbbWV0aG9kXSA9IGYKICAgICAgICByZXR1cm4g
ZgogICAgcmV0dXJuIGRlY29yYXRlCgoKZGVmIHJ1bl9jb21tYW5kKGNvbW1h
bmRzLCBhcmdzLCBjd2Q9Tm9uZSwgdmVyYm9zZT1GYWxzZSwgaGlkZV9zdGRl
cnI9RmFsc2UsCiAgICAgICAgICAgICAgICBlbnY9Tm9uZSk6CiAgICAiIiJD
YWxsIHRoZSBnaXZlbiBjb21tYW5kKHMpLiIiIgogICAgYXNzZXJ0IGlzaW5z
dGFuY2UoY29tbWFuZHMsIGxpc3QpCiAgICBwcm9jZXNzID0gTm9uZQoKICAg
IHBvcGVuX2t3YXJncyA9IHt9CiAgICBpZiBzeXMucGxhdGZvcm0gPT0gIndp
bjMyIjoKICAgICAgICAjIFRoaXMgaGlkZXMgdGhlIGNvbnNvbGUgd2luZG93
IGlmIHB5dGhvbncuZXhlIGlzIHVzZWQKICAgICAgICBzdGFydHVwaW5mbyA9
IHN1YnByb2Nlc3MuU1RBUlRVUElORk8oKQogICAgICAgIHN0YXJ0dXBpbmZv
LmR3RmxhZ3MgfD0gc3VicHJvY2Vzcy5TVEFSVEZfVVNFU0hPV1dJTkRPVwog
ICAgICAgIHBvcGVuX2t3YXJnc1sic3RhcnR1cGluZm8iXSA9IHN0YXJ0dXBp
bmZvCgogICAgZm9yIGNvbW1hbmQgaW4gY29tbWFuZHM6CiAgICAgICAgdHJ5
OgogICAgICAgICAgICBkaXNwY21kID0gc3RyKFtjb21tYW5kXSArIGFyZ3Mp
CiAgICAgICAgICAgICMgcmVtZW1iZXIgc2hlbGw9RmFsc2UsIHNvIHVzZSBn
aXQuY21kIG9uIHdpbmRvd3MsIG5vdCBqdXN0IGdpdAogICAgICAgICAgICBw
cm9jZXNzID0gc3VicHJvY2Vzcy5Qb3BlbihbY29tbWFuZF0gKyBhcmdzLCBj
d2Q9Y3dkLCBlbnY9ZW52LAogICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICBzdGRvdXQ9c3VicHJvY2Vzcy5QSVBFLAogICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICBzdGRlcnI9KHN1YnByb2Nl
c3MuUElQRSBpZiBoaWRlX3N0ZGVycgogICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIGVsc2UgTm9uZSksICoqcG9wZW5f
a3dhcmdzKQogICAgICAgICAgICBicmVhawogICAgICAgIGV4Y2VwdCBPU0Vy
cm9yOgogICAgICAgICAgICBlID0gc3lzLmV4Y19pbmZvKClbMV0KICAgICAg
ICAgICAgaWYgZS5lcnJubyA9PSBlcnJuby5FTk9FTlQ6CiAgICAgICAgICAg
ICAgICBjb250aW51ZQogICAgICAgICAgICBpZiB2ZXJib3NlOgogICAgICAg
ICAgICAgICAgcHJpbnQoInVuYWJsZSB0byBydW4gJXMiICUgZGlzcGNtZCkK
ICAgICAgICAgICAgICAgIHByaW50KGUpCiAgICAgICAgICAgIHJldHVybiBO
b25lLCBOb25lCiAgICBlbHNlOgogICAgICAgIGlmIHZlcmJvc2U6CiAgICAg
ICAgICAgIHByaW50KCJ1bmFibGUgdG8gZmluZCBjb21tYW5kLCB0cmllZCAl
cyIgJSAoY29tbWFuZHMsKSkKICAgICAgICByZXR1cm4gTm9uZSwgTm9uZQog
ICAgc3Rkb3V0ID0gcHJvY2Vzcy5jb21tdW5pY2F0ZSgpWzBdLnN0cmlwKCku
ZGVjb2RlKCkKICAgIGlmIHByb2Nlc3MucmV0dXJuY29kZSAhPSAwOgogICAg
ICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAgIHByaW50KCJ1bmFibGUgdG8g
cnVuICVzIChlcnJvcikiICUgZGlzcGNtZCkKICAgICAgICAgICAgcHJpbnQo
InN0ZG91dCB3YXMgJXMiICUgc3Rkb3V0KQogICAgICAgIHJldHVybiBOb25l
LCBwcm9jZXNzLnJldHVybmNvZGUKICAgIHJldHVybiBzdGRvdXQsIHByb2Nl
c3MucmV0dXJuY29kZQoKCkxPTkdfVkVSU0lPTl9QWVsnZ2l0J10gPSByJycn
CiMgVGhpcyBmaWxlIGhlbHBzIHRvIGNvbXB1dGUgYSB2ZXJzaW9uIG51bWJl
ciBpbiBzb3VyY2UgdHJlZXMgb2J0YWluZWQgZnJvbQojIGdpdC1hcmNoaXZl
IHRhcmJhbGwgKHN1Y2ggYXMgdGhvc2UgcHJvdmlkZWQgYnkgZ2l0aHVicyBk
b3dubG9hZC1mcm9tLXRhZwojIGZlYXR1cmUpLiBEaXN0cmlidXRpb24gdGFy
YmFsbHMgKGJ1aWx0IGJ5IHNldHVwLnB5IHNkaXN0KSBhbmQgYnVpbGQKIyBk
aXJlY3RvcmllcyAocHJvZHVjZWQgYnkgc2V0dXAucHkgYnVpbGQpIHdpbGwg
Y29udGFpbiBhIG11Y2ggc2hvcnRlciBmaWxlCiMgdGhhdCBqdXN0IGNvbnRh
aW5zIHRoZSBjb21wdXRlZCB2ZXJzaW9uIG51bWJlci4KCiMgVGhpcyBmaWxl
IGlzIHJlbGVhc2VkIGludG8gdGhlIHB1YmxpYyBkb21haW4uCiMgR2VuZXJh
dGVkIGJ5IHZlcnNpb25lZXItMC4yNQojIGh0dHBzOi8vZ2l0aHViLmNvbS9w
eXRob24tdmVyc2lvbmVlci9weXRob24tdmVyc2lvbmVlcgoKIiIiR2l0IGlt
cGxlbWVudGF0aW9uIG9mIF92ZXJzaW9uLnB5LiIiIgoKaW1wb3J0IGVycm5v
CmltcG9ydCBvcwppbXBvcnQgcmUKaW1wb3J0IHN1YnByb2Nlc3MKaW1wb3J0
IHN5cwpmcm9tIHR5cGluZyBpbXBvcnQgQ2FsbGFibGUsIERpY3QKaW1wb3J0
IGZ1bmN0b29scwoKCmRlZiBnZXRfa2V5d29yZHMoKToKICAgICIiIkdldCB0
aGUga2V5d29yZHMgbmVlZGVkIHRvIGxvb2sgdXAgdGhlIHZlcnNpb24gaW5m
b3JtYXRpb24uIiIiCiAgICAjIHRoZXNlIHN0cmluZ3Mgd2lsbCBiZSByZXBs
YWNlZCBieSBnaXQgZHVyaW5nIGdpdC1hcmNoaXZlLgogICAgIyBzZXR1cC5w
eS92ZXJzaW9uZWVyLnB5IHdpbGwgZ3JlcCBmb3IgdGhlIHZhcmlhYmxlIG5h
bWVzLCBzbyB0aGV5IG11c3QKICAgICMgZWFjaCBiZSBkZWZpbmVkIG9uIGEg
bGluZSBvZiB0aGVpciBvd24uIF92ZXJzaW9uLnB5IHdpbGwganVzdCBjYWxs
CiAgICAjIGdldF9rZXl3b3JkcygpLgogICAgZ2l0X3JlZm5hbWVzID0gIiUo
RE9MTEFSKXNGb3JtYXQ6JSVkJShET0xMQVIpcyIKICAgIGdpdF9mdWxsID0g
IiUoRE9MTEFSKXNGb3JtYXQ6JSVIJShET0xMQVIpcyIKICAgIGdpdF9kYXRl
ID0gIiUoRE9MTEFSKXNGb3JtYXQ6JSVjaSUoRE9MTEFSKXMiCiAgICBrZXl3
b3JkcyA9IHsicmVmbmFtZXMiOiBnaXRfcmVmbmFtZXMsICJmdWxsIjogZ2l0
X2Z1bGwsICJkYXRlIjogZ2l0X2RhdGV9CiAgICByZXR1cm4ga2V5d29yZHMK
CgpjbGFzcyBWZXJzaW9uZWVyQ29uZmlnOgogICAgIiIiQ29udGFpbmVyIGZv
ciBWZXJzaW9uZWVyIGNvbmZpZ3VyYXRpb24gcGFyYW1ldGVycy4iIiIKCgpk
ZWYgZ2V0X2NvbmZpZygpOgogICAgIiIiQ3JlYXRlLCBwb3B1bGF0ZSBhbmQg
cmV0dXJuIHRoZSBWZXJzaW9uZWVyQ29uZmlnKCkgb2JqZWN0LiIiIgogICAg
IyB0aGVzZSBzdHJpbmdzIGFyZSBmaWxsZWQgaW4gd2hlbiAnc2V0dXAucHkg
dmVyc2lvbmVlcicgY3JlYXRlcwogICAgIyBfdmVyc2lvbi5weQogICAgY2Zn
ID0gVmVyc2lvbmVlckNvbmZpZygpCiAgICBjZmcuVkNTID0gImdpdCIKICAg
IGNmZy5zdHlsZSA9ICIlKFNUWUxFKXMiCiAgICBjZmcudGFnX3ByZWZpeCA9
ICIlKFRBR19QUkVGSVgpcyIKICAgIGNmZy5wYXJlbnRkaXJfcHJlZml4ID0g
IiUoUEFSRU5URElSX1BSRUZJWClzIgogICAgY2ZnLnZlcnNpb25maWxlX3Nv
dXJjZSA9ICIlKFZFUlNJT05GSUxFX1NPVVJDRSlzIgogICAgY2ZnLnZlcmJv
c2UgPSBGYWxzZQogICAgcmV0dXJuIGNmZwoKCmNsYXNzIE5vdFRoaXNNZXRo
b2QoRXhjZXB0aW9uKToKICAgICIiIkV4Y2VwdGlvbiByYWlzZWQgaWYgYSBt
ZXRob2QgaXMgbm90IHZhbGlkIGZvciB0aGUgY3VycmVudCBzY2VuYXJpby4i
IiIKCgpMT05HX1ZFUlNJT05fUFk6IERpY3Rbc3RyLCBzdHJdID0ge30KSEFO
RExFUlM6IERpY3Rbc3RyLCBEaWN0W3N0ciwgQ2FsbGFibGVdXSA9IHt9CgoK
ZGVmIHJlZ2lzdGVyX3Zjc19oYW5kbGVyKHZjcywgbWV0aG9kKTogICMgZGVj
b3JhdG9yCiAgICAiIiJDcmVhdGUgZGVjb3JhdG9yIHRvIG1hcmsgYSBtZXRo
b2QgYXMgdGhlIGhhbmRsZXIgb2YgYSBWQ1MuIiIiCiAgICBkZWYgZGVjb3Jh
dGUoZik6CiAgICAgICAgIiIiU3RvcmUgZiBpbiBIQU5ETEVSU1t2Y3NdW21l
dGhvZF0uIiIiCiAgICAgICAgaWYgdmNzIG5vdCBpbiBIQU5ETEVSUzoKICAg
ICAgICAgICAgSEFORExFUlNbdmNzXSA9IHt9CiAgICAgICAgSEFORExFUlNb
dmNzXVttZXRob2RdID0gZgogICAgICAgIHJldHVybiBmCiAgICByZXR1cm4g
ZGVjb3JhdGUKCgpkZWYgcnVuX2NvbW1hbmQoY29tbWFuZHMsIGFyZ3MsIGN3
ZD1Ob25lLCB2ZXJib3NlPUZhbHNlLCBoaWRlX3N0ZGVycj1GYWxzZSwKICAg
ICAgICAgICAgICAgIGVudj1Ob25lKToKICAgICIiIkNhbGwgdGhlIGdpdmVu
IGNvbW1hbmQocykuIiIiCiAgICBhc3NlcnQgaXNpbnN0YW5jZShjb21tYW5k
cywgbGlzdCkKICAgIHByb2Nlc3MgPSBOb25lCgogICAgcG9wZW5fa3dhcmdz
ID0ge30KICAgIGlmIHN5cy5wbGF0Zm9ybSA9PSAid2luMzIiOgogICAgICAg
ICMgVGhpcyBoaWRlcyB0aGUgY29uc29sZSB3aW5kb3cgaWYgcHl0aG9udy5l
eGUgaXMgdXNlZAogICAgICAgIHN0YXJ0dXBpbmZvID0gc3VicHJvY2Vzcy5T
VEFSVFVQSU5GTygpCiAgICAgICAgc3RhcnR1cGluZm8uZHdGbGFncyB8PSBz
dWJwcm9jZXNzLlNUQVJURl9VU0VTSE9XV0lORE9XCiAgICAgICAgcG9wZW5f
a3dhcmdzWyJzdGFydHVwaW5mbyJdID0gc3RhcnR1cGluZm8KCiAgICBmb3Ig
Y29tbWFuZCBpbiBjb21tYW5kczoKICAgICAgICB0cnk6CiAgICAgICAgICAg
IGRpc3BjbWQgPSBzdHIoW2NvbW1hbmRdICsgYXJncykKICAgICAgICAgICAg
IyByZW1lbWJlciBzaGVsbD1GYWxzZSwgc28gdXNlIGdpdC5jbWQgb24gd2lu
ZG93cywgbm90IGp1c3QgZ2l0CiAgICAgICAgICAgIHByb2Nlc3MgPSBzdWJw
cm9jZXNzLlBvcGVuKFtjb21tYW5kXSArIGFyZ3MsIGN3ZD1jd2QsIGVudj1l
bnYsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIHN0
ZG91dD1zdWJwcm9jZXNzLlBJUEUsCiAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgIHN0ZGVycj0oc3VicHJvY2Vzcy5QSVBFIGlmIGhp
ZGVfc3RkZXJyCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgZWxzZSBOb25lKSwgKipwb3Blbl9rd2FyZ3MpCiAgICAg
ICAgICAgIGJyZWFrCiAgICAgICAgZXhjZXB0IE9TRXJyb3I6CiAgICAgICAg
ICAgIGUgPSBzeXMuZXhjX2luZm8oKVsxXQogICAgICAgICAgICBpZiBlLmVy
cm5vID09IGVycm5vLkVOT0VOVDoKICAgICAgICAgICAgICAgIGNvbnRpbnVl
CiAgICAgICAgICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAgICAgICBwcmlu
dCgidW5hYmxlIHRvIHJ1biAlJXMiICUlIGRpc3BjbWQpCiAgICAgICAgICAg
ICAgICBwcmludChlKQogICAgICAgICAgICByZXR1cm4gTm9uZSwgTm9uZQog
ICAgZWxzZToKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmlu
dCgidW5hYmxlIHRvIGZpbmQgY29tbWFuZCwgdHJpZWQgJSVzIiAlJSAoY29t
bWFuZHMsKSkKICAgICAgICByZXR1cm4gTm9uZSwgTm9uZQogICAgc3Rkb3V0
ID0gcHJvY2Vzcy5jb21tdW5pY2F0ZSgpWzBdLnN0cmlwKCkuZGVjb2RlKCkK
ICAgIGlmIHByb2Nlc3MucmV0dXJuY29kZSAhPSAwOgogICAgICAgIGlmIHZl
cmJvc2U6CiAgICAgICAgICAgIHByaW50KCJ1bmFibGUgdG8gcnVuICUlcyAo
ZXJyb3IpIiAlJSBkaXNwY21kKQogICAgICAgICAgICBwcmludCgic3Rkb3V0
IHdhcyAlJXMiICUlIHN0ZG91dCkKICAgICAgICByZXR1cm4gTm9uZSwgcHJv
Y2Vzcy5yZXR1cm5jb2RlCiAgICByZXR1cm4gc3Rkb3V0LCBwcm9jZXNzLnJl
dHVybmNvZGUKCgpkZWYgdmVyc2lvbnNfZnJvbV9wYXJlbnRkaXIocGFyZW50
ZGlyX3ByZWZpeCwgcm9vdCwgdmVyYm9zZSk6CiAgICAiIiJUcnkgdG8gZGV0
ZXJtaW5lIHRoZSB2ZXJzaW9uIGZyb20gdGhlIHBhcmVudCBkaXJlY3Rvcnkg
bmFtZS4KCiAgICBTb3VyY2UgdGFyYmFsbHMgY29udmVudGlvbmFsbHkgdW5w
YWNrIGludG8gYSBkaXJlY3RvcnkgdGhhdCBpbmNsdWRlcyBib3RoCiAgICB0
aGUgcHJvamVjdCBuYW1lIGFuZCBhIHZlcnNpb24gc3RyaW5nLiBXZSB3aWxs
IGFsc28gc3VwcG9ydCBzZWFyY2hpbmcgdXAKICAgIHR3byBkaXJlY3Rvcnkg
bGV2ZWxzIGZvciBhbiBhcHByb3ByaWF0ZWx5IG5hbWVkIHBhcmVudCBkaXJl
Y3RvcnkKICAgICIiIgogICAgcm9vdGRpcnMgPSBbXQoKICAgIGZvciBfIGlu
IHJhbmdlKDMpOgogICAgICAgIGRpcm5hbWUgPSBvcy5wYXRoLmJhc2VuYW1l
KHJvb3QpCiAgICAgICAgaWYgZGlybmFtZS5zdGFydHN3aXRoKHBhcmVudGRp
cl9wcmVmaXgpOgogICAgICAgICAgICByZXR1cm4geyJ2ZXJzaW9uIjogZGly
bmFtZVtsZW4ocGFyZW50ZGlyX3ByZWZpeCk6XSwKICAgICAgICAgICAgICAg
ICAgICAiZnVsbC1yZXZpc2lvbmlkIjogTm9uZSwKICAgICAgICAgICAgICAg
ICAgICAiZGlydHkiOiBGYWxzZSwgImVycm9yIjogTm9uZSwgImRhdGUiOiBO
b25lfQogICAgICAgIHJvb3RkaXJzLmFwcGVuZChyb290KQogICAgICAgIHJv
b3QgPSBvcy5wYXRoLmRpcm5hbWUocm9vdCkgICMgdXAgYSBsZXZlbAoKICAg
IGlmIHZlcmJvc2U6CiAgICAgICAgcHJpbnQoIlRyaWVkIGRpcmVjdG9yaWVz
ICUlcyBidXQgbm9uZSBzdGFydGVkIHdpdGggcHJlZml4ICUlcyIgJSUKICAg
ICAgICAgICAgICAoc3RyKHJvb3RkaXJzKSwgcGFyZW50ZGlyX3ByZWZpeCkp
CiAgICByYWlzZSBOb3RUaGlzTWV0aG9kKCJyb290ZGlyIGRvZXNuJ3Qgc3Rh
cnQgd2l0aCBwYXJlbnRkaXJfcHJlZml4IikKCgpAcmVnaXN0ZXJfdmNzX2hh
bmRsZXIoImdpdCIsICJnZXRfa2V5d29yZHMiKQpkZWYgZ2l0X2dldF9rZXl3
b3Jkcyh2ZXJzaW9uZmlsZV9hYnMpOgogICAgIiIiRXh0cmFjdCB2ZXJzaW9u
IGluZm9ybWF0aW9uIGZyb20gdGhlIGdpdmVuIGZpbGUuIiIiCiAgICAjIHRo
ZSBjb2RlIGVtYmVkZGVkIGluIF92ZXJzaW9uLnB5IGNhbiBqdXN0IGZldGNo
IHRoZSB2YWx1ZSBvZiB0aGVzZQogICAgIyBrZXl3b3Jkcy4gV2hlbiB1c2Vk
IGZyb20gc2V0dXAucHksIHdlIGRvbid0IHdhbnQgdG8gaW1wb3J0IF92ZXJz
aW9uLnB5LAogICAgIyBzbyB3ZSBkbyBpdCB3aXRoIGEgcmVnZXhwIGluc3Rl
YWQuIFRoaXMgZnVuY3Rpb24gaXMgbm90IHVzZWQgZnJvbQogICAgIyBfdmVy
c2lvbi5weS4KICAgIGtleXdvcmRzID0ge30KICAgIHRyeToKICAgICAgICB3
aXRoIG9wZW4odmVyc2lvbmZpbGVfYWJzLCAiciIpIGFzIGZvYmo6CiAgICAg
ICAgICAgIGZvciBsaW5lIGluIGZvYmo6CiAgICAgICAgICAgICAgICBpZiBs
aW5lLnN0cmlwKCkuc3RhcnRzd2l0aCgiZ2l0X3JlZm5hbWVzID0iKToKICAg
ICAgICAgICAgICAgICAgICBtbyA9IHJlLnNlYXJjaChyJz1ccyoiKC4qKSIn
LCBsaW5lKQogICAgICAgICAgICAgICAgICAgIGlmIG1vOgogICAgICAgICAg
ICAgICAgICAgICAgICBrZXl3b3Jkc1sicmVmbmFtZXMiXSA9IG1vLmdyb3Vw
KDEpCiAgICAgICAgICAgICAgICBpZiBsaW5lLnN0cmlwKCkuc3RhcnRzd2l0
aCgiZ2l0X2Z1bGwgPSIpOgogICAgICAgICAgICAgICAgICAgIG1vID0gcmUu
c2VhcmNoKHInPVxzKiIoLiopIicsIGxpbmUpCiAgICAgICAgICAgICAgICAg
ICAgaWYgbW86CiAgICAgICAgICAgICAgICAgICAgICAgIGtleXdvcmRzWyJm
dWxsIl0gPSBtby5ncm91cCgxKQogICAgICAgICAgICAgICAgaWYgbGluZS5z
dHJpcCgpLnN0YXJ0c3dpdGgoImdpdF9kYXRlID0iKToKICAgICAgICAgICAg
ICAgICAgICBtbyA9IHJlLnNlYXJjaChyJz1ccyoiKC4qKSInLCBsaW5lKQog
ICAgICAgICAgICAgICAgICAgIGlmIG1vOgogICAgICAgICAgICAgICAgICAg
ICAgICBrZXl3b3Jkc1siZGF0ZSJdID0gbW8uZ3JvdXAoMSkKICAgIGV4Y2Vw
dCBPU0Vycm9yOgogICAgICAgIHBhc3MKICAgIHJldHVybiBrZXl3b3JkcwoK
CkByZWdpc3Rlcl92Y3NfaGFuZGxlcigiZ2l0IiwgImtleXdvcmRzIikKZGVm
IGdpdF92ZXJzaW9uc19mcm9tX2tleXdvcmRzKGtleXdvcmRzLCB0YWdfcHJl
Zml4LCB2ZXJib3NlKToKICAgICIiIkdldCB2ZXJzaW9uIGluZm9ybWF0aW9u
IGZyb20gZ2l0IGtleXdvcmRzLiIiIgogICAgaWYgInJlZm5hbWVzIiBub3Qg
aW4ga2V5d29yZHM6CiAgICAgICAgcmFpc2UgTm90VGhpc01ldGhvZCgiU2hv
cnQgdmVyc2lvbiBmaWxlIGZvdW5kIikKICAgIGRhdGUgPSBrZXl3b3Jkcy5n
ZXQoImRhdGUiKQogICAgaWYgZGF0ZSBpcyBub3QgTm9uZToKICAgICAgICAj
IFVzZSBvbmx5IHRoZSBsYXN0IGxpbmUuICBQcmV2aW91cyBsaW5lcyBtYXkg
Y29udGFpbiBHUEcgc2lnbmF0dXJlCiAgICAgICAgIyBpbmZvcm1hdGlvbi4K
ICAgICAgICBkYXRlID0gZGF0ZS5zcGxpdGxpbmVzKClbLTFdCgogICAgICAg
ICMgZ2l0LTIuMi4wIGFkZGVkICIlJWNJIiwgd2hpY2ggZXhwYW5kcyB0byBh
biBJU08tODYwMSAtY29tcGxpYW50CiAgICAgICAgIyBkYXRlc3RhbXAuIEhv
d2V2ZXIgd2UgcHJlZmVyICIlJWNpIiAod2hpY2ggZXhwYW5kcyB0byBhbiAi
SVNPLTg2MDEKICAgICAgICAjIC1saWtlIiBzdHJpbmcsIHdoaWNoIHdlIG11
c3QgdGhlbiBlZGl0IHRvIG1ha2UgY29tcGxpYW50KSwgYmVjYXVzZQogICAg
ICAgICMgaXQncyBiZWVuIGFyb3VuZCBzaW5jZSBnaXQtMS41LjMsIGFuZCBp
dCdzIHRvbyBkaWZmaWN1bHQgdG8KICAgICAgICAjIGRpc2NvdmVyIHdoaWNo
IHZlcnNpb24gd2UncmUgdXNpbmcsIG9yIHRvIHdvcmsgYXJvdW5kIHVzaW5n
IGFuCiAgICAgICAgIyBvbGRlciBvbmUuCiAgICAgICAgZGF0ZSA9IGRhdGUu
c3RyaXAoKS5yZXBsYWNlKCIgIiwgIlQiLCAxKS5yZXBsYWNlKCIgIiwgIiIs
IDEpCiAgICByZWZuYW1lcyA9IGtleXdvcmRzWyJyZWZuYW1lcyJdLnN0cmlw
KCkKICAgIGlmIHJlZm5hbWVzLnN0YXJ0c3dpdGgoIiRGb3JtYXQiKToKICAg
ICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgia2V5d29yZHMg
YXJlIHVuZXhwYW5kZWQsIG5vdCB1c2luZyIpCiAgICAgICAgcmFpc2UgTm90
VGhpc01ldGhvZCgidW5leHBhbmRlZCBrZXl3b3Jkcywgbm90IGEgZ2l0LWFy
Y2hpdmUgdGFyYmFsbCIpCiAgICByZWZzID0ge3Iuc3RyaXAoKSBmb3IgciBp
biByZWZuYW1lcy5zdHJpcCgiKCkiKS5zcGxpdCgiLCIpfQogICAgIyBzdGFy
dGluZyBpbiBnaXQtMS44LjMsIHRhZ3MgYXJlIGxpc3RlZCBhcyAidGFnOiBm
b28tMS4wIiBpbnN0ZWFkIG9mCiAgICAjIGp1c3QgImZvby0xLjAiLiBJZiB3
ZSBzZWUgYSAidGFnOiAiIHByZWZpeCwgcHJlZmVyIHRob3NlLgogICAgVEFH
ID0gInRhZzogIgogICAgdGFncyA9IHtyW2xlbihUQUcpOl0gZm9yIHIgaW4g
cmVmcyBpZiByLnN0YXJ0c3dpdGgoVEFHKX0KICAgIGlmIG5vdCB0YWdzOgog
ICAgICAgICMgRWl0aGVyIHdlJ3JlIHVzaW5nIGdpdCA8IDEuOC4zLCBvciB0
aGVyZSByZWFsbHkgYXJlIG5vIHRhZ3MuIFdlIHVzZQogICAgICAgICMgYSBo
ZXVyaXN0aWM6IGFzc3VtZSBhbGwgdmVyc2lvbiB0YWdzIGhhdmUgYSBkaWdp
dC4gVGhlIG9sZCBnaXQgJSVkCiAgICAgICAgIyBleHBhbnNpb24gYmVoYXZl
cyBsaWtlIGdpdCBsb2cgLS1kZWNvcmF0ZT1zaG9ydCBhbmQgc3RyaXBzIG91
dCB0aGUKICAgICAgICAjIHJlZnMvaGVhZHMvIGFuZCByZWZzL3RhZ3MvIHBy
ZWZpeGVzIHRoYXQgd291bGQgbGV0IHVzIGRpc3Rpbmd1aXNoCiAgICAgICAg
IyBiZXR3ZWVuIGJyYW5jaGVzIGFuZCB0YWdzLiBCeSBpZ25vcmluZyByZWZu
YW1lcyB3aXRob3V0IGRpZ2l0cywgd2UKICAgICAgICAjIGZpbHRlciBvdXQg
bWFueSBjb21tb24gYnJhbmNoIG5hbWVzIGxpa2UgInJlbGVhc2UiIGFuZAog
ICAgICAgICMgInN0YWJpbGl6YXRpb24iLCBhcyB3ZWxsIGFzICJIRUFEIiBh
bmQgIm1hc3RlciIuCiAgICAgICAgdGFncyA9IHtyIGZvciByIGluIHJlZnMg
aWYgcmUuc2VhcmNoKHInXGQnLCByKX0KICAgICAgICBpZiB2ZXJib3NlOgog
ICAgICAgICAgICBwcmludCgiZGlzY2FyZGluZyAnJSVzJywgbm8gZGlnaXRz
IiAlJSAiLCIuam9pbihyZWZzIC0gdGFncykpCiAgICBpZiB2ZXJib3NlOgog
ICAgICAgIHByaW50KCJsaWtlbHkgdGFnczogJSVzIiAlJSAiLCIuam9pbihz
b3J0ZWQodGFncykpKQogICAgZm9yIHJlZiBpbiBzb3J0ZWQodGFncyk6CiAg
ICAgICAgIyBzb3J0aW5nIHdpbGwgcHJlZmVyIGUuZy4gIjIuMCIgb3ZlciAi
Mi4wcmMxIgogICAgICAgIGlmIHJlZi5zdGFydHN3aXRoKHRhZ19wcmVmaXgp
OgogICAgICAgICAgICByID0gcmVmW2xlbih0YWdfcHJlZml4KTpdCiAgICAg
ICAgICAgICMgRmlsdGVyIG91dCByZWZzIHRoYXQgZXhhY3RseSBtYXRjaCBw
cmVmaXggb3IgdGhhdCBkb24ndCBzdGFydAogICAgICAgICAgICAjIHdpdGgg
YSBudW1iZXIgb25jZSB0aGUgcHJlZml4IGlzIHN0cmlwcGVkIChtb3N0bHkg
YSBjb25jZXJuCiAgICAgICAgICAgICMgd2hlbiBwcmVmaXggaXMgJycpCiAg
ICAgICAgICAgIGlmIG5vdCByZS5tYXRjaChyJ1xkJywgcik6CiAgICAgICAg
ICAgICAgICBjb250aW51ZQogICAgICAgICAgICBpZiB2ZXJib3NlOgogICAg
ICAgICAgICAgICAgcHJpbnQoInBpY2tpbmcgJSVzIiAlJSByKQogICAgICAg
ICAgICByZXR1cm4geyJ2ZXJzaW9uIjogciwKICAgICAgICAgICAgICAgICAg
ICAiZnVsbC1yZXZpc2lvbmlkIjoga2V5d29yZHNbImZ1bGwiXS5zdHJpcCgp
LAogICAgICAgICAgICAgICAgICAgICJkaXJ0eSI6IEZhbHNlLCAiZXJyb3Ii
OiBOb25lLAogICAgICAgICAgICAgICAgICAgICJkYXRlIjogZGF0ZX0KICAg
ICMgbm8gc3VpdGFibGUgdGFncywgc28gdmVyc2lvbiBpcyAiMCt1bmtub3du
IiwgYnV0IGZ1bGwgaGV4IGlzIHN0aWxsIHRoZXJlCiAgICBpZiB2ZXJib3Nl
OgogICAgICAgIHByaW50KCJubyBzdWl0YWJsZSB0YWdzLCB1c2luZyB1bmtu
b3duICsgZnVsbCByZXZpc2lvbiBpZCIpCiAgICByZXR1cm4geyJ2ZXJzaW9u
IjogIjArdW5rbm93biIsCiAgICAgICAgICAgICJmdWxsLXJldmlzaW9uaWQi
OiBrZXl3b3Jkc1siZnVsbCJdLnN0cmlwKCksCiAgICAgICAgICAgICJkaXJ0
eSI6IEZhbHNlLCAiZXJyb3IiOiAibm8gc3VpdGFibGUgdGFncyIsICJkYXRl
IjogTm9uZX0KCgpAcmVnaXN0ZXJfdmNzX2hhbmRsZXIoImdpdCIsICJwaWVj
ZXNfZnJvbV92Y3MiKQpkZWYgZ2l0X3BpZWNlc19mcm9tX3Zjcyh0YWdfcHJl
Zml4LCByb290LCB2ZXJib3NlLCBydW5uZXI9cnVuX2NvbW1hbmQpOgogICAg
IiIiR2V0IHZlcnNpb24gZnJvbSAnZ2l0IGRlc2NyaWJlJyBpbiB0aGUgcm9v
dCBvZiB0aGUgc291cmNlIHRyZWUuCgogICAgVGhpcyBvbmx5IGdldHMgY2Fs
bGVkIGlmIHRoZSBnaXQtYXJjaGl2ZSAnc3Vic3QnIGtleXdvcmRzIHdlcmUg
Km5vdCoKICAgIGV4cGFuZGVkLCBhbmQgX3ZlcnNpb24ucHkgaGFzbid0IGFs
cmVhZHkgYmVlbiByZXdyaXR0ZW4gd2l0aCBhIHNob3J0CiAgICB2ZXJzaW9u
IHN0cmluZywgbWVhbmluZyB3ZSdyZSBpbnNpZGUgYSBjaGVja2VkIG91dCBz
b3VyY2UgdHJlZS4KICAgICIiIgogICAgR0lUUyA9IFsiZ2l0Il0KICAgIGlm
IHN5cy5wbGF0Zm9ybSA9PSAid2luMzIiOgogICAgICAgIEdJVFMgPSBbImdp
dC5jbWQiLCAiZ2l0LmV4ZSJdCgogICAgIyBHSVRfRElSIGNhbiBpbnRlcmZl
cmUgd2l0aCBjb3JyZWN0IG9wZXJhdGlvbiBvZiBWZXJzaW9uZWVyLgogICAg
IyBJdCBtYXkgYmUgaW50ZW5kZWQgdG8gYmUgcGFzc2VkIHRvIHRoZSBWZXJz
aW9uZWVyLXZlcnNpb25lZCBwcm9qZWN0LAogICAgIyBidXQgdGhhdCBzaG91
bGQgbm90IGNoYW5nZSB3aGVyZSB3ZSBnZXQgb3VyIHZlcnNpb24gZnJvbS4K
ICAgIGVudiA9IG9zLmVudmlyb24uY29weSgpCiAgICBlbnYucG9wKCJHSVRf
RElSIiwgTm9uZSkKICAgIHJ1bm5lciA9IGZ1bmN0b29scy5wYXJ0aWFsKHJ1
bm5lciwgZW52PWVudikKCiAgICBfLCByYyA9IHJ1bm5lcihHSVRTLCBbInJl
di1wYXJzZSIsICItLWdpdC1kaXIiXSwgY3dkPXJvb3QsCiAgICAgICAgICAg
ICAgICAgICBoaWRlX3N0ZGVycj1ub3QgdmVyYm9zZSkKICAgIGlmIHJjICE9
IDA6CiAgICAgICAgaWYgdmVyYm9zZToKICAgICAgICAgICAgcHJpbnQoIkRp
cmVjdG9yeSAlJXMgbm90IHVuZGVyIGdpdCBjb250cm9sIiAlJSByb290KQog
ICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoIidnaXQgcmV2LXBhcnNlIC0t
Z2l0LWRpcicgcmV0dXJuZWQgZXJyb3IiKQoKICAgICMgaWYgdGhlcmUgaXMg
YSB0YWcgbWF0Y2hpbmcgdGFnX3ByZWZpeCwgdGhpcyB5aWVsZHMgVEFHLU5V
TS1nSEVYWy1kaXJ0eV0KICAgICMgaWYgdGhlcmUgaXNuJ3Qgb25lLCB0aGlz
IHlpZWxkcyBIRVhbLWRpcnR5XSAobm8gTlVNKQogICAgZGVzY3JpYmVfb3V0
LCByYyA9IHJ1bm5lcihHSVRTLCBbCiAgICAgICAgImRlc2NyaWJlIiwgIi0t
dGFncyIsICItLWRpcnR5IiwgIi0tYWx3YXlzIiwgIi0tbG9uZyIsCiAgICAg
ICAgIi0tbWF0Y2giLCBmInt0YWdfcHJlZml4fVtbOmRpZ2l0Ol1dKiIKICAg
IF0sIGN3ZD1yb290KQogICAgIyAtLWxvbmcgd2FzIGFkZGVkIGluIGdpdC0x
LjUuNQogICAgaWYgZGVzY3JpYmVfb3V0IGlzIE5vbmU6CiAgICAgICAgcmFp
c2UgTm90VGhpc01ldGhvZCgiJ2dpdCBkZXNjcmliZScgZmFpbGVkIikKICAg
IGRlc2NyaWJlX291dCA9IGRlc2NyaWJlX291dC5zdHJpcCgpCiAgICBmdWxs
X291dCwgcmMgPSBydW5uZXIoR0lUUywgWyJyZXYtcGFyc2UiLCAiSEVBRCJd
LCBjd2Q9cm9vdCkKICAgIGlmIGZ1bGxfb3V0IGlzIE5vbmU6CiAgICAgICAg
cmFpc2UgTm90VGhpc01ldGhvZCgiJ2dpdCByZXYtcGFyc2UnIGZhaWxlZCIp
CiAgICBmdWxsX291dCA9IGZ1bGxfb3V0LnN0cmlwKCkKCiAgICBwaWVjZXMg
PSB7fQogICAgcGllY2VzWyJsb25nIl0gPSBmdWxsX291dAogICAgcGllY2Vz
WyJzaG9ydCJdID0gZnVsbF9vdXRbOjddICAjIG1heWJlIGltcHJvdmVkIGxh
dGVyCiAgICBwaWVjZXNbImVycm9yIl0gPSBOb25lCgogICAgYnJhbmNoX25h
bWUsIHJjID0gcnVubmVyKEdJVFMsIFsicmV2LXBhcnNlIiwgIi0tYWJicmV2
LXJlZiIsICJIRUFEIl0sCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
Y3dkPXJvb3QpCiAgICAjIC0tYWJicmV2LXJlZiB3YXMgYWRkZWQgaW4gZ2l0
LTEuNi4zCiAgICBpZiByYyAhPSAwIG9yIGJyYW5jaF9uYW1lIGlzIE5vbmU6
CiAgICAgICAgcmFpc2UgTm90VGhpc01ldGhvZCgiJ2dpdCByZXYtcGFyc2Ug
LS1hYmJyZXYtcmVmJyByZXR1cm5lZCBlcnJvciIpCiAgICBicmFuY2hfbmFt
ZSA9IGJyYW5jaF9uYW1lLnN0cmlwKCkKCiAgICBpZiBicmFuY2hfbmFtZSA9
PSAiSEVBRCI6CiAgICAgICAgIyBJZiB3ZSBhcmVuJ3QgZXhhY3RseSBvbiBh
IGJyYW5jaCwgcGljayBhIGJyYW5jaCB3aGljaCByZXByZXNlbnRzCiAgICAg
ICAgIyB0aGUgY3VycmVudCBjb21taXQuIElmIGFsbCBlbHNlIGZhaWxzLCB3
ZSBhcmUgb24gYSBicmFuY2hsZXNzCiAgICAgICAgIyBjb21taXQuCiAgICAg
ICAgYnJhbmNoZXMsIHJjID0gcnVubmVyKEdJVFMsIFsiYnJhbmNoIiwgIi0t
Y29udGFpbnMiXSwgY3dkPXJvb3QpCiAgICAgICAgIyAtLWNvbnRhaW5zIHdh
cyBhZGRlZCBpbiBnaXQtMS41LjQKICAgICAgICBpZiByYyAhPSAwIG9yIGJy
YW5jaGVzIGlzIE5vbmU6CiAgICAgICAgICAgIHJhaXNlIE5vdFRoaXNNZXRo
b2QoIidnaXQgYnJhbmNoIC0tY29udGFpbnMnIHJldHVybmVkIGVycm9yIikK
ICAgICAgICBicmFuY2hlcyA9IGJyYW5jaGVzLnNwbGl0KCJcbiIpCgogICAg
ICAgICMgUmVtb3ZlIHRoZSBmaXJzdCBsaW5lIGlmIHdlJ3JlIHJ1bm5pbmcg
ZGV0YWNoZWQKICAgICAgICBpZiAiKCIgaW4gYnJhbmNoZXNbMF06CiAgICAg
ICAgICAgIGJyYW5jaGVzLnBvcCgwKQoKICAgICAgICAjIFN0cmlwIG9mZiB0
aGUgbGVhZGluZyAiKiAiIGZyb20gdGhlIGxpc3Qgb2YgYnJhbmNoZXMuCiAg
ICAgICAgYnJhbmNoZXMgPSBbYnJhbmNoWzI6XSBmb3IgYnJhbmNoIGluIGJy
YW5jaGVzXQogICAgICAgIGlmICJtYXN0ZXIiIGluIGJyYW5jaGVzOgogICAg
ICAgICAgICBicmFuY2hfbmFtZSA9ICJtYXN0ZXIiCiAgICAgICAgZWxpZiBu
b3QgYnJhbmNoZXM6CiAgICAgICAgICAgIGJyYW5jaF9uYW1lID0gTm9uZQog
ICAgICAgIGVsc2U6CiAgICAgICAgICAgICMgUGljayB0aGUgZmlyc3QgYnJh
bmNoIHRoYXQgaXMgcmV0dXJuZWQuIEdvb2Qgb3IgYmFkLgogICAgICAgICAg
ICBicmFuY2hfbmFtZSA9IGJyYW5jaGVzWzBdCgogICAgcGllY2VzWyJicmFu
Y2giXSA9IGJyYW5jaF9uYW1lCgogICAgIyBwYXJzZSBkZXNjcmliZV9vdXQu
IEl0IHdpbGwgYmUgbGlrZSBUQUctTlVNLWdIRVhbLWRpcnR5XSBvciBIRVhb
LWRpcnR5XQogICAgIyBUQUcgbWlnaHQgaGF2ZSBoeXBoZW5zLgogICAgZ2l0
X2Rlc2NyaWJlID0gZGVzY3JpYmVfb3V0CgogICAgIyBsb29rIGZvciAtZGly
dHkgc3VmZml4CiAgICBkaXJ0eSA9IGdpdF9kZXNjcmliZS5lbmRzd2l0aCgi
LWRpcnR5IikKICAgIHBpZWNlc1siZGlydHkiXSA9IGRpcnR5CiAgICBpZiBk
aXJ0eToKICAgICAgICBnaXRfZGVzY3JpYmUgPSBnaXRfZGVzY3JpYmVbOmdp
dF9kZXNjcmliZS5yaW5kZXgoIi1kaXJ0eSIpXQoKICAgICMgbm93IHdlIGhh
dmUgVEFHLU5VTS1nSEVYIG9yIEhFWAoKICAgIGlmICItIiBpbiBnaXRfZGVz
Y3JpYmU6CiAgICAgICAgIyBUQUctTlVNLWdIRVgKICAgICAgICBtbyA9IHJl
LnNlYXJjaChyJ14oLispLShcZCspLWcoWzAtOWEtZl0rKSQnLCBnaXRfZGVz
Y3JpYmUpCiAgICAgICAgaWYgbm90IG1vOgogICAgICAgICAgICAjIHVucGFy
c2FibGUuIE1heWJlIGdpdC1kZXNjcmliZSBpcyBtaXNiZWhhdmluZz8KICAg
ICAgICAgICAgcGllY2VzWyJlcnJvciJdID0gKCJ1bmFibGUgdG8gcGFyc2Ug
Z2l0LWRlc2NyaWJlIG91dHB1dDogJyUlcyciCiAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAlJSBkZXNjcmliZV9vdXQpCiAgICAgICAgICAgIHJl
dHVybiBwaWVjZXMKCiAgICAgICAgIyB0YWcKICAgICAgICBmdWxsX3RhZyA9
IG1vLmdyb3VwKDEpCiAgICAgICAgaWYgbm90IGZ1bGxfdGFnLnN0YXJ0c3dp
dGgodGFnX3ByZWZpeCk6CiAgICAgICAgICAgIGlmIHZlcmJvc2U6CiAgICAg
ICAgICAgICAgICBmbXQgPSAidGFnICclJXMnIGRvZXNuJ3Qgc3RhcnQgd2l0
aCBwcmVmaXggJyUlcyciCiAgICAgICAgICAgICAgICBwcmludChmbXQgJSUg
KGZ1bGxfdGFnLCB0YWdfcHJlZml4KSkKICAgICAgICAgICAgcGllY2VzWyJl
cnJvciJdID0gKCJ0YWcgJyUlcycgZG9lc24ndCBzdGFydCB3aXRoIHByZWZp
eCAnJSVzJyIKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICUlIChm
dWxsX3RhZywgdGFnX3ByZWZpeCkpCiAgICAgICAgICAgIHJldHVybiBwaWVj
ZXMKICAgICAgICBwaWVjZXNbImNsb3Nlc3QtdGFnIl0gPSBmdWxsX3RhZ1ts
ZW4odGFnX3ByZWZpeCk6XQoKICAgICAgICAjIGRpc3RhbmNlOiBudW1iZXIg
b2YgY29tbWl0cyBzaW5jZSB0YWcKICAgICAgICBwaWVjZXNbImRpc3RhbmNl
Il0gPSBpbnQobW8uZ3JvdXAoMikpCgogICAgICAgICMgY29tbWl0OiBzaG9y
dCBoZXggcmV2aXNpb24gSUQKICAgICAgICBwaWVjZXNbInNob3J0Il0gPSBt
by5ncm91cCgzKQoKICAgIGVsc2U6CiAgICAgICAgIyBIRVg6IG5vIHRhZ3MK
ICAgICAgICBwaWVjZXNbImNsb3Nlc3QtdGFnIl0gPSBOb25lCiAgICAgICAg
b3V0LCByYyA9IHJ1bm5lcihHSVRTLCBbInJldi1saXN0IiwgIkhFQUQiLCAi
LS1sZWZ0LXJpZ2h0Il0sIGN3ZD1yb290KQogICAgICAgIHBpZWNlc1siZGlz
dGFuY2UiXSA9IGxlbihvdXQuc3BsaXQoKSkgICMgdG90YWwgbnVtYmVyIG9m
IGNvbW1pdHMKCiAgICAjIGNvbW1pdCBkYXRlOiBzZWUgSVNPLTg2MDEgY29t
bWVudCBpbiBnaXRfdmVyc2lvbnNfZnJvbV9rZXl3b3JkcygpCiAgICBkYXRl
ID0gcnVubmVyKEdJVFMsIFsic2hvdyIsICItcyIsICItLWZvcm1hdD0lJWNp
IiwgIkhFQUQiXSwgY3dkPXJvb3QpWzBdLnN0cmlwKCkKICAgICMgVXNlIG9u
bHkgdGhlIGxhc3QgbGluZS4gIFByZXZpb3VzIGxpbmVzIG1heSBjb250YWlu
IEdQRyBzaWduYXR1cmUKICAgICMgaW5mb3JtYXRpb24uCiAgICBkYXRlID0g
ZGF0ZS5zcGxpdGxpbmVzKClbLTFdCiAgICBwaWVjZXNbImRhdGUiXSA9IGRh
dGUuc3RyaXAoKS5yZXBsYWNlKCIgIiwgIlQiLCAxKS5yZXBsYWNlKCIgIiwg
IiIsIDEpCgogICAgcmV0dXJuIHBpZWNlcwoKCmRlZiBwbHVzX29yX2RvdChw
aWVjZXMpOgogICAgIiIiUmV0dXJuIGEgKyBpZiB3ZSBkb24ndCBhbHJlYWR5
IGhhdmUgb25lLCBlbHNlIHJldHVybiBhIC4iIiIKICAgIGlmICIrIiBpbiBw
aWVjZXMuZ2V0KCJjbG9zZXN0LXRhZyIsICIiKToKICAgICAgICByZXR1cm4g
Ii4iCiAgICByZXR1cm4gIisiCgoKZGVmIHJlbmRlcl9wZXA0NDAocGllY2Vz
KToKICAgICIiIkJ1aWxkIHVwIHZlcnNpb24gc3RyaW5nLCB3aXRoIHBvc3Qt
cmVsZWFzZSAibG9jYWwgdmVyc2lvbiBpZGVudGlmaWVyIi4KCiAgICBPdXIg
Z29hbDogVEFHWytESVNUQU5DRS5nSEVYWy5kaXJ0eV1dIC4gTm90ZSB0aGF0
IGlmIHlvdQogICAgZ2V0IGEgdGFnZ2VkIGJ1aWxkIGFuZCB0aGVuIGRpcnR5
IGl0LCB5b3UnbGwgZ2V0IFRBRyswLmdIRVguZGlydHkKCiAgICBFeGNlcHRp
b25zOgogICAgMTogbm8gdGFncy4gZ2l0X2Rlc2NyaWJlIHdhcyBqdXN0IEhF
WC4gMCt1bnRhZ2dlZC5ESVNUQU5DRS5nSEVYWy5kaXJ0eV0KICAgICIiIgog
ICAgaWYgcGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVk
ID0gcGllY2VzWyJjbG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJk
aXN0YW5jZSJdIG9yIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVu
ZGVyZWQgKz0gcGx1c19vcl9kb3QocGllY2VzKQogICAgICAgICAgICByZW5k
ZXJlZCArPSAiJSVkLmclJXMiICUlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBp
ZWNlc1sic2hvcnQiXSkKICAgICAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJd
OgogICAgICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kaXJ0eSIKICAgIGVs
c2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9
ICIwK3VudGFnZ2VkLiUlZC5nJSVzIiAlJSAocGllY2VzWyJkaXN0YW5jZSJd
LAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBw
aWVjZXNbInNob3J0Il0pCiAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgog
ICAgICAgICAgICByZW5kZXJlZCArPSAiLmRpcnR5IgogICAgcmV0dXJuIHJl
bmRlcmVkCgoKZGVmIHJlbmRlcl9wZXA0NDBfYnJhbmNoKHBpZWNlcyk6CiAg
ICAiIiJUQUdbWy5kZXYwXStESVNUQU5DRS5nSEVYWy5kaXJ0eV1dIC4KCiAg
ICBUaGUgIi5kZXYwIiBtZWFucyBub3QgbWFzdGVyIGJyYW5jaC4gTm90ZSB0
aGF0IC5kZXYwIHNvcnRzIGJhY2t3YXJkcwogICAgKGEgZmVhdHVyZSBicmFu
Y2ggd2lsbCBhcHBlYXIgIm9sZGVyIiB0aGFuIHRoZSBtYXN0ZXIgYnJhbmNo
KS4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gMFsuZGV2MF0r
dW50YWdnZWQuRElTVEFOQ0UuZ0hFWFsuZGlydHldCiAgICAiIiIKICAgIGlm
IHBpZWNlc1siY2xvc2VzdC10YWciXToKICAgICAgICByZW5kZXJlZCA9IHBp
ZWNlc1siY2xvc2VzdC10YWciXQogICAgICAgIGlmIHBpZWNlc1siZGlzdGFu
Y2UiXSBvciBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgIGlmIHBpZWNl
c1siYnJhbmNoIl0gIT0gIm1hc3RlciI6CiAgICAgICAgICAgICAgICByZW5k
ZXJlZCArPSAiLmRldjAiCiAgICAgICAgICAgIHJlbmRlcmVkICs9IHBsdXNf
b3JfZG90KHBpZWNlcykKICAgICAgICAgICAgcmVuZGVyZWQgKz0gIiUlZC5n
JSVzIiAlJSAocGllY2VzWyJkaXN0YW5jZSJdLCBwaWVjZXNbInNob3J0Il0p
CiAgICAgICAgICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAg
ICAgIHJlbmRlcmVkICs9ICIuZGlydHkiCiAgICBlbHNlOgogICAgICAgICMg
ZXhjZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMCIKICAgICAgICBp
ZiBwaWVjZXNbImJyYW5jaCJdICE9ICJtYXN0ZXIiOgogICAgICAgICAgICBy
ZW5kZXJlZCArPSAiLmRldjAiCiAgICAgICAgcmVuZGVyZWQgKz0gIit1bnRh
Z2dlZC4lJWQuZyUlcyIgJSUgKHBpZWNlc1siZGlzdGFuY2UiXSwKICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgcGllY2VzWyJz
aG9ydCJdKQogICAgICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAg
ICAgcmVuZGVyZWQgKz0gIi5kaXJ0eSIKICAgIHJldHVybiByZW5kZXJlZAoK
CmRlZiBwZXA0NDBfc3BsaXRfcG9zdCh2ZXIpOgogICAgIiIiU3BsaXQgcGVw
NDQwIHZlcnNpb24gc3RyaW5nIGF0IHRoZSBwb3N0LXJlbGVhc2Ugc2VnbWVu
dC4KCiAgICBSZXR1cm5zIHRoZSByZWxlYXNlIHNlZ21lbnRzIGJlZm9yZSB0
aGUgcG9zdC1yZWxlYXNlIGFuZCB0aGUKICAgIHBvc3QtcmVsZWFzZSB2ZXJz
aW9uIG51bWJlciAob3IgLTEgaWYgbm8gcG9zdC1yZWxlYXNlIHNlZ21lbnQg
aXMgcHJlc2VudCkuCiAgICAiIiIKICAgIHZjID0gc3RyLnNwbGl0KHZlciwg
Ii5wb3N0IikKICAgIHJldHVybiB2Y1swXSwgaW50KHZjWzFdIG9yIDApIGlm
IGxlbih2YykgPT0gMiBlbHNlIE5vbmUKCgpkZWYgcmVuZGVyX3BlcDQ0MF9w
cmUocGllY2VzKToKICAgICIiIlRBR1sucG9zdE4uZGV2RElTVEFOQ0VdIC0t
IE5vIC1kaXJ0eS4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8gdGFncy4g
MC5wb3N0MC5kZXZESVNUQU5DRQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNs
b3Nlc3QtdGFnIl06CiAgICAgICAgaWYgcGllY2VzWyJkaXN0YW5jZSJdOgog
ICAgICAgICAgICAjIHVwZGF0ZSB0aGUgcG9zdCByZWxlYXNlIHNlZ21lbnQK
ICAgICAgICAgICAgdGFnX3ZlcnNpb24sIHBvc3RfdmVyc2lvbiA9IHBlcDQ0
MF9zcGxpdF9wb3N0KHBpZWNlc1siY2xvc2VzdC10YWciXSkKICAgICAgICAg
ICAgcmVuZGVyZWQgPSB0YWdfdmVyc2lvbgogICAgICAgICAgICBpZiBwb3N0
X3ZlcnNpb24gaXMgbm90IE5vbmU6CiAgICAgICAgICAgICAgICByZW5kZXJl
ZCArPSAiLnBvc3QlJWQuZGV2JSVkIiAlJSAocG9zdF92ZXJzaW9uICsgMSwg
cGllY2VzWyJkaXN0YW5jZSJdKQogICAgICAgICAgICBlbHNlOgogICAgICAg
ICAgICAgICAgcmVuZGVyZWQgKz0gIi5wb3N0MC5kZXYlJWQiICUlIChwaWVj
ZXNbImRpc3RhbmNlIl0pCiAgICAgICAgZWxzZToKICAgICAgICAgICAgIyBu
byBjb21taXRzLCB1c2UgdGhlIHRhZyBhcyB0aGUgdmVyc2lvbgogICAgICAg
ICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQogICAgZWxz
ZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAgICAgIHJlbmRlcmVkID0g
IjAucG9zdDAuZGV2JSVkIiAlJSBwaWVjZXNbImRpc3RhbmNlIl0KICAgIHJl
dHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfcGVwNDQwX3Bvc3QocGllY2Vz
KToKICAgICIiIlRBR1sucG9zdERJU1RBTkNFWy5kZXYwXStnSEVYXSAuCgog
ICAgVGhlICIuZGV2MCIgbWVhbnMgZGlydHkuIE5vdGUgdGhhdCAuZGV2MCBz
b3J0cyBiYWNrd2FyZHMKICAgIChhIGRpcnR5IHRyZWUgd2lsbCBhcHBlYXIg
Im9sZGVyIiB0aGFuIHRoZSBjb3JyZXNwb25kaW5nIGNsZWFuIG9uZSksCiAg
ICBidXQgeW91IHNob3VsZG4ndCBiZSByZWxlYXNpbmcgc29mdHdhcmUgd2l0
aCAtZGlydHkgYW55d2F5cy4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8g
dGFncy4gMC5wb3N0RElTVEFOQ0VbLmRldjBdCiAgICAiIiIKICAgIGlmIHBp
ZWNlc1siY2xvc2VzdC10YWciXToKICAgICAgICByZW5kZXJlZCA9IHBpZWNl
c1siY2xvc2VzdC10YWciXQogICAgICAgIGlmIHBpZWNlc1siZGlzdGFuY2Ui
XSBvciBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9
ICIucG9zdCUlZCIgJSUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICAgICAgICAg
IGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgICAgIHJlbmRlcmVk
ICs9ICIuZGV2MCIKICAgICAgICAgICAgcmVuZGVyZWQgKz0gcGx1c19vcl9k
b3QocGllY2VzKQogICAgICAgICAgICByZW5kZXJlZCArPSAiZyUlcyIgJSUg
cGllY2VzWyJzaG9ydCJdCiAgICBlbHNlOgogICAgICAgICMgZXhjZXB0aW9u
ICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMC5wb3N0JSVkIiAlJSBwaWVjZXNb
ImRpc3RhbmNlIl0KICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAg
ICAgICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAgICAgICByZW5kZXJlZCAr
PSAiK2clJXMiICUlIHBpZWNlc1sic2hvcnQiXQogICAgcmV0dXJuIHJlbmRl
cmVkCgoKZGVmIHJlbmRlcl9wZXA0NDBfcG9zdF9icmFuY2gocGllY2VzKToK
ICAgICIiIlRBR1sucG9zdERJU1RBTkNFWy5kZXYwXStnSEVYWy5kaXJ0eV1d
IC4KCiAgICBUaGUgIi5kZXYwIiBtZWFucyBub3QgbWFzdGVyIGJyYW5jaC4K
CiAgICBFeGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gMC5wb3N0RElTVEFO
Q0VbLmRldjBdK2dIRVhbLmRpcnR5XQogICAgIiIiCiAgICBpZiBwaWVjZXNb
ImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNs
b3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl0gb3Ig
cGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSAiLnBv
c3QlJWQiICUlIHBpZWNlc1siZGlzdGFuY2UiXQogICAgICAgICAgICBpZiBw
aWVjZXNbImJyYW5jaCJdICE9ICJtYXN0ZXIiOgogICAgICAgICAgICAgICAg
cmVuZGVyZWQgKz0gIi5kZXYwIgogICAgICAgICAgICByZW5kZXJlZCArPSBw
bHVzX29yX2RvdChwaWVjZXMpCiAgICAgICAgICAgIHJlbmRlcmVkICs9ICJn
JSVzIiAlJSBwaWVjZXNbInNob3J0Il0KICAgICAgICAgICAgaWYgcGllY2Vz
WyJkaXJ0eSJdOgogICAgICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kaXJ0
eSIKICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICBy
ZW5kZXJlZCA9ICIwLnBvc3QlJWQiICUlIHBpZWNlc1siZGlzdGFuY2UiXQog
ICAgICAgIGlmIHBpZWNlc1siYnJhbmNoIl0gIT0gIm1hc3RlciI6CiAgICAg
ICAgICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAgICAgICByZW5kZXJlZCAr
PSAiK2clJXMiICUlIHBpZWNlc1sic2hvcnQiXQogICAgICAgIGlmIHBpZWNl
c1siZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kaXJ0eSIK
ICAgIHJldHVybiByZW5kZXJlZAoKCmRlZiByZW5kZXJfcGVwNDQwX29sZChw
aWVjZXMpOgogICAgIiIiVEFHWy5wb3N0RElTVEFOQ0VbLmRldjBdXSAuCgog
ICAgVGhlICIuZGV2MCIgbWVhbnMgZGlydHkuCgogICAgRXhjZXB0aW9uczoK
ICAgIDE6IG5vIHRhZ3MuIDAucG9zdERJU1RBTkNFWy5kZXYwXQogICAgIiIi
CiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVy
ZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNb
ImRpc3RhbmNlIl0gb3IgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICBy
ZW5kZXJlZCArPSAiLnBvc3QlJWQiICUlIHBpZWNlc1siZGlzdGFuY2UiXQog
ICAgICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAgICAgICAg
ICByZW5kZXJlZCArPSAiLmRldjAiCiAgICBlbHNlOgogICAgICAgICMgZXhj
ZXB0aW9uICMxCiAgICAgICAgcmVuZGVyZWQgPSAiMC5wb3N0JSVkIiAlJSBw
aWVjZXNbImRpc3RhbmNlIl0KICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06
CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAgIHJldHVybiBy
ZW5kZXJlZAoKCmRlZiByZW5kZXJfZ2l0X2Rlc2NyaWJlKHBpZWNlcyk6CiAg
ICAiIiJUQUdbLURJU1RBTkNFLWdIRVhdWy1kaXJ0eV0uCgogICAgTGlrZSAn
Z2l0IGRlc2NyaWJlIC0tdGFncyAtLWRpcnR5IC0tYWx3YXlzJy4KCiAgICBF
eGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gSEVYWy1kaXJ0eV0gIChub3Rl
OiBubyAnZycgcHJlZml4KQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nl
c3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3Qt
dGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl06CiAgICAgICAg
ICAgIHJlbmRlcmVkICs9ICItJSVkLWclJXMiICUlIChwaWVjZXNbImRpc3Rh
bmNlIl0sIHBpZWNlc1sic2hvcnQiXSkKICAgIGVsc2U6CiAgICAgICAgIyBl
eGNlcHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1sic2hvcnQi
XQogICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgIHJlbmRlcmVkICs9
ICItZGlydHkiCiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyX2dp
dF9kZXNjcmliZV9sb25nKHBpZWNlcyk6CiAgICAiIiJUQUctRElTVEFOQ0Ut
Z0hFWFstZGlydHldLgoKICAgIExpa2UgJ2dpdCBkZXNjcmliZSAtLXRhZ3Mg
LS1kaXJ0eSAtLWFsd2F5cyAtbG9uZycuCiAgICBUaGUgZGlzdGFuY2UvaGFz
aCBpcyB1bmNvbmRpdGlvbmFsLgoKICAgIEV4Y2VwdGlvbnM6CiAgICAxOiBu
byB0YWdzLiBIRVhbLWRpcnR5XSAgKG5vdGU6IG5vICdnJyBwcmVmaXgpCiAg
ICAiIiIKICAgIGlmIHBpZWNlc1siY2xvc2VzdC10YWciXToKICAgICAgICBy
ZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQogICAgICAgIHJlbmRl
cmVkICs9ICItJSVkLWclJXMiICUlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBp
ZWNlc1sic2hvcnQiXSkKICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24g
IzEKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1sic2hvcnQiXQogICAgaWYg
cGllY2VzWyJkaXJ0eSJdOgogICAgICAgIHJlbmRlcmVkICs9ICItZGlydHki
CiAgICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyKHBpZWNlcywgc3R5
bGUpOgogICAgIiIiUmVuZGVyIHRoZSBnaXZlbiB2ZXJzaW9uIHBpZWNlcyBp
bnRvIHRoZSByZXF1ZXN0ZWQgc3R5bGUuIiIiCiAgICBpZiBwaWVjZXNbImVy
cm9yIl06CiAgICAgICAgcmV0dXJuIHsidmVyc2lvbiI6ICJ1bmtub3duIiwK
ICAgICAgICAgICAgICAgICJmdWxsLXJldmlzaW9uaWQiOiBwaWVjZXMuZ2V0
KCJsb25nIiksCiAgICAgICAgICAgICAgICAiZGlydHkiOiBOb25lLAogICAg
ICAgICAgICAgICAgImVycm9yIjogcGllY2VzWyJlcnJvciJdLAogICAgICAg
ICAgICAgICAgImRhdGUiOiBOb25lfQoKICAgIGlmIG5vdCBzdHlsZSBvciBz
dHlsZSA9PSAiZGVmYXVsdCI6CiAgICAgICAgc3R5bGUgPSAicGVwNDQwIiAg
IyB0aGUgZGVmYXVsdAoKICAgIGlmIHN0eWxlID09ICJwZXA0NDAiOgogICAg
ICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MChwaWVjZXMpCiAgICBlbGlm
IHN0eWxlID09ICJwZXA0NDAtYnJhbmNoIjoKICAgICAgICByZW5kZXJlZCA9
IHJlbmRlcl9wZXA0NDBfYnJhbmNoKHBpZWNlcykKICAgIGVsaWYgc3R5bGUg
PT0gInBlcDQ0MC1wcmUiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3Bl
cDQ0MF9wcmUocGllY2VzKQogICAgZWxpZiBzdHlsZSA9PSAicGVwNDQwLXBv
c3QiOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9wb3N0KHBp
ZWNlcykKICAgIGVsaWYgc3R5bGUgPT0gInBlcDQ0MC1wb3N0LWJyYW5jaCI6
CiAgICAgICAgcmVuZGVyZWQgPSByZW5kZXJfcGVwNDQwX3Bvc3RfYnJhbmNo
KHBpZWNlcykKICAgIGVsaWYgc3R5bGUgPT0gInBlcDQ0MC1vbGQiOgogICAg
ICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9vbGQocGllY2VzKQogICAg
ZWxpZiBzdHlsZSA9PSAiZ2l0LWRlc2NyaWJlIjoKICAgICAgICByZW5kZXJl
ZCA9IHJlbmRlcl9naXRfZGVzY3JpYmUocGllY2VzKQogICAgZWxpZiBzdHls
ZSA9PSAiZ2l0LWRlc2NyaWJlLWxvbmciOgogICAgICAgIHJlbmRlcmVkID0g
cmVuZGVyX2dpdF9kZXNjcmliZV9sb25nKHBpZWNlcykKICAgIGVsc2U6CiAg
ICAgICAgcmFpc2UgVmFsdWVFcnJvcigidW5rbm93biBzdHlsZSAnJSVzJyIg
JSUgc3R5bGUpCgogICAgcmV0dXJuIHsidmVyc2lvbiI6IHJlbmRlcmVkLCAi
ZnVsbC1yZXZpc2lvbmlkIjogcGllY2VzWyJsb25nIl0sCiAgICAgICAgICAg
ICJkaXJ0eSI6IHBpZWNlc1siZGlydHkiXSwgImVycm9yIjogTm9uZSwKICAg
ICAgICAgICAgImRhdGUiOiBwaWVjZXMuZ2V0KCJkYXRlIil9CgoKZGVmIGdl
dF92ZXJzaW9ucygpOgogICAgIiIiR2V0IHZlcnNpb24gaW5mb3JtYXRpb24g
b3IgcmV0dXJuIGRlZmF1bHQgaWYgdW5hYmxlIHRvIGRvIHNvLiIiIgogICAg
IyBJIGFtIGluIF92ZXJzaW9uLnB5LCB3aGljaCBsaXZlcyBhdCBST09UL1ZF
UlNJT05GSUxFX1NPVVJDRS4gSWYgd2UgaGF2ZQogICAgIyBfX2ZpbGVfXywg
d2UgY2FuIHdvcmsgYmFja3dhcmRzIGZyb20gdGhlcmUgdG8gdGhlIHJvb3Qu
IFNvbWUKICAgICMgcHkyZXhlL2JiZnJlZXplL25vbi1DUHl0aG9uIGltcGxl
bWVudGF0aW9ucyBkb24ndCBkbyBfX2ZpbGVfXywgaW4gd2hpY2gKICAgICMg
Y2FzZSB3ZSBjYW4gb25seSB1c2UgZXhwYW5kZWQga2V5d29yZHMuCgogICAg
Y2ZnID0gZ2V0X2NvbmZpZygpCiAgICB2ZXJib3NlID0gY2ZnLnZlcmJvc2UK
CiAgICB0cnk6CiAgICAgICAgcmV0dXJuIGdpdF92ZXJzaW9uc19mcm9tX2tl
eXdvcmRzKGdldF9rZXl3b3JkcygpLCBjZmcudGFnX3ByZWZpeCwKICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgdmVyYm9zZSkK
ICAgIGV4Y2VwdCBOb3RUaGlzTWV0aG9kOgogICAgICAgIHBhc3MKCiAgICB0
cnk6CiAgICAgICAgcm9vdCA9IG9zLnBhdGgucmVhbHBhdGgoX19maWxlX18p
CiAgICAgICAgIyB2ZXJzaW9uZmlsZV9zb3VyY2UgaXMgdGhlIHJlbGF0aXZl
IHBhdGggZnJvbSB0aGUgdG9wIG9mIHRoZSBzb3VyY2UKICAgICAgICAjIHRy
ZWUgKHdoZXJlIHRoZSAuZ2l0IGRpcmVjdG9yeSBtaWdodCBsaXZlKSB0byB0
aGlzIGZpbGUuIEludmVydAogICAgICAgICMgdGhpcyB0byBmaW5kIHRoZSBy
b290IGZyb20gX19maWxlX18uCiAgICAgICAgZm9yIF8gaW4gY2ZnLnZlcnNp
b25maWxlX3NvdXJjZS5zcGxpdCgnLycpOgogICAgICAgICAgICByb290ID0g
b3MucGF0aC5kaXJuYW1lKHJvb3QpCiAgICBleGNlcHQgTmFtZUVycm9yOgog
ICAgICAgIHJldHVybiB7InZlcnNpb24iOiAiMCt1bmtub3duIiwgImZ1bGwt
cmV2aXNpb25pZCI6IE5vbmUsCiAgICAgICAgICAgICAgICAiZGlydHkiOiBO
b25lLAogICAgICAgICAgICAgICAgImVycm9yIjogInVuYWJsZSB0byBmaW5k
IHJvb3Qgb2Ygc291cmNlIHRyZWUiLAogICAgICAgICAgICAgICAgImRhdGUi
OiBOb25lfQoKICAgIHRyeToKICAgICAgICBwaWVjZXMgPSBnaXRfcGllY2Vz
X2Zyb21fdmNzKGNmZy50YWdfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAg
ICAgIHJldHVybiByZW5kZXIocGllY2VzLCBjZmcuc3R5bGUpCiAgICBleGNl
cHQgTm90VGhpc01ldGhvZDoKICAgICAgICBwYXNzCgogICAgdHJ5OgogICAg
ICAgIGlmIGNmZy5wYXJlbnRkaXJfcHJlZml4OgogICAgICAgICAgICByZXR1
cm4gdmVyc2lvbnNfZnJvbV9wYXJlbnRkaXIoY2ZnLnBhcmVudGRpcl9wcmVm
aXgsIHJvb3QsIHZlcmJvc2UpCiAgICBleGNlcHQgTm90VGhpc01ldGhvZDoK
ICAgICAgICBwYXNzCgogICAgcmV0dXJuIHsidmVyc2lvbiI6ICIwK3Vua25v
d24iLCAiZnVsbC1yZXZpc2lvbmlkIjogTm9uZSwKICAgICAgICAgICAgImRp
cnR5IjogTm9uZSwKICAgICAgICAgICAgImVycm9yIjogInVuYWJsZSB0byBj
b21wdXRlIHZlcnNpb24iLCAiZGF0ZSI6IE5vbmV9CicnJwoKCkByZWdpc3Rl
cl92Y3NfaGFuZGxlcigiZ2l0IiwgImdldF9rZXl3b3JkcyIpCmRlZiBnaXRf
Z2V0X2tleXdvcmRzKHZlcnNpb25maWxlX2Ficyk6CiAgICAiIiJFeHRyYWN0
IHZlcnNpb24gaW5mb3JtYXRpb24gZnJvbSB0aGUgZ2l2ZW4gZmlsZS4iIiIK
ICAgICMgdGhlIGNvZGUgZW1iZWRkZWQgaW4gX3ZlcnNpb24ucHkgY2FuIGp1
c3QgZmV0Y2ggdGhlIHZhbHVlIG9mIHRoZXNlCiAgICAjIGtleXdvcmRzLiBX
aGVuIHVzZWQgZnJvbSBzZXR1cC5weSwgd2UgZG9uJ3Qgd2FudCB0byBpbXBv
cnQgX3ZlcnNpb24ucHksCiAgICAjIHNvIHdlIGRvIGl0IHdpdGggYSByZWdl
eHAgaW5zdGVhZC4gVGhpcyBmdW5jdGlvbiBpcyBub3QgdXNlZCBmcm9tCiAg
ICAjIF92ZXJzaW9uLnB5LgogICAga2V5d29yZHMgPSB7fQogICAgdHJ5Ogog
ICAgICAgIHdpdGggb3Blbih2ZXJzaW9uZmlsZV9hYnMsICJyIikgYXMgZm9i
ajoKICAgICAgICAgICAgZm9yIGxpbmUgaW4gZm9iajoKICAgICAgICAgICAg
ICAgIGlmIGxpbmUuc3RyaXAoKS5zdGFydHN3aXRoKCJnaXRfcmVmbmFtZXMg
PSIpOgogICAgICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxz
KiIoLiopIicsIGxpbmUpCiAgICAgICAgICAgICAgICAgICAgaWYgbW86CiAg
ICAgICAgICAgICAgICAgICAgICAgIGtleXdvcmRzWyJyZWZuYW1lcyJdID0g
bW8uZ3JvdXAoMSkKICAgICAgICAgICAgICAgIGlmIGxpbmUuc3RyaXAoKS5z
dGFydHN3aXRoKCJnaXRfZnVsbCA9Iik6CiAgICAgICAgICAgICAgICAgICAg
bW8gPSByZS5zZWFyY2gocic9XHMqIiguKikiJywgbGluZSkKICAgICAgICAg
ICAgICAgICAgICBpZiBtbzoKICAgICAgICAgICAgICAgICAgICAgICAga2V5
d29yZHNbImZ1bGwiXSA9IG1vLmdyb3VwKDEpCiAgICAgICAgICAgICAgICBp
ZiBsaW5lLnN0cmlwKCkuc3RhcnRzd2l0aCgiZ2l0X2RhdGUgPSIpOgogICAg
ICAgICAgICAgICAgICAgIG1vID0gcmUuc2VhcmNoKHInPVxzKiIoLiopIics
IGxpbmUpCiAgICAgICAgICAgICAgICAgICAgaWYgbW86CiAgICAgICAgICAg
ICAgICAgICAgICAgIGtleXdvcmRzWyJkYXRlIl0gPSBtby5ncm91cCgxKQog
ICAgZXhjZXB0IE9TRXJyb3I6CiAgICAgICAgcGFzcwogICAgcmV0dXJuIGtl
eXdvcmRzCgoKQHJlZ2lzdGVyX3Zjc19oYW5kbGVyKCJnaXQiLCAia2V5d29y
ZHMiKQpkZWYgZ2l0X3ZlcnNpb25zX2Zyb21fa2V5d29yZHMoa2V5d29yZHMs
IHRhZ19wcmVmaXgsIHZlcmJvc2UpOgogICAgIiIiR2V0IHZlcnNpb24gaW5m
b3JtYXRpb24gZnJvbSBnaXQga2V5d29yZHMuIiIiCiAgICBpZiAicmVmbmFt
ZXMiIG5vdCBpbiBrZXl3b3JkczoKICAgICAgICByYWlzZSBOb3RUaGlzTWV0
aG9kKCJTaG9ydCB2ZXJzaW9uIGZpbGUgZm91bmQiKQogICAgZGF0ZSA9IGtl
eXdvcmRzLmdldCgiZGF0ZSIpCiAgICBpZiBkYXRlIGlzIG5vdCBOb25lOgog
ICAgICAgICMgVXNlIG9ubHkgdGhlIGxhc3QgbGluZS4gIFByZXZpb3VzIGxp
bmVzIG1heSBjb250YWluIEdQRyBzaWduYXR1cmUKICAgICAgICAjIGluZm9y
bWF0aW9uLgogICAgICAgIGRhdGUgPSBkYXRlLnNwbGl0bGluZXMoKVstMV0K
CiAgICAgICAgIyBnaXQtMi4yLjAgYWRkZWQgIiVjSSIsIHdoaWNoIGV4cGFu
ZHMgdG8gYW4gSVNPLTg2MDEgLWNvbXBsaWFudAogICAgICAgICMgZGF0ZXN0
YW1wLiBIb3dldmVyIHdlIHByZWZlciAiJWNpIiAod2hpY2ggZXhwYW5kcyB0
byBhbiAiSVNPLTg2MDEKICAgICAgICAjIC1saWtlIiBzdHJpbmcsIHdoaWNo
IHdlIG11c3QgdGhlbiBlZGl0IHRvIG1ha2UgY29tcGxpYW50KSwgYmVjYXVz
ZQogICAgICAgICMgaXQncyBiZWVuIGFyb3VuZCBzaW5jZSBnaXQtMS41LjMs
IGFuZCBpdCdzIHRvbyBkaWZmaWN1bHQgdG8KICAgICAgICAjIGRpc2NvdmVy
IHdoaWNoIHZlcnNpb24gd2UncmUgdXNpbmcsIG9yIHRvIHdvcmsgYXJvdW5k
IHVzaW5nIGFuCiAgICAgICAgIyBvbGRlciBvbmUuCiAgICAgICAgZGF0ZSA9
IGRhdGUuc3RyaXAoKS5yZXBsYWNlKCIgIiwgIlQiLCAxKS5yZXBsYWNlKCIg
IiwgIiIsIDEpCiAgICByZWZuYW1lcyA9IGtleXdvcmRzWyJyZWZuYW1lcyJd
LnN0cmlwKCkKICAgIGlmIHJlZm5hbWVzLnN0YXJ0c3dpdGgoIiRGb3JtYXQi
KToKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgia2V5
d29yZHMgYXJlIHVuZXhwYW5kZWQsIG5vdCB1c2luZyIpCiAgICAgICAgcmFp
c2UgTm90VGhpc01ldGhvZCgidW5leHBhbmRlZCBrZXl3b3Jkcywgbm90IGEg
Z2l0LWFyY2hpdmUgdGFyYmFsbCIpCiAgICByZWZzID0ge3Iuc3RyaXAoKSBm
b3IgciBpbiByZWZuYW1lcy5zdHJpcCgiKCkiKS5zcGxpdCgiLCIpfQogICAg
IyBzdGFydGluZyBpbiBnaXQtMS44LjMsIHRhZ3MgYXJlIGxpc3RlZCBhcyAi
dGFnOiBmb28tMS4wIiBpbnN0ZWFkIG9mCiAgICAjIGp1c3QgImZvby0xLjAi
LiBJZiB3ZSBzZWUgYSAidGFnOiAiIHByZWZpeCwgcHJlZmVyIHRob3NlLgog
ICAgVEFHID0gInRhZzogIgogICAgdGFncyA9IHtyW2xlbihUQUcpOl0gZm9y
IHIgaW4gcmVmcyBpZiByLnN0YXJ0c3dpdGgoVEFHKX0KICAgIGlmIG5vdCB0
YWdzOgogICAgICAgICMgRWl0aGVyIHdlJ3JlIHVzaW5nIGdpdCA8IDEuOC4z
LCBvciB0aGVyZSByZWFsbHkgYXJlIG5vIHRhZ3MuIFdlIHVzZQogICAgICAg
ICMgYSBoZXVyaXN0aWM6IGFzc3VtZSBhbGwgdmVyc2lvbiB0YWdzIGhhdmUg
YSBkaWdpdC4gVGhlIG9sZCBnaXQgJWQKICAgICAgICAjIGV4cGFuc2lvbiBi
ZWhhdmVzIGxpa2UgZ2l0IGxvZyAtLWRlY29yYXRlPXNob3J0IGFuZCBzdHJp
cHMgb3V0IHRoZQogICAgICAgICMgcmVmcy9oZWFkcy8gYW5kIHJlZnMvdGFn
cy8gcHJlZml4ZXMgdGhhdCB3b3VsZCBsZXQgdXMgZGlzdGluZ3Vpc2gKICAg
ICAgICAjIGJldHdlZW4gYnJhbmNoZXMgYW5kIHRhZ3MuIEJ5IGlnbm9yaW5n
IHJlZm5hbWVzIHdpdGhvdXQgZGlnaXRzLCB3ZQogICAgICAgICMgZmlsdGVy
IG91dCBtYW55IGNvbW1vbiBicmFuY2ggbmFtZXMgbGlrZSAicmVsZWFzZSIg
YW5kCiAgICAgICAgIyAic3RhYmlsaXphdGlvbiIsIGFzIHdlbGwgYXMgIkhF
QUQiIGFuZCAibWFzdGVyIi4KICAgICAgICB0YWdzID0ge3IgZm9yIHIgaW4g
cmVmcyBpZiByZS5zZWFyY2gocidcZCcsIHIpfQogICAgICAgIGlmIHZlcmJv
c2U6CiAgICAgICAgICAgIHByaW50KCJkaXNjYXJkaW5nICclcycsIG5vIGRp
Z2l0cyIgJSAiLCIuam9pbihyZWZzIC0gdGFncykpCiAgICBpZiB2ZXJib3Nl
OgogICAgICAgIHByaW50KCJsaWtlbHkgdGFnczogJXMiICUgIiwiLmpvaW4o
c29ydGVkKHRhZ3MpKSkKICAgIGZvciByZWYgaW4gc29ydGVkKHRhZ3MpOgog
ICAgICAgICMgc29ydGluZyB3aWxsIHByZWZlciBlLmcuICIyLjAiIG92ZXIg
IjIuMHJjMSIKICAgICAgICBpZiByZWYuc3RhcnRzd2l0aCh0YWdfcHJlZml4
KToKICAgICAgICAgICAgciA9IHJlZltsZW4odGFnX3ByZWZpeCk6XQogICAg
ICAgICAgICAjIEZpbHRlciBvdXQgcmVmcyB0aGF0IGV4YWN0bHkgbWF0Y2gg
cHJlZml4IG9yIHRoYXQgZG9uJ3Qgc3RhcnQKICAgICAgICAgICAgIyB3aXRo
IGEgbnVtYmVyIG9uY2UgdGhlIHByZWZpeCBpcyBzdHJpcHBlZCAobW9zdGx5
IGEgY29uY2VybgogICAgICAgICAgICAjIHdoZW4gcHJlZml4IGlzICcnKQog
ICAgICAgICAgICBpZiBub3QgcmUubWF0Y2gocidcZCcsIHIpOgogICAgICAg
ICAgICAgICAgY29udGludWUKICAgICAgICAgICAgaWYgdmVyYm9zZToKICAg
ICAgICAgICAgICAgIHByaW50KCJwaWNraW5nICVzIiAlIHIpCiAgICAgICAg
ICAgIHJldHVybiB7InZlcnNpb24iOiByLAogICAgICAgICAgICAgICAgICAg
ICJmdWxsLXJldmlzaW9uaWQiOiBrZXl3b3Jkc1siZnVsbCJdLnN0cmlwKCks
CiAgICAgICAgICAgICAgICAgICAgImRpcnR5IjogRmFsc2UsICJlcnJvciI6
IE5vbmUsCiAgICAgICAgICAgICAgICAgICAgImRhdGUiOiBkYXRlfQogICAg
IyBubyBzdWl0YWJsZSB0YWdzLCBzbyB2ZXJzaW9uIGlzICIwK3Vua25vd24i
LCBidXQgZnVsbCBoZXggaXMgc3RpbGwgdGhlcmUKICAgIGlmIHZlcmJvc2U6
CiAgICAgICAgcHJpbnQoIm5vIHN1aXRhYmxlIHRhZ3MsIHVzaW5nIHVua25v
d24gKyBmdWxsIHJldmlzaW9uIGlkIikKICAgIHJldHVybiB7InZlcnNpb24i
OiAiMCt1bmtub3duIiwKICAgICAgICAgICAgImZ1bGwtcmV2aXNpb25pZCI6
IGtleXdvcmRzWyJmdWxsIl0uc3RyaXAoKSwKICAgICAgICAgICAgImRpcnR5
IjogRmFsc2UsICJlcnJvciI6ICJubyBzdWl0YWJsZSB0YWdzIiwgImRhdGUi
OiBOb25lfQoKCkByZWdpc3Rlcl92Y3NfaGFuZGxlcigiZ2l0IiwgInBpZWNl
c19mcm9tX3ZjcyIpCmRlZiBnaXRfcGllY2VzX2Zyb21fdmNzKHRhZ19wcmVm
aXgsIHJvb3QsIHZlcmJvc2UsIHJ1bm5lcj1ydW5fY29tbWFuZCk6CiAgICAi
IiJHZXQgdmVyc2lvbiBmcm9tICdnaXQgZGVzY3JpYmUnIGluIHRoZSByb290
IG9mIHRoZSBzb3VyY2UgdHJlZS4KCiAgICBUaGlzIG9ubHkgZ2V0cyBjYWxs
ZWQgaWYgdGhlIGdpdC1hcmNoaXZlICdzdWJzdCcga2V5d29yZHMgd2VyZSAq
bm90KgogICAgZXhwYW5kZWQsIGFuZCBfdmVyc2lvbi5weSBoYXNuJ3QgYWxy
ZWFkeSBiZWVuIHJld3JpdHRlbiB3aXRoIGEgc2hvcnQKICAgIHZlcnNpb24g
c3RyaW5nLCBtZWFuaW5nIHdlJ3JlIGluc2lkZSBhIGNoZWNrZWQgb3V0IHNv
dXJjZSB0cmVlLgogICAgIiIiCiAgICBHSVRTID0gWyJnaXQiXQogICAgaWYg
c3lzLnBsYXRmb3JtID09ICJ3aW4zMiI6CiAgICAgICAgR0lUUyA9IFsiZ2l0
LmNtZCIsICJnaXQuZXhlIl0KCiAgICAjIEdJVF9ESVIgY2FuIGludGVyZmVy
ZSB3aXRoIGNvcnJlY3Qgb3BlcmF0aW9uIG9mIFZlcnNpb25lZXIuCiAgICAj
IEl0IG1heSBiZSBpbnRlbmRlZCB0byBiZSBwYXNzZWQgdG8gdGhlIFZlcnNp
b25lZXItdmVyc2lvbmVkIHByb2plY3QsCiAgICAjIGJ1dCB0aGF0IHNob3Vs
ZCBub3QgY2hhbmdlIHdoZXJlIHdlIGdldCBvdXIgdmVyc2lvbiBmcm9tLgog
ICAgZW52ID0gb3MuZW52aXJvbi5jb3B5KCkKICAgIGVudi5wb3AoIkdJVF9E
SVIiLCBOb25lKQogICAgcnVubmVyID0gZnVuY3Rvb2xzLnBhcnRpYWwocnVu
bmVyLCBlbnY9ZW52KQoKICAgIF8sIHJjID0gcnVubmVyKEdJVFMsIFsicmV2
LXBhcnNlIiwgIi0tZ2l0LWRpciJdLCBjd2Q9cm9vdCwKICAgICAgICAgICAg
ICAgICAgIGhpZGVfc3RkZXJyPW5vdCB2ZXJib3NlKQogICAgaWYgcmMgIT0g
MDoKICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICBwcmludCgiRGly
ZWN0b3J5ICVzIG5vdCB1bmRlciBnaXQgY29udHJvbCIgJSByb290KQogICAg
ICAgIHJhaXNlIE5vdFRoaXNNZXRob2QoIidnaXQgcmV2LXBhcnNlIC0tZ2l0
LWRpcicgcmV0dXJuZWQgZXJyb3IiKQoKICAgICMgaWYgdGhlcmUgaXMgYSB0
YWcgbWF0Y2hpbmcgdGFnX3ByZWZpeCwgdGhpcyB5aWVsZHMgVEFHLU5VTS1n
SEVYWy1kaXJ0eV0KICAgICMgaWYgdGhlcmUgaXNuJ3Qgb25lLCB0aGlzIHlp
ZWxkcyBIRVhbLWRpcnR5XSAobm8gTlVNKQogICAgZGVzY3JpYmVfb3V0LCBy
YyA9IHJ1bm5lcihHSVRTLCBbCiAgICAgICAgImRlc2NyaWJlIiwgIi0tdGFn
cyIsICItLWRpcnR5IiwgIi0tYWx3YXlzIiwgIi0tbG9uZyIsCiAgICAgICAg
Ii0tbWF0Y2giLCBmInt0YWdfcHJlZml4fVtbOmRpZ2l0Ol1dKiIKICAgIF0s
IGN3ZD1yb290KQogICAgIyAtLWxvbmcgd2FzIGFkZGVkIGluIGdpdC0xLjUu
NQogICAgaWYgZGVzY3JpYmVfb3V0IGlzIE5vbmU6CiAgICAgICAgcmFpc2Ug
Tm90VGhpc01ldGhvZCgiJ2dpdCBkZXNjcmliZScgZmFpbGVkIikKICAgIGRl
c2NyaWJlX291dCA9IGRlc2NyaWJlX291dC5zdHJpcCgpCiAgICBmdWxsX291
dCwgcmMgPSBydW5uZXIoR0lUUywgWyJyZXYtcGFyc2UiLCAiSEVBRCJdLCBj
d2Q9cm9vdCkKICAgIGlmIGZ1bGxfb3V0IGlzIE5vbmU6CiAgICAgICAgcmFp
c2UgTm90VGhpc01ldGhvZCgiJ2dpdCByZXYtcGFyc2UnIGZhaWxlZCIpCiAg
ICBmdWxsX291dCA9IGZ1bGxfb3V0LnN0cmlwKCkKCiAgICBwaWVjZXMgPSB7
fQogICAgcGllY2VzWyJsb25nIl0gPSBmdWxsX291dAogICAgcGllY2VzWyJz
aG9ydCJdID0gZnVsbF9vdXRbOjddICAjIG1heWJlIGltcHJvdmVkIGxhdGVy
CiAgICBwaWVjZXNbImVycm9yIl0gPSBOb25lCgogICAgYnJhbmNoX25hbWUs
IHJjID0gcnVubmVyKEdJVFMsIFsicmV2LXBhcnNlIiwgIi0tYWJicmV2LXJl
ZiIsICJIRUFEIl0sCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgY3dk
PXJvb3QpCiAgICAjIC0tYWJicmV2LXJlZiB3YXMgYWRkZWQgaW4gZ2l0LTEu
Ni4zCiAgICBpZiByYyAhPSAwIG9yIGJyYW5jaF9uYW1lIGlzIE5vbmU6CiAg
ICAgICAgcmFpc2UgTm90VGhpc01ldGhvZCgiJ2dpdCByZXYtcGFyc2UgLS1h
YmJyZXYtcmVmJyByZXR1cm5lZCBlcnJvciIpCiAgICBicmFuY2hfbmFtZSA9
IGJyYW5jaF9uYW1lLnN0cmlwKCkKCiAgICBpZiBicmFuY2hfbmFtZSA9PSAi
SEVBRCI6CiAgICAgICAgIyBJZiB3ZSBhcmVuJ3QgZXhhY3RseSBvbiBhIGJy
YW5jaCwgcGljayBhIGJyYW5jaCB3aGljaCByZXByZXNlbnRzCiAgICAgICAg
IyB0aGUgY3VycmVudCBjb21taXQuIElmIGFsbCBlbHNlIGZhaWxzLCB3ZSBh
cmUgb24gYSBicmFuY2hsZXNzCiAgICAgICAgIyBjb21taXQuCiAgICAgICAg
YnJhbmNoZXMsIHJjID0gcnVubmVyKEdJVFMsIFsiYnJhbmNoIiwgIi0tY29u
dGFpbnMiXSwgY3dkPXJvb3QpCiAgICAgICAgIyAtLWNvbnRhaW5zIHdhcyBh
ZGRlZCBpbiBnaXQtMS41LjQKICAgICAgICBpZiByYyAhPSAwIG9yIGJyYW5j
aGVzIGlzIE5vbmU6CiAgICAgICAgICAgIHJhaXNlIE5vdFRoaXNNZXRob2Qo
IidnaXQgYnJhbmNoIC0tY29udGFpbnMnIHJldHVybmVkIGVycm9yIikKICAg
ICAgICBicmFuY2hlcyA9IGJyYW5jaGVzLnNwbGl0KCJcbiIpCgogICAgICAg
ICMgUmVtb3ZlIHRoZSBmaXJzdCBsaW5lIGlmIHdlJ3JlIHJ1bm5pbmcgZGV0
YWNoZWQKICAgICAgICBpZiAiKCIgaW4gYnJhbmNoZXNbMF06CiAgICAgICAg
ICAgIGJyYW5jaGVzLnBvcCgwKQoKICAgICAgICAjIFN0cmlwIG9mZiB0aGUg
bGVhZGluZyAiKiAiIGZyb20gdGhlIGxpc3Qgb2YgYnJhbmNoZXMuCiAgICAg
ICAgYnJhbmNoZXMgPSBbYnJhbmNoWzI6XSBmb3IgYnJhbmNoIGluIGJyYW5j
aGVzXQogICAgICAgIGlmICJtYXN0ZXIiIGluIGJyYW5jaGVzOgogICAgICAg
ICAgICBicmFuY2hfbmFtZSA9ICJtYXN0ZXIiCiAgICAgICAgZWxpZiBub3Qg
YnJhbmNoZXM6CiAgICAgICAgICAgIGJyYW5jaF9uYW1lID0gTm9uZQogICAg
ICAgIGVsc2U6CiAgICAgICAgICAgICMgUGljayB0aGUgZmlyc3QgYnJhbmNo
IHRoYXQgaXMgcmV0dXJuZWQuIEdvb2Qgb3IgYmFkLgogICAgICAgICAgICBi
cmFuY2hfbmFtZSA9IGJyYW5jaGVzWzBdCgogICAgcGllY2VzWyJicmFuY2gi
XSA9IGJyYW5jaF9uYW1lCgogICAgIyBwYXJzZSBkZXNjcmliZV9vdXQuIEl0
IHdpbGwgYmUgbGlrZSBUQUctTlVNLWdIRVhbLWRpcnR5XSBvciBIRVhbLWRp
cnR5XQogICAgIyBUQUcgbWlnaHQgaGF2ZSBoeXBoZW5zLgogICAgZ2l0X2Rl
c2NyaWJlID0gZGVzY3JpYmVfb3V0CgogICAgIyBsb29rIGZvciAtZGlydHkg
c3VmZml4CiAgICBkaXJ0eSA9IGdpdF9kZXNjcmliZS5lbmRzd2l0aCgiLWRp
cnR5IikKICAgIHBpZWNlc1siZGlydHkiXSA9IGRpcnR5CiAgICBpZiBkaXJ0
eToKICAgICAgICBnaXRfZGVzY3JpYmUgPSBnaXRfZGVzY3JpYmVbOmdpdF9k
ZXNjcmliZS5yaW5kZXgoIi1kaXJ0eSIpXQoKICAgICMgbm93IHdlIGhhdmUg
VEFHLU5VTS1nSEVYIG9yIEhFWAoKICAgIGlmICItIiBpbiBnaXRfZGVzY3Jp
YmU6CiAgICAgICAgIyBUQUctTlVNLWdIRVgKICAgICAgICBtbyA9IHJlLnNl
YXJjaChyJ14oLispLShcZCspLWcoWzAtOWEtZl0rKSQnLCBnaXRfZGVzY3Jp
YmUpCiAgICAgICAgaWYgbm90IG1vOgogICAgICAgICAgICAjIHVucGFyc2Fi
bGUuIE1heWJlIGdpdC1kZXNjcmliZSBpcyBtaXNiZWhhdmluZz8KICAgICAg
ICAgICAgcGllY2VzWyJlcnJvciJdID0gKCJ1bmFibGUgdG8gcGFyc2UgZ2l0
LWRlc2NyaWJlIG91dHB1dDogJyVzJyIKICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICUgZGVzY3JpYmVfb3V0KQogICAgICAgICAgICByZXR1cm4g
cGllY2VzCgogICAgICAgICMgdGFnCiAgICAgICAgZnVsbF90YWcgPSBtby5n
cm91cCgxKQogICAgICAgIGlmIG5vdCBmdWxsX3RhZy5zdGFydHN3aXRoKHRh
Z19wcmVmaXgpOgogICAgICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAg
ICAgICAgZm10ID0gInRhZyAnJXMnIGRvZXNuJ3Qgc3RhcnQgd2l0aCBwcmVm
aXggJyVzJyIKICAgICAgICAgICAgICAgIHByaW50KGZtdCAlIChmdWxsX3Rh
ZywgdGFnX3ByZWZpeCkpCiAgICAgICAgICAgIHBpZWNlc1siZXJyb3IiXSA9
ICgidGFnICclcycgZG9lc24ndCBzdGFydCB3aXRoIHByZWZpeCAnJXMnIgog
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgJSAoZnVsbF90YWcsIHRh
Z19wcmVmaXgpKQogICAgICAgICAgICByZXR1cm4gcGllY2VzCiAgICAgICAg
cGllY2VzWyJjbG9zZXN0LXRhZyJdID0gZnVsbF90YWdbbGVuKHRhZ19wcmVm
aXgpOl0KCiAgICAgICAgIyBkaXN0YW5jZTogbnVtYmVyIG9mIGNvbW1pdHMg
c2luY2UgdGFnCiAgICAgICAgcGllY2VzWyJkaXN0YW5jZSJdID0gaW50KG1v
Lmdyb3VwKDIpKQoKICAgICAgICAjIGNvbW1pdDogc2hvcnQgaGV4IHJldmlz
aW9uIElECiAgICAgICAgcGllY2VzWyJzaG9ydCJdID0gbW8uZ3JvdXAoMykK
CiAgICBlbHNlOgogICAgICAgICMgSEVYOiBubyB0YWdzCiAgICAgICAgcGll
Y2VzWyJjbG9zZXN0LXRhZyJdID0gTm9uZQogICAgICAgIG91dCwgcmMgPSBy
dW5uZXIoR0lUUywgWyJyZXYtbGlzdCIsICJIRUFEIiwgIi0tbGVmdC1yaWdo
dCJdLCBjd2Q9cm9vdCkKICAgICAgICBwaWVjZXNbImRpc3RhbmNlIl0gPSBs
ZW4ob3V0LnNwbGl0KCkpICAjIHRvdGFsIG51bWJlciBvZiBjb21taXRzCgog
ICAgIyBjb21taXQgZGF0ZTogc2VlIElTTy04NjAxIGNvbW1lbnQgaW4gZ2l0
X3ZlcnNpb25zX2Zyb21fa2V5d29yZHMoKQogICAgZGF0ZSA9IHJ1bm5lcihH
SVRTLCBbInNob3ciLCAiLXMiLCAiLS1mb3JtYXQ9JWNpIiwgIkhFQUQiXSwg
Y3dkPXJvb3QpWzBdLnN0cmlwKCkKICAgICMgVXNlIG9ubHkgdGhlIGxhc3Qg
bGluZS4gIFByZXZpb3VzIGxpbmVzIG1heSBjb250YWluIEdQRyBzaWduYXR1
cmUKICAgICMgaW5mb3JtYXRpb24uCiAgICBkYXRlID0gZGF0ZS5zcGxpdGxp
bmVzKClbLTFdCiAgICBwaWVjZXNbImRhdGUiXSA9IGRhdGUuc3RyaXAoKS5y
ZXBsYWNlKCIgIiwgIlQiLCAxKS5yZXBsYWNlKCIgIiwgIiIsIDEpCgogICAg
cmV0dXJuIHBpZWNlcwoKCmRlZiBkb192Y3NfaW5zdGFsbCh2ZXJzaW9uZmls
ZV9zb3VyY2UsIGlweSk6CiAgICAiIiJHaXQtc3BlY2lmaWMgaW5zdGFsbGF0
aW9uIGxvZ2ljIGZvciBWZXJzaW9uZWVyLgoKICAgIEZvciBHaXQsIHRoaXMg
bWVhbnMgY3JlYXRpbmcvY2hhbmdpbmcgLmdpdGF0dHJpYnV0ZXMgdG8gbWFy
ayBfdmVyc2lvbi5weQogICAgZm9yIGV4cG9ydC1zdWJzdCBrZXl3b3JkIHN1
YnN0aXR1dGlvbi4KICAgICIiIgogICAgR0lUUyA9IFsiZ2l0Il0KICAgIGlm
IHN5cy5wbGF0Zm9ybSA9PSAid2luMzIiOgogICAgICAgIEdJVFMgPSBbImdp
dC5jbWQiLCAiZ2l0LmV4ZSJdCiAgICBmaWxlcyA9IFt2ZXJzaW9uZmlsZV9z
b3VyY2VdCiAgICBpZiBpcHk6CiAgICAgICAgZmlsZXMuYXBwZW5kKGlweSkK
ICAgIGlmICJWRVJTSU9ORUVSX1BFUDUxOCIgbm90IGluIGdsb2JhbHMoKToK
ICAgICAgICB0cnk6CiAgICAgICAgICAgIG15X3BhdGggPSBfX2ZpbGVfXwog
ICAgICAgICAgICBpZiBteV9wYXRoLmVuZHN3aXRoKCIucHljIikgb3IgbXlf
cGF0aC5lbmRzd2l0aCgiLnB5byIpOgogICAgICAgICAgICAgICAgbXlfcGF0
aCA9IG9zLnBhdGguc3BsaXRleHQobXlfcGF0aClbMF0gKyAiLnB5IgogICAg
ICAgICAgICB2ZXJzaW9uZWVyX2ZpbGUgPSBvcy5wYXRoLnJlbHBhdGgobXlf
cGF0aCkKICAgICAgICBleGNlcHQgTmFtZUVycm9yOgogICAgICAgICAgICB2
ZXJzaW9uZWVyX2ZpbGUgPSAidmVyc2lvbmVlci5weSIKICAgICAgICBmaWxl
cy5hcHBlbmQodmVyc2lvbmVlcl9maWxlKQogICAgcHJlc2VudCA9IEZhbHNl
CiAgICB0cnk6CiAgICAgICAgd2l0aCBvcGVuKCIuZ2l0YXR0cmlidXRlcyIs
ICJyIikgYXMgZm9iajoKICAgICAgICAgICAgZm9yIGxpbmUgaW4gZm9iajoK
ICAgICAgICAgICAgICAgIGlmIGxpbmUuc3RyaXAoKS5zdGFydHN3aXRoKHZl
cnNpb25maWxlX3NvdXJjZSk6CiAgICAgICAgICAgICAgICAgICAgaWYgImV4
cG9ydC1zdWJzdCIgaW4gbGluZS5zdHJpcCgpLnNwbGl0KClbMTpdOgogICAg
ICAgICAgICAgICAgICAgICAgICBwcmVzZW50ID0gVHJ1ZQogICAgICAgICAg
ICAgICAgICAgICAgICBicmVhawogICAgZXhjZXB0IE9TRXJyb3I6CiAgICAg
ICAgcGFzcwogICAgaWYgbm90IHByZXNlbnQ6CiAgICAgICAgd2l0aCBvcGVu
KCIuZ2l0YXR0cmlidXRlcyIsICJhKyIpIGFzIGZvYmo6CiAgICAgICAgICAg
IGZvYmoud3JpdGUoZiJ7dmVyc2lvbmZpbGVfc291cmNlfSBleHBvcnQtc3Vi
c3RcbiIpCiAgICAgICAgZmlsZXMuYXBwZW5kKCIuZ2l0YXR0cmlidXRlcyIp
CiAgICBydW5fY29tbWFuZChHSVRTLCBbImFkZCIsICItLSJdICsgZmlsZXMp
CgoKZGVmIHZlcnNpb25zX2Zyb21fcGFyZW50ZGlyKHBhcmVudGRpcl9wcmVm
aXgsIHJvb3QsIHZlcmJvc2UpOgogICAgIiIiVHJ5IHRvIGRldGVybWluZSB0
aGUgdmVyc2lvbiBmcm9tIHRoZSBwYXJlbnQgZGlyZWN0b3J5IG5hbWUuCgog
ICAgU291cmNlIHRhcmJhbGxzIGNvbnZlbnRpb25hbGx5IHVucGFjayBpbnRv
IGEgZGlyZWN0b3J5IHRoYXQgaW5jbHVkZXMgYm90aAogICAgdGhlIHByb2pl
Y3QgbmFtZSBhbmQgYSB2ZXJzaW9uIHN0cmluZy4gV2Ugd2lsbCBhbHNvIHN1
cHBvcnQgc2VhcmNoaW5nIHVwCiAgICB0d28gZGlyZWN0b3J5IGxldmVscyBm
b3IgYW4gYXBwcm9wcmlhdGVseSBuYW1lZCBwYXJlbnQgZGlyZWN0b3J5CiAg
ICAiIiIKICAgIHJvb3RkaXJzID0gW10KCiAgICBmb3IgXyBpbiByYW5nZSgz
KToKICAgICAgICBkaXJuYW1lID0gb3MucGF0aC5iYXNlbmFtZShyb290KQog
ICAgICAgIGlmIGRpcm5hbWUuc3RhcnRzd2l0aChwYXJlbnRkaXJfcHJlZml4
KToKICAgICAgICAgICAgcmV0dXJuIHsidmVyc2lvbiI6IGRpcm5hbWVbbGVu
KHBhcmVudGRpcl9wcmVmaXgpOl0sCiAgICAgICAgICAgICAgICAgICAgImZ1
bGwtcmV2aXNpb25pZCI6IE5vbmUsCiAgICAgICAgICAgICAgICAgICAgImRp
cnR5IjogRmFsc2UsICJlcnJvciI6IE5vbmUsICJkYXRlIjogTm9uZX0KICAg
ICAgICByb290ZGlycy5hcHBlbmQocm9vdCkKICAgICAgICByb290ID0gb3Mu
cGF0aC5kaXJuYW1lKHJvb3QpICAjIHVwIGEgbGV2ZWwKCiAgICBpZiB2ZXJi
b3NlOgogICAgICAgIHByaW50KCJUcmllZCBkaXJlY3RvcmllcyAlcyBidXQg
bm9uZSBzdGFydGVkIHdpdGggcHJlZml4ICVzIiAlCiAgICAgICAgICAgICAg
KHN0cihyb290ZGlycyksIHBhcmVudGRpcl9wcmVmaXgpKQogICAgcmFpc2Ug
Tm90VGhpc01ldGhvZCgicm9vdGRpciBkb2Vzbid0IHN0YXJ0IHdpdGggcGFy
ZW50ZGlyX3ByZWZpeCIpCgoKU0hPUlRfVkVSU0lPTl9QWSA9ICIiIgojIFRo
aXMgZmlsZSB3YXMgZ2VuZXJhdGVkIGJ5ICd2ZXJzaW9uZWVyLnB5JyAoMC4y
NSkgZnJvbQojIHJldmlzaW9uLWNvbnRyb2wgc3lzdGVtIGRhdGEsIG9yIGZy
b20gdGhlIHBhcmVudCBkaXJlY3RvcnkgbmFtZSBvZiBhbgojIHVucGFja2Vk
IHNvdXJjZSBhcmNoaXZlLiBEaXN0cmlidXRpb24gdGFyYmFsbHMgY29udGFp
biBhIHByZS1nZW5lcmF0ZWQgY29weQojIG9mIHRoaXMgZmlsZS4KCmltcG9y
dCBqc29uCgp2ZXJzaW9uX2pzb24gPSAnJycKJXMKJycnICAjIEVORCBWRVJT
SU9OX0pTT04KCgpkZWYgZ2V0X3ZlcnNpb25zKCk6CiAgICByZXR1cm4ganNv
bi5sb2Fkcyh2ZXJzaW9uX2pzb24pCiIiIgoKCmRlZiB2ZXJzaW9uc19mcm9t
X2ZpbGUoZmlsZW5hbWUpOgogICAgIiIiVHJ5IHRvIGRldGVybWluZSB0aGUg
dmVyc2lvbiBmcm9tIF92ZXJzaW9uLnB5IGlmIHByZXNlbnQuIiIiCiAgICB0
cnk6CiAgICAgICAgd2l0aCBvcGVuKGZpbGVuYW1lKSBhcyBmOgogICAgICAg
ICAgICBjb250ZW50cyA9IGYucmVhZCgpCiAgICBleGNlcHQgT1NFcnJvcjoK
ICAgICAgICByYWlzZSBOb3RUaGlzTWV0aG9kKCJ1bmFibGUgdG8gcmVhZCBf
dmVyc2lvbi5weSIpCiAgICBtbyA9IHJlLnNlYXJjaChyInZlcnNpb25fanNv
biA9ICcnJ1xuKC4qKScnJyAgIyBFTkQgVkVSU0lPTl9KU09OIiwKICAgICAg
ICAgICAgICAgICAgIGNvbnRlbnRzLCByZS5NIHwgcmUuUykKICAgIGlmIG5v
dCBtbzoKICAgICAgICBtbyA9IHJlLnNlYXJjaChyInZlcnNpb25fanNvbiA9
ICcnJ1xyXG4oLiopJycnICAjIEVORCBWRVJTSU9OX0pTT04iLAogICAgICAg
ICAgICAgICAgICAgICAgIGNvbnRlbnRzLCByZS5NIHwgcmUuUykKICAgIGlm
IG5vdCBtbzoKICAgICAgICByYWlzZSBOb3RUaGlzTWV0aG9kKCJubyB2ZXJz
aW9uX2pzb24gaW4gX3ZlcnNpb24ucHkiKQogICAgcmV0dXJuIGpzb24ubG9h
ZHMobW8uZ3JvdXAoMSkpCgoKZGVmIHdyaXRlX3RvX3ZlcnNpb25fZmlsZShm
aWxlbmFtZSwgdmVyc2lvbnMpOgogICAgIiIiV3JpdGUgdGhlIGdpdmVuIHZl
cnNpb24gbnVtYmVyIHRvIHRoZSBnaXZlbiBfdmVyc2lvbi5weSBmaWxlLiIi
IgogICAgb3MudW5saW5rKGZpbGVuYW1lKQogICAgY29udGVudHMgPSBqc29u
LmR1bXBzKHZlcnNpb25zLCBzb3J0X2tleXM9VHJ1ZSwKICAgICAgICAgICAg
ICAgICAgICAgICAgICBpbmRlbnQ9MSwgc2VwYXJhdG9ycz0oIiwiLCAiOiAi
KSkKICAgIHdpdGggb3BlbihmaWxlbmFtZSwgInciKSBhcyBmOgogICAgICAg
IGYud3JpdGUoU0hPUlRfVkVSU0lPTl9QWSAlIGNvbnRlbnRzKQoKICAgIHBy
aW50KCJzZXQgJXMgdG8gJyVzJyIgJSAoZmlsZW5hbWUsIHZlcnNpb25zWyJ2
ZXJzaW9uIl0pKQoKCmRlZiBwbHVzX29yX2RvdChwaWVjZXMpOgogICAgIiIi
UmV0dXJuIGEgKyBpZiB3ZSBkb24ndCBhbHJlYWR5IGhhdmUgb25lLCBlbHNl
IHJldHVybiBhIC4iIiIKICAgIGlmICIrIiBpbiBwaWVjZXMuZ2V0KCJjbG9z
ZXN0LXRhZyIsICIiKToKICAgICAgICByZXR1cm4gIi4iCiAgICByZXR1cm4g
IisiCgoKZGVmIHJlbmRlcl9wZXA0NDAocGllY2VzKToKICAgICIiIkJ1aWxk
IHVwIHZlcnNpb24gc3RyaW5nLCB3aXRoIHBvc3QtcmVsZWFzZSAibG9jYWwg
dmVyc2lvbiBpZGVudGlmaWVyIi4KCiAgICBPdXIgZ29hbDogVEFHWytESVNU
QU5DRS5nSEVYWy5kaXJ0eV1dIC4gTm90ZSB0aGF0IGlmIHlvdQogICAgZ2V0
IGEgdGFnZ2VkIGJ1aWxkIGFuZCB0aGVuIGRpcnR5IGl0LCB5b3UnbGwgZ2V0
IFRBRyswLmdIRVguZGlydHkKCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8g
dGFncy4gZ2l0X2Rlc2NyaWJlIHdhcyBqdXN0IEhFWC4gMCt1bnRhZ2dlZC5E
SVNUQU5DRS5nSEVYWy5kaXJ0eV0KICAgICIiIgogICAgaWYgcGllY2VzWyJj
bG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVkID0gcGllY2VzWyJjbG9z
ZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJkaXN0YW5jZSJdIG9yIHBp
ZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gcGx1c19v
cl9kb3QocGllY2VzKQogICAgICAgICAgICByZW5kZXJlZCArPSAiJWQuZyVz
IiAlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBpZWNlc1sic2hvcnQiXSkKICAg
ICAgICAgICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICAgICAg
cmVuZGVyZWQgKz0gIi5kaXJ0eSIKICAgIGVsc2U6CiAgICAgICAgIyBleGNl
cHRpb24gIzEKICAgICAgICByZW5kZXJlZCA9ICIwK3VudGFnZ2VkLiVkLmcl
cyIgJSAocGllY2VzWyJkaXN0YW5jZSJdLAogICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICBwaWVjZXNbInNob3J0Il0pCiAgICAg
ICAgaWYgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCAr
PSAiLmRpcnR5IgogICAgcmV0dXJuIHJlbmRlcmVkCgoKZGVmIHJlbmRlcl9w
ZXA0NDBfYnJhbmNoKHBpZWNlcyk6CiAgICAiIiJUQUdbWy5kZXYwXStESVNU
QU5DRS5nSEVYWy5kaXJ0eV1dIC4KCiAgICBUaGUgIi5kZXYwIiBtZWFucyBu
b3QgbWFzdGVyIGJyYW5jaC4gTm90ZSB0aGF0IC5kZXYwIHNvcnRzIGJhY2t3
YXJkcwogICAgKGEgZmVhdHVyZSBicmFuY2ggd2lsbCBhcHBlYXIgIm9sZGVy
IiB0aGFuIHRoZSBtYXN0ZXIgYnJhbmNoKS4KCiAgICBFeGNlcHRpb25zOgog
ICAgMTogbm8gdGFncy4gMFsuZGV2MF0rdW50YWdnZWQuRElTVEFOQ0UuZ0hF
WFsuZGlydHldCiAgICAiIiIKICAgIGlmIHBpZWNlc1siY2xvc2VzdC10YWci
XToKICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1siY2xvc2VzdC10YWciXQog
ICAgICAgIGlmIHBpZWNlc1siZGlzdGFuY2UiXSBvciBwaWVjZXNbImRpcnR5
Il06CiAgICAgICAgICAgIGlmIHBpZWNlc1siYnJhbmNoIl0gIT0gIm1hc3Rl
ciI6CiAgICAgICAgICAgICAgICByZW5kZXJlZCArPSAiLmRldjAiCiAgICAg
ICAgICAgIHJlbmRlcmVkICs9IHBsdXNfb3JfZG90KHBpZWNlcykKICAgICAg
ICAgICAgcmVuZGVyZWQgKz0gIiVkLmclcyIgJSAocGllY2VzWyJkaXN0YW5j
ZSJdLCBwaWVjZXNbInNob3J0Il0pCiAgICAgICAgICAgIGlmIHBpZWNlc1si
ZGlydHkiXToKICAgICAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGlydHki
CiAgICBlbHNlOgogICAgICAgICMgZXhjZXB0aW9uICMxCiAgICAgICAgcmVu
ZGVyZWQgPSAiMCIKICAgICAgICBpZiBwaWVjZXNbImJyYW5jaCJdICE9ICJt
YXN0ZXIiOgogICAgICAgICAgICByZW5kZXJlZCArPSAiLmRldjAiCiAgICAg
ICAgcmVuZGVyZWQgKz0gIit1bnRhZ2dlZC4lZC5nJXMiICUgKHBpZWNlc1si
ZGlzdGFuY2UiXSwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgcGllY2VzWyJzaG9ydCJdKQogICAgICAgIGlmIHBpZWNlc1si
ZGlydHkiXToKICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kaXJ0eSIKICAg
IHJldHVybiByZW5kZXJlZAoKCmRlZiBwZXA0NDBfc3BsaXRfcG9zdCh2ZXIp
OgogICAgIiIiU3BsaXQgcGVwNDQwIHZlcnNpb24gc3RyaW5nIGF0IHRoZSBw
b3N0LXJlbGVhc2Ugc2VnbWVudC4KCiAgICBSZXR1cm5zIHRoZSByZWxlYXNl
IHNlZ21lbnRzIGJlZm9yZSB0aGUgcG9zdC1yZWxlYXNlIGFuZCB0aGUKICAg
IHBvc3QtcmVsZWFzZSB2ZXJzaW9uIG51bWJlciAob3IgLTEgaWYgbm8gcG9z
dC1yZWxlYXNlIHNlZ21lbnQgaXMgcHJlc2VudCkuCiAgICAiIiIKICAgIHZj
ID0gc3RyLnNwbGl0KHZlciwgIi5wb3N0IikKICAgIHJldHVybiB2Y1swXSwg
aW50KHZjWzFdIG9yIDApIGlmIGxlbih2YykgPT0gMiBlbHNlIE5vbmUKCgpk
ZWYgcmVuZGVyX3BlcDQ0MF9wcmUocGllY2VzKToKICAgICIiIlRBR1sucG9z
dE4uZGV2RElTVEFOQ0VdIC0tIE5vIC1kaXJ0eS4KCiAgICBFeGNlcHRpb25z
OgogICAgMTogbm8gdGFncy4gMC5wb3N0MC5kZXZESVNUQU5DRQogICAgIiIi
CiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgaWYgcGll
Y2VzWyJkaXN0YW5jZSJdOgogICAgICAgICAgICAjIHVwZGF0ZSB0aGUgcG9z
dCByZWxlYXNlIHNlZ21lbnQKICAgICAgICAgICAgdGFnX3ZlcnNpb24sIHBv
c3RfdmVyc2lvbiA9IHBlcDQ0MF9zcGxpdF9wb3N0KHBpZWNlc1siY2xvc2Vz
dC10YWciXSkKICAgICAgICAgICAgcmVuZGVyZWQgPSB0YWdfdmVyc2lvbgog
ICAgICAgICAgICBpZiBwb3N0X3ZlcnNpb24gaXMgbm90IE5vbmU6CiAgICAg
ICAgICAgICAgICByZW5kZXJlZCArPSAiLnBvc3QlZC5kZXYlZCIgJSAocG9z
dF92ZXJzaW9uICsgMSwgcGllY2VzWyJkaXN0YW5jZSJdKQogICAgICAgICAg
ICBlbHNlOgogICAgICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5wb3N0MC5k
ZXYlZCIgJSAocGllY2VzWyJkaXN0YW5jZSJdKQogICAgICAgIGVsc2U6CiAg
ICAgICAgICAgICMgbm8gY29tbWl0cywgdXNlIHRoZSB0YWcgYXMgdGhlIHZl
cnNpb24KICAgICAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3Qt
dGFnIl0KICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEKICAgICAg
ICByZW5kZXJlZCA9ICIwLnBvc3QwLmRldiVkIiAlIHBpZWNlc1siZGlzdGFu
Y2UiXQogICAgcmV0dXJuIHJlbmRlcmVkCgoKZGVmIHJlbmRlcl9wZXA0NDBf
cG9zdChwaWVjZXMpOgogICAgIiIiVEFHWy5wb3N0RElTVEFOQ0VbLmRldjBd
K2dIRVhdIC4KCiAgICBUaGUgIi5kZXYwIiBtZWFucyBkaXJ0eS4gTm90ZSB0
aGF0IC5kZXYwIHNvcnRzIGJhY2t3YXJkcwogICAgKGEgZGlydHkgdHJlZSB3
aWxsIGFwcGVhciAib2xkZXIiIHRoYW4gdGhlIGNvcnJlc3BvbmRpbmcgY2xl
YW4gb25lKSwKICAgIGJ1dCB5b3Ugc2hvdWxkbid0IGJlIHJlbGVhc2luZyBz
b2Z0d2FyZSB3aXRoIC1kaXJ0eSBhbnl3YXlzLgoKICAgIEV4Y2VwdGlvbnM6
CiAgICAxOiBubyB0YWdzLiAwLnBvc3RESVNUQU5DRVsuZGV2MF0KICAgICIi
IgogICAgaWYgcGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRl
cmVkID0gcGllY2VzWyJjbG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2Vz
WyJkaXN0YW5jZSJdIG9yIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAg
cmVuZGVyZWQgKz0gIi5wb3N0JWQiICUgcGllY2VzWyJkaXN0YW5jZSJdCiAg
ICAgICAgICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgICAg
IHJlbmRlcmVkICs9ICIuZGV2MCIKICAgICAgICAgICAgcmVuZGVyZWQgKz0g
cGx1c19vcl9kb3QocGllY2VzKQogICAgICAgICAgICByZW5kZXJlZCArPSAi
ZyVzIiAlIHBpZWNlc1sic2hvcnQiXQogICAgZWxzZToKICAgICAgICAjIGV4
Y2VwdGlvbiAjMQogICAgICAgIHJlbmRlcmVkID0gIjAucG9zdCVkIiAlIHBp
ZWNlc1siZGlzdGFuY2UiXQogICAgICAgIGlmIHBpZWNlc1siZGlydHkiXToK
ICAgICAgICAgICAgcmVuZGVyZWQgKz0gIi5kZXYwIgogICAgICAgIHJlbmRl
cmVkICs9ICIrZyVzIiAlIHBpZWNlc1sic2hvcnQiXQogICAgcmV0dXJuIHJl
bmRlcmVkCgoKZGVmIHJlbmRlcl9wZXA0NDBfcG9zdF9icmFuY2gocGllY2Vz
KToKICAgICIiIlRBR1sucG9zdERJU1RBTkNFWy5kZXYwXStnSEVYWy5kaXJ0
eV1dIC4KCiAgICBUaGUgIi5kZXYwIiBtZWFucyBub3QgbWFzdGVyIGJyYW5j
aC4KCiAgICBFeGNlcHRpb25zOgogICAgMTogbm8gdGFncy4gMC5wb3N0RElT
VEFOQ0VbLmRldjBdK2dIRVhbLmRpcnR5XQogICAgIiIiCiAgICBpZiBwaWVj
ZXNbImNsb3Nlc3QtdGFnIl06CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNb
ImNsb3Nlc3QtdGFnIl0KICAgICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl0g
b3IgcGllY2VzWyJkaXJ0eSJdOgogICAgICAgICAgICByZW5kZXJlZCArPSAi
LnBvc3QlZCIgJSBwaWVjZXNbImRpc3RhbmNlIl0KICAgICAgICAgICAgaWYg
cGllY2VzWyJicmFuY2giXSAhPSAibWFzdGVyIjoKICAgICAgICAgICAgICAg
IHJlbmRlcmVkICs9ICIuZGV2MCIKICAgICAgICAgICAgcmVuZGVyZWQgKz0g
cGx1c19vcl9kb3QocGllY2VzKQogICAgICAgICAgICByZW5kZXJlZCArPSAi
ZyVzIiAlIHBpZWNlc1sic2hvcnQiXQogICAgICAgICAgICBpZiBwaWVjZXNb
ImRpcnR5Il06CiAgICAgICAgICAgICAgICByZW5kZXJlZCArPSAiLmRpcnR5
IgogICAgZWxzZToKICAgICAgICAjIGV4Y2VwdGlvbiAjMQogICAgICAgIHJl
bmRlcmVkID0gIjAucG9zdCVkIiAlIHBpZWNlc1siZGlzdGFuY2UiXQogICAg
ICAgIGlmIHBpZWNlc1siYnJhbmNoIl0gIT0gIm1hc3RlciI6CiAgICAgICAg
ICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAgICAgICByZW5kZXJlZCArPSAi
K2clcyIgJSBwaWVjZXNbInNob3J0Il0KICAgICAgICBpZiBwaWVjZXNbImRp
cnR5Il06CiAgICAgICAgICAgIHJlbmRlcmVkICs9ICIuZGlydHkiCiAgICBy
ZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyX3BlcDQ0MF9vbGQocGllY2Vz
KToKICAgICIiIlRBR1sucG9zdERJU1RBTkNFWy5kZXYwXV0gLgoKICAgIFRo
ZSAiLmRldjAiIG1lYW5zIGRpcnR5LgoKICAgIEV4Y2VwdGlvbnM6CiAgICAx
OiBubyB0YWdzLiAwLnBvc3RESVNUQU5DRVsuZGV2MF0KICAgICIiIgogICAg
aWYgcGllY2VzWyJjbG9zZXN0LXRhZyJdOgogICAgICAgIHJlbmRlcmVkID0g
cGllY2VzWyJjbG9zZXN0LXRhZyJdCiAgICAgICAgaWYgcGllY2VzWyJkaXN0
YW5jZSJdIG9yIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgcmVuZGVy
ZWQgKz0gIi5wb3N0JWQiICUgcGllY2VzWyJkaXN0YW5jZSJdCiAgICAgICAg
ICAgIGlmIHBpZWNlc1siZGlydHkiXToKICAgICAgICAgICAgICAgIHJlbmRl
cmVkICs9ICIuZGV2MCIKICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24g
IzEKICAgICAgICByZW5kZXJlZCA9ICIwLnBvc3QlZCIgJSBwaWVjZXNbImRp
c3RhbmNlIl0KICAgICAgICBpZiBwaWVjZXNbImRpcnR5Il06CiAgICAgICAg
ICAgIHJlbmRlcmVkICs9ICIuZGV2MCIKICAgIHJldHVybiByZW5kZXJlZAoK
CmRlZiByZW5kZXJfZ2l0X2Rlc2NyaWJlKHBpZWNlcyk6CiAgICAiIiJUQUdb
LURJU1RBTkNFLWdIRVhdWy1kaXJ0eV0uCgogICAgTGlrZSAnZ2l0IGRlc2Ny
aWJlIC0tdGFncyAtLWRpcnR5IC0tYWx3YXlzJy4KCiAgICBFeGNlcHRpb25z
OgogICAgMTogbm8gdGFncy4gSEVYWy1kaXJ0eV0gIChub3RlOiBubyAnZycg
cHJlZml4KQogICAgIiIiCiAgICBpZiBwaWVjZXNbImNsb3Nlc3QtdGFnIl06
CiAgICAgICAgcmVuZGVyZWQgPSBwaWVjZXNbImNsb3Nlc3QtdGFnIl0KICAg
ICAgICBpZiBwaWVjZXNbImRpc3RhbmNlIl06CiAgICAgICAgICAgIHJlbmRl
cmVkICs9ICItJWQtZyVzIiAlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBpZWNl
c1sic2hvcnQiXSkKICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEK
ICAgICAgICByZW5kZXJlZCA9IHBpZWNlc1sic2hvcnQiXQogICAgaWYgcGll
Y2VzWyJkaXJ0eSJdOgogICAgICAgIHJlbmRlcmVkICs9ICItZGlydHkiCiAg
ICByZXR1cm4gcmVuZGVyZWQKCgpkZWYgcmVuZGVyX2dpdF9kZXNjcmliZV9s
b25nKHBpZWNlcyk6CiAgICAiIiJUQUctRElTVEFOQ0UtZ0hFWFstZGlydHld
LgoKICAgIExpa2UgJ2dpdCBkZXNjcmliZSAtLXRhZ3MgLS1kaXJ0eSAtLWFs
d2F5cyAtbG9uZycuCiAgICBUaGUgZGlzdGFuY2UvaGFzaCBpcyB1bmNvbmRp
dGlvbmFsLgoKICAgIEV4Y2VwdGlvbnM6CiAgICAxOiBubyB0YWdzLiBIRVhb
LWRpcnR5XSAgKG5vdGU6IG5vICdnJyBwcmVmaXgpCiAgICAiIiIKICAgIGlm
IHBpZWNlc1siY2xvc2VzdC10YWciXToKICAgICAgICByZW5kZXJlZCA9IHBp
ZWNlc1siY2xvc2VzdC10YWciXQogICAgICAgIHJlbmRlcmVkICs9ICItJWQt
ZyVzIiAlIChwaWVjZXNbImRpc3RhbmNlIl0sIHBpZWNlc1sic2hvcnQiXSkK
ICAgIGVsc2U6CiAgICAgICAgIyBleGNlcHRpb24gIzEKICAgICAgICByZW5k
ZXJlZCA9IHBpZWNlc1sic2hvcnQiXQogICAgaWYgcGllY2VzWyJkaXJ0eSJd
OgogICAgICAgIHJlbmRlcmVkICs9ICItZGlydHkiCiAgICByZXR1cm4gcmVu
ZGVyZWQKCgpkZWYgcmVuZGVyKHBpZWNlcywgc3R5bGUpOgogICAgIiIiUmVu
ZGVyIHRoZSBnaXZlbiB2ZXJzaW9uIHBpZWNlcyBpbnRvIHRoZSByZXF1ZXN0
ZWQgc3R5bGUuIiIiCiAgICBpZiBwaWVjZXNbImVycm9yIl06CiAgICAgICAg
cmV0dXJuIHsidmVyc2lvbiI6ICJ1bmtub3duIiwKICAgICAgICAgICAgICAg
ICJmdWxsLXJldmlzaW9uaWQiOiBwaWVjZXMuZ2V0KCJsb25nIiksCiAgICAg
ICAgICAgICAgICAiZGlydHkiOiBOb25lLAogICAgICAgICAgICAgICAgImVy
cm9yIjogcGllY2VzWyJlcnJvciJdLAogICAgICAgICAgICAgICAgImRhdGUi
OiBOb25lfQoKICAgIGlmIG5vdCBzdHlsZSBvciBzdHlsZSA9PSAiZGVmYXVs
dCI6CiAgICAgICAgc3R5bGUgPSAicGVwNDQwIiAgIyB0aGUgZGVmYXVsdAoK
ICAgIGlmIHN0eWxlID09ICJwZXA0NDAiOgogICAgICAgIHJlbmRlcmVkID0g
cmVuZGVyX3BlcDQ0MChwaWVjZXMpCiAgICBlbGlmIHN0eWxlID09ICJwZXA0
NDAtYnJhbmNoIjoKICAgICAgICByZW5kZXJlZCA9IHJlbmRlcl9wZXA0NDBf
YnJhbmNoKHBpZWNlcykKICAgIGVsaWYgc3R5bGUgPT0gInBlcDQ0MC1wcmUi
OgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9wcmUocGllY2Vz
KQogICAgZWxpZiBzdHlsZSA9PSAicGVwNDQwLXBvc3QiOgogICAgICAgIHJl
bmRlcmVkID0gcmVuZGVyX3BlcDQ0MF9wb3N0KHBpZWNlcykKICAgIGVsaWYg
c3R5bGUgPT0gInBlcDQ0MC1wb3N0LWJyYW5jaCI6CiAgICAgICAgcmVuZGVy
ZWQgPSByZW5kZXJfcGVwNDQwX3Bvc3RfYnJhbmNoKHBpZWNlcykKICAgIGVs
aWYgc3R5bGUgPT0gInBlcDQ0MC1vbGQiOgogICAgICAgIHJlbmRlcmVkID0g
cmVuZGVyX3BlcDQ0MF9vbGQocGllY2VzKQogICAgZWxpZiBzdHlsZSA9PSAi
Z2l0LWRlc2NyaWJlIjoKICAgICAgICByZW5kZXJlZCA9IHJlbmRlcl9naXRf
ZGVzY3JpYmUocGllY2VzKQogICAgZWxpZiBzdHlsZSA9PSAiZ2l0LWRlc2Ny
aWJlLWxvbmciOgogICAgICAgIHJlbmRlcmVkID0gcmVuZGVyX2dpdF9kZXNj
cmliZV9sb25nKHBpZWNlcykKICAgIGVsc2U6CiAgICAgICAgcmFpc2UgVmFs
dWVFcnJvcigidW5rbm93biBzdHlsZSAnJXMnIiAlIHN0eWxlKQoKICAgIHJl
dHVybiB7InZlcnNpb24iOiByZW5kZXJlZCwgImZ1bGwtcmV2aXNpb25pZCI6
IHBpZWNlc1sibG9uZyJdLAogICAgICAgICAgICAiZGlydHkiOiBwaWVjZXNb
ImRpcnR5Il0sICJlcnJvciI6IE5vbmUsCiAgICAgICAgICAgICJkYXRlIjog
cGllY2VzLmdldCgiZGF0ZSIpfQoKCmNsYXNzIFZlcnNpb25lZXJCYWRSb290
RXJyb3IoRXhjZXB0aW9uKToKICAgICIiIlRoZSBwcm9qZWN0IHJvb3QgZGly
ZWN0b3J5IGlzIHVua25vd24gb3IgbWlzc2luZyBrZXkgZmlsZXMuIiIiCgoK
ZGVmIGdldF92ZXJzaW9ucyh2ZXJib3NlPUZhbHNlKToKICAgICIiIkdldCB0
aGUgcHJvamVjdCB2ZXJzaW9uIGZyb20gd2hhdGV2ZXIgc291cmNlIGlzIGF2
YWlsYWJsZS4KCiAgICBSZXR1cm5zIGRpY3Qgd2l0aCB0d28ga2V5czogJ3Zl
cnNpb24nIGFuZCAnZnVsbCcuCiAgICAiIiIKICAgIGlmICJ2ZXJzaW9uZWVy
IiBpbiBzeXMubW9kdWxlczoKICAgICAgICAjIHNlZSB0aGUgZGlzY3Vzc2lv
biBpbiBjbWRjbGFzcy5weTpnZXRfY21kY2xhc3MoKQogICAgICAgIGRlbCBz
eXMubW9kdWxlc1sidmVyc2lvbmVlciJdCgogICAgcm9vdCA9IGdldF9yb290
KCkKICAgIGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290KHJvb3QpCgogICAg
YXNzZXJ0IGNmZy5WQ1MgaXMgbm90IE5vbmUsICJwbGVhc2Ugc2V0IFt2ZXJz
aW9uZWVyXVZDUz0gaW4gc2V0dXAuY2ZnIgogICAgaGFuZGxlcnMgPSBIQU5E
TEVSUy5nZXQoY2ZnLlZDUykKICAgIGFzc2VydCBoYW5kbGVycywgInVucmVj
b2duaXplZCBWQ1MgJyVzJyIgJSBjZmcuVkNTCiAgICB2ZXJib3NlID0gdmVy
Ym9zZSBvciBjZmcudmVyYm9zZQogICAgYXNzZXJ0IGNmZy52ZXJzaW9uZmls
ZV9zb3VyY2UgaXMgbm90IE5vbmUsIFwKICAgICAgICAicGxlYXNlIHNldCB2
ZXJzaW9uZWVyLnZlcnNpb25maWxlX3NvdXJjZSIKICAgIGFzc2VydCBjZmcu
dGFnX3ByZWZpeCBpcyBub3QgTm9uZSwgInBsZWFzZSBzZXQgdmVyc2lvbmVl
ci50YWdfcHJlZml4IgoKICAgIHZlcnNpb25maWxlX2FicyA9IG9zLnBhdGgu
am9pbihyb290LCBjZmcudmVyc2lvbmZpbGVfc291cmNlKQoKICAgICMgZXh0
cmFjdCB2ZXJzaW9uIGZyb20gZmlyc3Qgb2Y6IF92ZXJzaW9uLnB5LCBWQ1Mg
Y29tbWFuZCAoZS5nLiAnZ2l0CiAgICAjIGRlc2NyaWJlJyksIHBhcmVudGRp
ci4gVGhpcyBpcyBtZWFudCB0byB3b3JrIGZvciBkZXZlbG9wZXJzIHVzaW5n
IGEKICAgICMgc291cmNlIGNoZWNrb3V0LCBmb3IgdXNlcnMgb2YgYSB0YXJi
YWxsIGNyZWF0ZWQgYnkgJ3NldHVwLnB5IHNkaXN0JywKICAgICMgYW5kIGZv
ciB1c2VycyBvZiBhIHRhcmJhbGwvemlwYmFsbCBjcmVhdGVkIGJ5ICdnaXQg
YXJjaGl2ZScgb3IgZ2l0aHViJ3MKICAgICMgZG93bmxvYWQtZnJvbS10YWcg
ZmVhdHVyZSBvciB0aGUgZXF1aXZhbGVudCBpbiBvdGhlciBWQ1Nlcy4KCiAg
ICBnZXRfa2V5d29yZHNfZiA9IGhhbmRsZXJzLmdldCgiZ2V0X2tleXdvcmRz
IikKICAgIGZyb21fa2V5d29yZHNfZiA9IGhhbmRsZXJzLmdldCgia2V5d29y
ZHMiKQogICAgaWYgZ2V0X2tleXdvcmRzX2YgYW5kIGZyb21fa2V5d29yZHNf
ZjoKICAgICAgICB0cnk6CiAgICAgICAgICAgIGtleXdvcmRzID0gZ2V0X2tl
eXdvcmRzX2YodmVyc2lvbmZpbGVfYWJzKQogICAgICAgICAgICB2ZXIgPSBm
cm9tX2tleXdvcmRzX2Yoa2V5d29yZHMsIGNmZy50YWdfcHJlZml4LCB2ZXJi
b3NlKQogICAgICAgICAgICBpZiB2ZXJib3NlOgogICAgICAgICAgICAgICAg
cHJpbnQoImdvdCB2ZXJzaW9uIGZyb20gZXhwYW5kZWQga2V5d29yZCAlcyIg
JSB2ZXIpCiAgICAgICAgICAgIHJldHVybiB2ZXIKICAgICAgICBleGNlcHQg
Tm90VGhpc01ldGhvZDoKICAgICAgICAgICAgcGFzcwoKICAgIHRyeToKICAg
ICAgICB2ZXIgPSB2ZXJzaW9uc19mcm9tX2ZpbGUodmVyc2lvbmZpbGVfYWJz
KQogICAgICAgIGlmIHZlcmJvc2U6CiAgICAgICAgICAgIHByaW50KCJnb3Qg
dmVyc2lvbiBmcm9tIGZpbGUgJXMgJXMiICUgKHZlcnNpb25maWxlX2Ficywg
dmVyKSkKICAgICAgICByZXR1cm4gdmVyCiAgICBleGNlcHQgTm90VGhpc01l
dGhvZDoKICAgICAgICBwYXNzCgogICAgZnJvbV92Y3NfZiA9IGhhbmRsZXJz
LmdldCgicGllY2VzX2Zyb21fdmNzIikKICAgIGlmIGZyb21fdmNzX2Y6CiAg
ICAgICAgdHJ5OgogICAgICAgICAgICBwaWVjZXMgPSBmcm9tX3Zjc19mKGNm
Zy50YWdfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAgICAgICAgICB2ZXIg
PSByZW5kZXIocGllY2VzLCBjZmcuc3R5bGUpCiAgICAgICAgICAgIGlmIHZl
cmJvc2U6CiAgICAgICAgICAgICAgICBwcmludCgiZ290IHZlcnNpb24gZnJv
bSBWQ1MgJXMiICUgdmVyKQogICAgICAgICAgICByZXR1cm4gdmVyCiAgICAg
ICAgZXhjZXB0IE5vdFRoaXNNZXRob2Q6CiAgICAgICAgICAgIHBhc3MKCiAg
ICB0cnk6CiAgICAgICAgaWYgY2ZnLnBhcmVudGRpcl9wcmVmaXg6CiAgICAg
ICAgICAgIHZlciA9IHZlcnNpb25zX2Zyb21fcGFyZW50ZGlyKGNmZy5wYXJl
bnRkaXJfcHJlZml4LCByb290LCB2ZXJib3NlKQogICAgICAgICAgICBpZiB2
ZXJib3NlOgogICAgICAgICAgICAgICAgcHJpbnQoImdvdCB2ZXJzaW9uIGZy
b20gcGFyZW50ZGlyICVzIiAlIHZlcikKICAgICAgICAgICAgcmV0dXJuIHZl
cgogICAgZXhjZXB0IE5vdFRoaXNNZXRob2Q6CiAgICAgICAgcGFzcwoKICAg
IGlmIHZlcmJvc2U6CiAgICAgICAgcHJpbnQoInVuYWJsZSB0byBjb21wdXRl
IHZlcnNpb24iKQoKICAgIHJldHVybiB7InZlcnNpb24iOiAiMCt1bmtub3du
IiwgImZ1bGwtcmV2aXNpb25pZCI6IE5vbmUsCiAgICAgICAgICAgICJkaXJ0
eSI6IE5vbmUsICJlcnJvciI6ICJ1bmFibGUgdG8gY29tcHV0ZSB2ZXJzaW9u
IiwKICAgICAgICAgICAgImRhdGUiOiBOb25lfQoKCmRlZiBnZXRfdmVyc2lv
bigpOgogICAgIiIiR2V0IHRoZSBzaG9ydCB2ZXJzaW9uIHN0cmluZyBmb3Ig
dGhpcyBwcm9qZWN0LiIiIgogICAgcmV0dXJuIGdldF92ZXJzaW9ucygpWyJ2
ZXJzaW9uIl0KCgpkZWYgZ2V0X2NtZGNsYXNzKGNtZGNsYXNzPU5vbmUpOgog
ICAgIiIiR2V0IHRoZSBjdXN0b20gc2V0dXB0b29scyBzdWJjbGFzc2VzIHVz
ZWQgYnkgVmVyc2lvbmVlci4KCiAgICBJZiB0aGUgcGFja2FnZSB1c2VzIGEg
ZGlmZmVyZW50IGNtZGNsYXNzIChlLmcuIG9uZSBmcm9tIG51bXB5KSwgaXQK
ICAgIHNob3VsZCBiZSBwcm92aWRlIGFzIGFuIGFyZ3VtZW50LgogICAgIiIi
CiAgICBpZiAidmVyc2lvbmVlciIgaW4gc3lzLm1vZHVsZXM6CiAgICAgICAg
ZGVsIHN5cy5tb2R1bGVzWyJ2ZXJzaW9uZWVyIl0KICAgICAgICAjIHRoaXMg
Zml4ZXMgdGhlICJweXRob24gc2V0dXAucHkgZGV2ZWxvcCIgY2FzZSAoYWxz
byAnaW5zdGFsbCcgYW5kCiAgICAgICAgIyAnZWFzeV9pbnN0YWxsIC4nKSwg
aW4gd2hpY2ggc3ViZGVwZW5kZW5jaWVzIG9mIHRoZSBtYWluIHByb2plY3Qg
YXJlCiAgICAgICAgIyBidWlsdCAodXNpbmcgc2V0dXAucHkgYmRpc3RfZWdn
KSBpbiB0aGUgc2FtZSBweXRob24gcHJvY2Vzcy4gQXNzdW1lCiAgICAgICAg
IyBhIG1haW4gcHJvamVjdCBBIGFuZCBhIGRlcGVuZGVuY3kgQiwgd2hpY2gg
dXNlIGRpZmZlcmVudCB2ZXJzaW9ucwogICAgICAgICMgb2YgVmVyc2lvbmVl
ci4gQSdzIHNldHVwLnB5IGltcG9ydHMgQSdzIFZlcnNpb25lZXIsIGxlYXZp
bmcgaXQgaW4KICAgICAgICAjIHN5cy5tb2R1bGVzIGJ5IHRoZSB0aW1lIEIn
cyBzZXR1cC5weSBpcyBleGVjdXRlZCwgY2F1c2luZyBCIHRvIHJ1bgogICAg
ICAgICMgd2l0aCB0aGUgd3JvbmcgdmVyc2lvbmVlci4gU2V0dXB0b29scyB3
cmFwcyB0aGUgc3ViLWRlcCBidWlsZHMgaW4gYQogICAgICAgICMgc2FuZGJv
eCB0aGF0IHJlc3RvcmVzIHN5cy5tb2R1bGVzIHRvIGl0J3MgcHJlLWJ1aWxk
IHN0YXRlLCBzbyB0aGUKICAgICAgICAjIHBhcmVudCBpcyBwcm90ZWN0ZWQg
YWdhaW5zdCB0aGUgY2hpbGQncyAiaW1wb3J0IHZlcnNpb25lZXIiLiBCeQog
ICAgICAgICMgcmVtb3Zpbmcgb3Vyc2VsdmVzIGZyb20gc3lzLm1vZHVsZXMg
aGVyZSwgYmVmb3JlIHRoZSBjaGlsZCBidWlsZAogICAgICAgICMgaGFwcGVu
cywgd2UgcHJvdGVjdCB0aGUgY2hpbGQgZnJvbSB0aGUgcGFyZW50J3MgdmVy
c2lvbmVlciB0b28uCiAgICAgICAgIyBBbHNvIHNlZSBodHRwczovL2dpdGh1
Yi5jb20vcHl0aG9uLXZlcnNpb25lZXIvcHl0aG9uLXZlcnNpb25lZXIvaXNz
dWVzLzUyCgogICAgY21kcyA9IHt9IGlmIGNtZGNsYXNzIGlzIE5vbmUgZWxz
ZSBjbWRjbGFzcy5jb3B5KCkKCiAgICAjIHdlIGFkZCAidmVyc2lvbiIgdG8g
c2V0dXB0b29scwogICAgZnJvbSBzZXR1cHRvb2xzIGltcG9ydCBDb21tYW5k
CgogICAgY2xhc3MgY21kX3ZlcnNpb24oQ29tbWFuZCk6CiAgICAgICAgZGVz
Y3JpcHRpb24gPSAicmVwb3J0IGdlbmVyYXRlZCB2ZXJzaW9uIHN0cmluZyIK
ICAgICAgICB1c2VyX29wdGlvbnMgPSBbXQogICAgICAgIGJvb2xlYW5fb3B0
aW9ucyA9IFtdCgogICAgICAgIGRlZiBpbml0aWFsaXplX29wdGlvbnMoc2Vs
Zik6CiAgICAgICAgICAgIHBhc3MKCiAgICAgICAgZGVmIGZpbmFsaXplX29w
dGlvbnMoc2VsZik6CiAgICAgICAgICAgIHBhc3MKCiAgICAgICAgZGVmIHJ1
bihzZWxmKToKICAgICAgICAgICAgdmVycyA9IGdldF92ZXJzaW9ucyh2ZXJi
b3NlPVRydWUpCiAgICAgICAgICAgIHByaW50KCJWZXJzaW9uOiAlcyIgJSB2
ZXJzWyJ2ZXJzaW9uIl0pCiAgICAgICAgICAgIHByaW50KCIgZnVsbC1yZXZp
c2lvbmlkOiAlcyIgJSB2ZXJzLmdldCgiZnVsbC1yZXZpc2lvbmlkIikpCiAg
ICAgICAgICAgIHByaW50KCIgZGlydHk6ICVzIiAlIHZlcnMuZ2V0KCJkaXJ0
eSIpKQogICAgICAgICAgICBwcmludCgiIGRhdGU6ICVzIiAlIHZlcnMuZ2V0
KCJkYXRlIikpCiAgICAgICAgICAgIGlmIHZlcnNbImVycm9yIl06CiAgICAg
ICAgICAgICAgICBwcmludCgiIGVycm9yOiAlcyIgJSB2ZXJzWyJlcnJvciJd
KQogICAgY21kc1sidmVyc2lvbiJdID0gY21kX3ZlcnNpb24KCiAgICAjIHdl
IG92ZXJyaWRlICJidWlsZF9weSIgaW4gc2V0dXB0b29scwogICAgIwogICAg
IyBtb3N0IGludm9jYXRpb24gcGF0aHdheXMgZW5kIHVwIHJ1bm5pbmcgYnVp
bGRfcHk6CiAgICAjICBkaXN0dXRpbHMvYnVpbGQgLT4gYnVpbGRfcHkKICAg
ICMgIGRpc3R1dGlscy9pbnN0YWxsIC0+IGRpc3R1dGlscy9idWlsZCAtPi4u
CiAgICAjICBzZXR1cHRvb2xzL2JkaXN0X3doZWVsIC0+IGRpc3R1dGlscy9p
bnN0YWxsIC0+Li4KICAgICMgIHNldHVwdG9vbHMvYmRpc3RfZWdnIC0+IGRp
c3R1dGlscy9pbnN0YWxsX2xpYiAtPiBidWlsZF9weQogICAgIyAgc2V0dXB0
b29scy9pbnN0YWxsIC0+IGJkaXN0X2VnZyAtPi4uCiAgICAjICBzZXR1cHRv
b2xzL2RldmVsb3AgLT4gPwogICAgIyAgcGlwIGluc3RhbGw6CiAgICAjICAg
Y29waWVzIHNvdXJjZSB0cmVlIHRvIGEgdGVtcGRpciBiZWZvcmUgcnVubmlu
ZyBlZ2dfaW5mby9ldGMKICAgICMgICBpZiAuZ2l0IGlzbid0IGNvcGllZCB0
b28sICdnaXQgZGVzY3JpYmUnIHdpbGwgZmFpbAogICAgIyAgIHRoZW4gZG9l
cyBzZXR1cC5weSBiZGlzdF93aGVlbCwgb3Igc29tZXRpbWVzIHNldHVwLnB5
IGluc3RhbGwKICAgICMgIHNldHVwLnB5IGVnZ19pbmZvIC0+ID8KCiAgICAj
IHBpcCBpbnN0YWxsIC1lIC4gYW5kIHNldHVwdG9vbC9lZGl0YWJsZV93aGVl
bCB3aWxsIGludm9rZSBidWlsZF9weQogICAgIyBidXQgdGhlIGJ1aWxkX3B5
IGNvbW1hbmQgaXMgbm90IGV4cGVjdGVkIHRvIGNvcHkgYW55IGZpbGVzLgoK
ICAgICMgd2Ugb3ZlcnJpZGUgZGlmZmVyZW50ICJidWlsZF9weSIgY29tbWFu
ZHMgZm9yIGJvdGggZW52aXJvbm1lbnRzCiAgICBpZiAnYnVpbGRfcHknIGlu
IGNtZHM6CiAgICAgICAgX2J1aWxkX3B5ID0gY21kc1snYnVpbGRfcHknXQog
ICAgZWxzZToKICAgICAgICBmcm9tIHNldHVwdG9vbHMuY29tbWFuZC5idWls
ZF9weSBpbXBvcnQgYnVpbGRfcHkgYXMgX2J1aWxkX3B5CgogICAgY2xhc3Mg
Y21kX2J1aWxkX3B5KF9idWlsZF9weSk6CiAgICAgICAgZGVmIHJ1bihzZWxm
KToKICAgICAgICAgICAgcm9vdCA9IGdldF9yb290KCkKICAgICAgICAgICAg
Y2ZnID0gZ2V0X2NvbmZpZ19mcm9tX3Jvb3Qocm9vdCkKICAgICAgICAgICAg
dmVyc2lvbnMgPSBnZXRfdmVyc2lvbnMoKQogICAgICAgICAgICBfYnVpbGRf
cHkucnVuKHNlbGYpCiAgICAgICAgICAgIGlmIGdldGF0dHIoc2VsZiwgImVk
aXRhYmxlX21vZGUiLCBGYWxzZSk6CiAgICAgICAgICAgICAgICAjIER1cmlu
ZyBlZGl0YWJsZSBpbnN0YWxscyBgLnB5YCBhbmQgZGF0YSBmaWxlcyBhcmUK
ICAgICAgICAgICAgICAgICMgbm90IGNvcGllZCB0byBidWlsZF9saWIKICAg
ICAgICAgICAgICAgIHJldHVybgogICAgICAgICAgICAjIG5vdyBsb2NhdGUg
X3ZlcnNpb24ucHkgaW4gdGhlIG5ldyBidWlsZC8gZGlyZWN0b3J5IGFuZCBy
ZXBsYWNlCiAgICAgICAgICAgICMgaXQgd2l0aCBhbiB1cGRhdGVkIHZhbHVl
CiAgICAgICAgICAgIGlmIGNmZy52ZXJzaW9uZmlsZV9idWlsZDoKICAgICAg
ICAgICAgICAgIHRhcmdldF92ZXJzaW9uZmlsZSA9IG9zLnBhdGguam9pbihz
ZWxmLmJ1aWxkX2xpYiwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICBjZmcudmVyc2lvbmZpbGVfYnVpbGQpCiAg
ICAgICAgICAgICAgICBwcmludCgiVVBEQVRJTkcgJXMiICUgdGFyZ2V0X3Zl
cnNpb25maWxlKQogICAgICAgICAgICAgICAgd3JpdGVfdG9fdmVyc2lvbl9m
aWxlKHRhcmdldF92ZXJzaW9uZmlsZSwgdmVyc2lvbnMpCiAgICBjbWRzWyJi
dWlsZF9weSJdID0gY21kX2J1aWxkX3B5CgogICAgaWYgJ2J1aWxkX2V4dCcg
aW4gY21kczoKICAgICAgICBfYnVpbGRfZXh0ID0gY21kc1snYnVpbGRfZXh0
J10KICAgIGVsc2U6CiAgICAgICAgZnJvbSBzZXR1cHRvb2xzLmNvbW1hbmQu
YnVpbGRfZXh0IGltcG9ydCBidWlsZF9leHQgYXMgX2J1aWxkX2V4dAoKICAg
IGNsYXNzIGNtZF9idWlsZF9leHQoX2J1aWxkX2V4dCk6CiAgICAgICAgZGVm
IHJ1bihzZWxmKToKICAgICAgICAgICAgcm9vdCA9IGdldF9yb290KCkKICAg
ICAgICAgICAgY2ZnID0gZ2V0X2NvbmZpZ19mcm9tX3Jvb3Qocm9vdCkKICAg
ICAgICAgICAgdmVyc2lvbnMgPSBnZXRfdmVyc2lvbnMoKQogICAgICAgICAg
ICBfYnVpbGRfZXh0LnJ1bihzZWxmKQogICAgICAgICAgICBpZiBzZWxmLmlu
cGxhY2U6CiAgICAgICAgICAgICAgICAjIGJ1aWxkX2V4dCAtLWlucGxhY2Ug
d2lsbCBvbmx5IGJ1aWxkIGV4dGVuc2lvbnMgaW4KICAgICAgICAgICAgICAg
ICMgYnVpbGQvbGliPC4uPiBkaXIgd2l0aCBubyBfdmVyc2lvbi5weSB0byB3
cml0ZSB0by4KICAgICAgICAgICAgICAgICMgQXMgaW4gcGxhY2UgYnVpbGRz
IHdpbGwgYWxyZWFkeSBoYXZlIGEgX3ZlcnNpb24ucHkKICAgICAgICAgICAg
ICAgICMgaW4gdGhlIG1vZHVsZSBkaXIsIHdlIGRvIG5vdCBuZWVkIHRvIHdy
aXRlIG9uZS4KICAgICAgICAgICAgICAgIHJldHVybgogICAgICAgICAgICAj
IG5vdyBsb2NhdGUgX3ZlcnNpb24ucHkgaW4gdGhlIG5ldyBidWlsZC8gZGly
ZWN0b3J5IGFuZCByZXBsYWNlCiAgICAgICAgICAgICMgaXQgd2l0aCBhbiB1
cGRhdGVkIHZhbHVlCiAgICAgICAgICAgIHRhcmdldF92ZXJzaW9uZmlsZSA9
IG9zLnBhdGguam9pbihzZWxmLmJ1aWxkX2xpYiwKICAgICAgICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIGNmZy52ZXJzaW9uZmls
ZV9idWlsZCkKICAgICAgICAgICAgaWYgbm90IG9zLnBhdGguZXhpc3RzKHRh
cmdldF92ZXJzaW9uZmlsZSk6CiAgICAgICAgICAgICAgICBwcmludChmIldh
cm5pbmc6IHt0YXJnZXRfdmVyc2lvbmZpbGV9IGRvZXMgbm90IGV4aXN0LCBz
a2lwcGluZyAiCiAgICAgICAgICAgICAgICAgICAgICAidmVyc2lvbiB1cGRh
dGUuIFRoaXMgY2FuIGhhcHBlbiBpZiB5b3UgYXJlIHJ1bm5pbmcgYnVpbGRf
ZXh0ICIKICAgICAgICAgICAgICAgICAgICAgICJ3aXRob3V0IGZpcnN0IHJ1
bm5pbmcgYnVpbGRfcHkuIikKICAgICAgICAgICAgICAgIHJldHVybgogICAg
ICAgICAgICBwcmludCgiVVBEQVRJTkcgJXMiICUgdGFyZ2V0X3ZlcnNpb25m
aWxlKQogICAgICAgICAgICB3cml0ZV90b192ZXJzaW9uX2ZpbGUodGFyZ2V0
X3ZlcnNpb25maWxlLCB2ZXJzaW9ucykKICAgIGNtZHNbImJ1aWxkX2V4dCJd
ID0gY21kX2J1aWxkX2V4dAoKICAgIGlmICJjeF9GcmVlemUiIGluIHN5cy5t
b2R1bGVzOiAgIyBjeF9mcmVlemUgZW5hYmxlZD8KICAgICAgICBmcm9tIGN4
X0ZyZWV6ZS5kaXN0IGltcG9ydCBidWlsZF9leGUgYXMgX2J1aWxkX2V4ZQog
ICAgICAgICMgbmN6ZWN6dWxpbiByZXBvcnRzIHRoYXQgcHkyZXhlIHdvbid0
IGxpa2UgdGhlIHBlcDQ0MC1zdHlsZSBzdHJpbmcKICAgICAgICAjIGFzIEZJ
TEVWRVJTSU9OLCBidXQgaXQgY2FuIGJlIHVzZWQgZm9yIFBST0RVQ1RWRVJT
SU9OLCBlLmcuCiAgICAgICAgIyBzZXR1cChjb25zb2xlPVt7CiAgICAgICAg
IyAgICJ2ZXJzaW9uIjogdmVyc2lvbmVlci5nZXRfdmVyc2lvbigpLnNwbGl0
KCIrIiwgMSlbMF0sICMgRklMRVZFUlNJT04KICAgICAgICAjICAgInByb2R1
Y3RfdmVyc2lvbiI6IHZlcnNpb25lZXIuZ2V0X3ZlcnNpb24oKSwKICAgICAg
ICAjICAgLi4uCgogICAgICAgIGNsYXNzIGNtZF9idWlsZF9leGUoX2J1aWxk
X2V4ZSk6CiAgICAgICAgICAgIGRlZiBydW4oc2VsZik6CiAgICAgICAgICAg
ICAgICByb290ID0gZ2V0X3Jvb3QoKQogICAgICAgICAgICAgICAgY2ZnID0g
Z2V0X2NvbmZpZ19mcm9tX3Jvb3Qocm9vdCkKICAgICAgICAgICAgICAgIHZl
cnNpb25zID0gZ2V0X3ZlcnNpb25zKCkKICAgICAgICAgICAgICAgIHRhcmdl
dF92ZXJzaW9uZmlsZSA9IGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UKICAgICAg
ICAgICAgICAgIHByaW50KCJVUERBVElORyAlcyIgJSB0YXJnZXRfdmVyc2lv
bmZpbGUpCiAgICAgICAgICAgICAgICB3cml0ZV90b192ZXJzaW9uX2ZpbGUo
dGFyZ2V0X3ZlcnNpb25maWxlLCB2ZXJzaW9ucykKCiAgICAgICAgICAgICAg
ICBfYnVpbGRfZXhlLnJ1bihzZWxmKQogICAgICAgICAgICAgICAgb3MudW5s
aW5rKHRhcmdldF92ZXJzaW9uZmlsZSkKICAgICAgICAgICAgICAgIHdpdGgg
b3BlbihjZmcudmVyc2lvbmZpbGVfc291cmNlLCAidyIpIGFzIGY6CiAgICAg
ICAgICAgICAgICAgICAgTE9ORyA9IExPTkdfVkVSU0lPTl9QWVtjZmcuVkNT
XQogICAgICAgICAgICAgICAgICAgIGYud3JpdGUoTE9ORyAlCiAgICAgICAg
ICAgICAgICAgICAgICAgICAgICB7IkRPTExBUiI6ICIkIiwKICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICAiU1RZTEUiOiBjZmcuc3R5bGUsCiAgICAg
ICAgICAgICAgICAgICAgICAgICAgICAgIlRBR19QUkVGSVgiOiBjZmcudGFn
X3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAiUEFSRU5U
RElSX1BSRUZJWCI6IGNmZy5wYXJlbnRkaXJfcHJlZml4LAogICAgICAgICAg
ICAgICAgICAgICAgICAgICAgICJWRVJTSU9ORklMRV9TT1VSQ0UiOiBjZmcu
dmVyc2lvbmZpbGVfc291cmNlLAogICAgICAgICAgICAgICAgICAgICAgICAg
ICAgIH0pCiAgICAgICAgY21kc1siYnVpbGRfZXhlIl0gPSBjbWRfYnVpbGRf
ZXhlCiAgICAgICAgZGVsIGNtZHNbImJ1aWxkX3B5Il0KCiAgICBpZiAncHky
ZXhlJyBpbiBzeXMubW9kdWxlczogICMgcHkyZXhlIGVuYWJsZWQ/CiAgICAg
ICAgdHJ5OgogICAgICAgICAgICBmcm9tIHB5MmV4ZS5zZXR1cHRvb2xzX2J1
aWxkZXhlIGltcG9ydCBweTJleGUgYXMgX3B5MmV4ZQogICAgICAgIGV4Y2Vw
dCBJbXBvcnRFcnJvcjoKICAgICAgICAgICAgZnJvbSBweTJleGUuZGlzdHV0
aWxzX2J1aWxkZXhlIGltcG9ydCBweTJleGUgYXMgX3B5MmV4ZQoKICAgICAg
ICBjbGFzcyBjbWRfcHkyZXhlKF9weTJleGUpOgogICAgICAgICAgICBkZWYg
cnVuKHNlbGYpOgogICAgICAgICAgICAgICAgcm9vdCA9IGdldF9yb290KCkK
ICAgICAgICAgICAgICAgIGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290KHJv
b3QpCiAgICAgICAgICAgICAgICB2ZXJzaW9ucyA9IGdldF92ZXJzaW9ucygp
CiAgICAgICAgICAgICAgICB0YXJnZXRfdmVyc2lvbmZpbGUgPSBjZmcudmVy
c2lvbmZpbGVfc291cmNlCiAgICAgICAgICAgICAgICBwcmludCgiVVBEQVRJ
TkcgJXMiICUgdGFyZ2V0X3ZlcnNpb25maWxlKQogICAgICAgICAgICAgICAg
d3JpdGVfdG9fdmVyc2lvbl9maWxlKHRhcmdldF92ZXJzaW9uZmlsZSwgdmVy
c2lvbnMpCgogICAgICAgICAgICAgICAgX3B5MmV4ZS5ydW4oc2VsZikKICAg
ICAgICAgICAgICAgIG9zLnVubGluayh0YXJnZXRfdmVyc2lvbmZpbGUpCiAg
ICAgICAgICAgICAgICB3aXRoIG9wZW4oY2ZnLnZlcnNpb25maWxlX3NvdXJj
ZSwgInciKSBhcyBmOgogICAgICAgICAgICAgICAgICAgIExPTkcgPSBMT05H
X1ZFUlNJT05fUFlbY2ZnLlZDU10KICAgICAgICAgICAgICAgICAgICBmLndy
aXRlKExPTkcgJQogICAgICAgICAgICAgICAgICAgICAgICAgICAgeyJET0xM
QVIiOiAiJCIsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgIlNUWUxF
IjogY2ZnLnN0eWxlLAogICAgICAgICAgICAgICAgICAgICAgICAgICAgICJU
QUdfUFJFRklYIjogY2ZnLnRhZ19wcmVmaXgsCiAgICAgICAgICAgICAgICAg
ICAgICAgICAgICAgIlBBUkVOVERJUl9QUkVGSVgiOiBjZmcucGFyZW50ZGly
X3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAgICAgICAgICAiVkVSU0lP
TkZJTEVfU09VUkNFIjogY2ZnLnZlcnNpb25maWxlX3NvdXJjZSwKICAgICAg
ICAgICAgICAgICAgICAgICAgICAgICB9KQogICAgICAgIGNtZHNbInB5MmV4
ZSJdID0gY21kX3B5MmV4ZQoKICAgICMgc2Rpc3QgZmFybXMgaXRzIGZpbGUg
bGlzdCBidWlsZGluZyBvdXQgdG8gZWdnX2luZm8KICAgIGlmICdlZ2dfaW5m
bycgaW4gY21kczoKICAgICAgICBfc2Rpc3QgPSBjbWRzWydlZ2dfaW5mbydd
CiAgICBlbHNlOgogICAgICAgIGZyb20gc2V0dXB0b29scy5jb21tYW5kLmVn
Z19pbmZvIGltcG9ydCBlZ2dfaW5mbyBhcyBfZWdnX2luZm8KCiAgICBjbGFz
cyBjbWRfZWdnX2luZm8oX2VnZ19pbmZvKToKICAgICAgICBkZWYgZmluZF9z
b3VyY2VzKHNlbGYpOgogICAgICAgICAgICAjIGVnZ19pbmZvLmZpbmRfc291
cmNlcyBidWlsZHMgdGhlIG1hbmlmZXN0IGxpc3QgYW5kIHdyaXRlcyBpdAog
ICAgICAgICAgICAjIGluIG9uZSBzaG90CiAgICAgICAgICAgIHN1cGVyKCku
ZmluZF9zb3VyY2VzKCkKCiAgICAgICAgICAgICMgTW9kaWZ5IHRoZSBmaWxl
bGlzdCBhbmQgbm9ybWFsaXplIGl0CiAgICAgICAgICAgIHJvb3QgPSBnZXRf
cm9vdCgpCiAgICAgICAgICAgIGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290
KHJvb3QpCiAgICAgICAgICAgIHNlbGYuZmlsZWxpc3QuYXBwZW5kKCd2ZXJz
aW9uZWVyLnB5JykKICAgICAgICAgICAgaWYgY2ZnLnZlcnNpb25maWxlX3Nv
dXJjZToKICAgICAgICAgICAgICAgICMgVGhlcmUgYXJlIHJhcmUgY2FzZXMg
d2hlcmUgdmVyc2lvbmZpbGVfc291cmNlIG1pZ2h0IG5vdCBiZQogICAgICAg
ICAgICAgICAgIyBpbmNsdWRlZCBieSBkZWZhdWx0LCBzbyB3ZSBtdXN0IGJl
IGV4cGxpY2l0CiAgICAgICAgICAgICAgICBzZWxmLmZpbGVsaXN0LmFwcGVu
ZChjZmcudmVyc2lvbmZpbGVfc291cmNlKQogICAgICAgICAgICBzZWxmLmZp
bGVsaXN0LnNvcnQoKQogICAgICAgICAgICBzZWxmLmZpbGVsaXN0LnJlbW92
ZV9kdXBsaWNhdGVzKCkKCiAgICAgICAgICAgICMgVGhlIHdyaXRlIG1ldGhv
ZCBpcyBoaWRkZW4gaW4gdGhlIG1hbmlmZXN0X21ha2VyIGluc3RhbmNlIHRo
YXQKICAgICAgICAgICAgIyBnZW5lcmF0ZWQgdGhlIGZpbGVsaXN0IGFuZCB3
YXMgdGhyb3duIGF3YXkKICAgICAgICAgICAgIyBXZSB3aWxsIGluc3RlYWQg
cmVwbGljYXRlIHRoZWlyIGZpbmFsIG5vcm1hbGl6YXRpb24gKHRvIHVuaWNv
ZGUsCiAgICAgICAgICAgICMgYW5kIFBPU0lYLXN0eWxlIHBhdGhzKQogICAg
ICAgICAgICBmcm9tIHNldHVwdG9vbHMgaW1wb3J0IHVuaWNvZGVfdXRpbHMK
ICAgICAgICAgICAgbm9ybWFsaXplZCA9IFt1bmljb2RlX3V0aWxzLmZpbGVz
eXNfZGVjb2RlKGYpLnJlcGxhY2Uob3Muc2VwLCAnLycpCiAgICAgICAgICAg
ICAgICAgICAgICAgICAgZm9yIGYgaW4gc2VsZi5maWxlbGlzdC5maWxlc10K
CiAgICAgICAgICAgIG1hbmlmZXN0X2ZpbGVuYW1lID0gb3MucGF0aC5qb2lu
KHNlbGYuZWdnX2luZm8sICdTT1VSQ0VTLnR4dCcpCiAgICAgICAgICAgIHdp
dGggb3BlbihtYW5pZmVzdF9maWxlbmFtZSwgJ3cnKSBhcyBmb2JqOgogICAg
ICAgICAgICAgICAgZm9iai53cml0ZSgnXG4nLmpvaW4obm9ybWFsaXplZCkp
CgogICAgY21kc1snZWdnX2luZm8nXSA9IGNtZF9lZ2dfaW5mbwoKICAgICMg
d2Ugb3ZlcnJpZGUgZGlmZmVyZW50ICJzZGlzdCIgY29tbWFuZHMgZm9yIGJv
dGggZW52aXJvbm1lbnRzCiAgICBpZiAnc2Rpc3QnIGluIGNtZHM6CiAgICAg
ICAgX3NkaXN0ID0gY21kc1snc2Rpc3QnXQogICAgZWxzZToKICAgICAgICBm
cm9tIHNldHVwdG9vbHMuY29tbWFuZC5zZGlzdCBpbXBvcnQgc2Rpc3QgYXMg
X3NkaXN0CgogICAgY2xhc3MgY21kX3NkaXN0KF9zZGlzdCk6CiAgICAgICAg
ZGVmIHJ1bihzZWxmKToKICAgICAgICAgICAgdmVyc2lvbnMgPSBnZXRfdmVy
c2lvbnMoKQogICAgICAgICAgICBzZWxmLl92ZXJzaW9uZWVyX2dlbmVyYXRl
ZF92ZXJzaW9ucyA9IHZlcnNpb25zCiAgICAgICAgICAgICMgdW5sZXNzIHdl
IHVwZGF0ZSB0aGlzLCB0aGUgY29tbWFuZCB3aWxsIGtlZXAgdXNpbmcgdGhl
IG9sZAogICAgICAgICAgICAjIHZlcnNpb24KICAgICAgICAgICAgc2VsZi5k
aXN0cmlidXRpb24ubWV0YWRhdGEudmVyc2lvbiA9IHZlcnNpb25zWyJ2ZXJz
aW9uIl0KICAgICAgICAgICAgcmV0dXJuIF9zZGlzdC5ydW4oc2VsZikKCiAg
ICAgICAgZGVmIG1ha2VfcmVsZWFzZV90cmVlKHNlbGYsIGJhc2VfZGlyLCBm
aWxlcyk6CiAgICAgICAgICAgIHJvb3QgPSBnZXRfcm9vdCgpCiAgICAgICAg
ICAgIGNmZyA9IGdldF9jb25maWdfZnJvbV9yb290KHJvb3QpCiAgICAgICAg
ICAgIF9zZGlzdC5tYWtlX3JlbGVhc2VfdHJlZShzZWxmLCBiYXNlX2Rpciwg
ZmlsZXMpCiAgICAgICAgICAgICMgbm93IGxvY2F0ZSBfdmVyc2lvbi5weSBp
biB0aGUgbmV3IGJhc2VfZGlyIGRpcmVjdG9yeQogICAgICAgICAgICAjIChy
ZW1lbWJlcmluZyB0aGF0IGl0IG1heSBiZSBhIGhhcmRsaW5rKSBhbmQgcmVw
bGFjZSBpdCB3aXRoIGFuCiAgICAgICAgICAgICMgdXBkYXRlZCB2YWx1ZQog
ICAgICAgICAgICB0YXJnZXRfdmVyc2lvbmZpbGUgPSBvcy5wYXRoLmpvaW4o
YmFzZV9kaXIsIGNmZy52ZXJzaW9uZmlsZV9zb3VyY2UpCiAgICAgICAgICAg
IHByaW50KCJVUERBVElORyAlcyIgJSB0YXJnZXRfdmVyc2lvbmZpbGUpCiAg
ICAgICAgICAgIHdyaXRlX3RvX3ZlcnNpb25fZmlsZSh0YXJnZXRfdmVyc2lv
bmZpbGUsCiAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICAgICBzZWxm
Ll92ZXJzaW9uZWVyX2dlbmVyYXRlZF92ZXJzaW9ucykKICAgIGNtZHNbInNk
aXN0Il0gPSBjbWRfc2Rpc3QKCiAgICByZXR1cm4gY21kcwoKCkNPTkZJR19F
UlJPUiA9ICIiIgpzZXR1cC5jZmcgaXMgbWlzc2luZyB0aGUgbmVjZXNzYXJ5
IFZlcnNpb25lZXIgY29uZmlndXJhdGlvbi4gWW91IG5lZWQKYSBzZWN0aW9u
IGxpa2U6CgogW3ZlcnNpb25lZXJdCiBWQ1MgPSBnaXQKIHN0eWxlID0gcGVw
NDQwCiB2ZXJzaW9uZmlsZV9zb3VyY2UgPSBzcmMvbXlwcm9qZWN0L192ZXJz
aW9uLnB5CiB2ZXJzaW9uZmlsZV9idWlsZCA9IG15cHJvamVjdC9fdmVyc2lv
bi5weQogdGFnX3ByZWZpeCA9CiBwYXJlbnRkaXJfcHJlZml4ID0gbXlwcm9q
ZWN0LQoKWW91IHdpbGwgYWxzbyBuZWVkIHRvIGVkaXQgeW91ciBzZXR1cC5w
eSB0byB1c2UgdGhlIHJlc3VsdHM6CgogaW1wb3J0IHZlcnNpb25lZXIKIHNl
dHVwKHZlcnNpb249dmVyc2lvbmVlci5nZXRfdmVyc2lvbigpLAogICAgICAg
Y21kY2xhc3M9dmVyc2lvbmVlci5nZXRfY21kY2xhc3MoKSwgLi4uKQoKUGxl
YXNlIHJlYWQgdGhlIGRvY3N0cmluZyBpbiAuL3ZlcnNpb25lZXIucHkgZm9y
IGNvbmZpZ3VyYXRpb24gaW5zdHJ1Y3Rpb25zLAplZGl0IHNldHVwLmNmZywg
YW5kIHJlLXJ1biB0aGUgaW5zdGFsbGVyIG9yICdweXRob24gdmVyc2lvbmVl
ci5weSBzZXR1cCcuCiIiIgoKU0FNUExFX0NPTkZJRyA9ICIiIgojIFNlZSB0
aGUgZG9jc3RyaW5nIGluIHZlcnNpb25lZXIucHkgZm9yIGluc3RydWN0aW9u
cy4gTm90ZSB0aGF0IHlvdSBtdXN0CiMgcmUtcnVuICd2ZXJzaW9uZWVyLnB5
IHNldHVwJyBhZnRlciBjaGFuZ2luZyB0aGlzIHNlY3Rpb24sIGFuZCBjb21t
aXQgdGhlCiMgcmVzdWx0aW5nIGZpbGVzLgoKW3ZlcnNpb25lZXJdCiNWQ1Mg
PSBnaXQKI3N0eWxlID0gcGVwNDQwCiN2ZXJzaW9uZmlsZV9zb3VyY2UgPQoj
dmVyc2lvbmZpbGVfYnVpbGQgPQojdGFnX3ByZWZpeCA9CiNwYXJlbnRkaXJf
cHJlZml4ID0KCiIiIgoKT0xEX1NOSVBQRVQgPSAiIiIKZnJvbSAuX3ZlcnNp
b24gaW1wb3J0IGdldF92ZXJzaW9ucwpfX3ZlcnNpb25fXyA9IGdldF92ZXJz
aW9ucygpWyd2ZXJzaW9uJ10KZGVsIGdldF92ZXJzaW9ucwoiIiIKCklOSVRf
UFlfU05JUFBFVCA9ICIiIgpmcm9tIC4gaW1wb3J0IHswfQpfX3ZlcnNpb25f
XyA9IHswfS5nZXRfdmVyc2lvbnMoKVsndmVyc2lvbiddCiIiIgoKCmRlZiBk
b19zZXR1cCgpOgogICAgIiIiRG8gbWFpbiBWQ1MtaW5kZXBlbmRlbnQgc2V0
dXAgZnVuY3Rpb24gZm9yIGluc3RhbGxpbmcgVmVyc2lvbmVlci4iIiIKICAg
IHJvb3QgPSBnZXRfcm9vdCgpCiAgICB0cnk6CiAgICAgICAgY2ZnID0gZ2V0
X2NvbmZpZ19mcm9tX3Jvb3Qocm9vdCkKICAgIGV4Y2VwdCAoT1NFcnJvciwg
Y29uZmlncGFyc2VyLk5vU2VjdGlvbkVycm9yLAogICAgICAgICAgICBjb25m
aWdwYXJzZXIuTm9PcHRpb25FcnJvcikgYXMgZToKICAgICAgICBpZiBpc2lu
c3RhbmNlKGUsIChPU0Vycm9yLCBjb25maWdwYXJzZXIuTm9TZWN0aW9uRXJy
b3IpKToKICAgICAgICAgICAgcHJpbnQoIkFkZGluZyBzYW1wbGUgdmVyc2lv
bmVlciBjb25maWcgdG8gc2V0dXAuY2ZnIiwKICAgICAgICAgICAgICAgICAg
ZmlsZT1zeXMuc3RkZXJyKQogICAgICAgICAgICB3aXRoIG9wZW4ob3MucGF0
aC5qb2luKHJvb3QsICJzZXR1cC5jZmciKSwgImEiKSBhcyBmOgogICAgICAg
ICAgICAgICAgZi53cml0ZShTQU1QTEVfQ09ORklHKQogICAgICAgIHByaW50
KENPTkZJR19FUlJPUiwgZmlsZT1zeXMuc3RkZXJyKQogICAgICAgIHJldHVy
biAxCgogICAgcHJpbnQoIiBjcmVhdGluZyAlcyIgJSBjZmcudmVyc2lvbmZp
bGVfc291cmNlKQogICAgd2l0aCBvcGVuKGNmZy52ZXJzaW9uZmlsZV9zb3Vy
Y2UsICJ3IikgYXMgZjoKICAgICAgICBMT05HID0gTE9OR19WRVJTSU9OX1BZ
W2NmZy5WQ1NdCiAgICAgICAgZi53cml0ZShMT05HICUgeyJET0xMQVIiOiAi
JCIsCiAgICAgICAgICAgICAgICAgICAgICAgICJTVFlMRSI6IGNmZy5zdHls
ZSwKICAgICAgICAgICAgICAgICAgICAgICAgIlRBR19QUkVGSVgiOiBjZmcu
dGFnX3ByZWZpeCwKICAgICAgICAgICAgICAgICAgICAgICAgIlBBUkVOVERJ
Ul9QUkVGSVgiOiBjZmcucGFyZW50ZGlyX3ByZWZpeCwKICAgICAgICAgICAg
ICAgICAgICAgICAgIlZFUlNJT05GSUxFX1NPVVJDRSI6IGNmZy52ZXJzaW9u
ZmlsZV9zb3VyY2UsCiAgICAgICAgICAgICAgICAgICAgICAgIH0pCgogICAg
aXB5ID0gb3MucGF0aC5qb2luKG9zLnBhdGguZGlybmFtZShjZmcudmVyc2lv
bmZpbGVfc291cmNlKSwKICAgICAgICAgICAgICAgICAgICAgICAiX19pbml0
X18ucHkiKQogICAgaWYgb3MucGF0aC5leGlzdHMoaXB5KToKICAgICAgICB0
cnk6CiAgICAgICAgICAgIHdpdGggb3BlbihpcHksICJyIikgYXMgZjoKICAg
ICAgICAgICAgICAgIG9sZCA9IGYucmVhZCgpCiAgICAgICAgZXhjZXB0IE9T
RXJyb3I6CiAgICAgICAgICAgIG9sZCA9ICIiCiAgICAgICAgbW9kdWxlID0g
b3MucGF0aC5zcGxpdGV4dChvcy5wYXRoLmJhc2VuYW1lKGNmZy52ZXJzaW9u
ZmlsZV9zb3VyY2UpKVswXQogICAgICAgIHNuaXBwZXQgPSBJTklUX1BZX1NO
SVBQRVQuZm9ybWF0KG1vZHVsZSkKICAgICAgICBpZiBPTERfU05JUFBFVCBp
biBvbGQ6CiAgICAgICAgICAgIHByaW50KCIgcmVwbGFjaW5nIGJvaWxlcnBs
YXRlIGluICVzIiAlIGlweSkKICAgICAgICAgICAgd2l0aCBvcGVuKGlweSwg
InciKSBhcyBmOgogICAgICAgICAgICAgICAgZi53cml0ZShvbGQucmVwbGFj
ZShPTERfU05JUFBFVCwgc25pcHBldCkpCiAgICAgICAgZWxpZiBzbmlwcGV0
IG5vdCBpbiBvbGQ6CiAgICAgICAgICAgIHByaW50KCIgYXBwZW5kaW5nIHRv
ICVzIiAlIGlweSkKICAgICAgICAgICAgd2l0aCBvcGVuKGlweSwgImEiKSBh
cyBmOgogICAgICAgICAgICAgICAgZi53cml0ZShzbmlwcGV0KQogICAgICAg
IGVsc2U6CiAgICAgICAgICAgIHByaW50KCIgJXMgdW5tb2RpZmllZCIgJSBp
cHkpCiAgICBlbHNlOgogICAgICAgIHByaW50KCIgJXMgZG9lc24ndCBleGlz
dCwgb2siICUgaXB5KQogICAgICAgIGlweSA9IE5vbmUKCiAgICAjIE1ha2Ug
VkNTLXNwZWNpZmljIGNoYW5nZXMuIEZvciBnaXQsIHRoaXMgbWVhbnMgY3Jl
YXRpbmcvY2hhbmdpbmcKICAgICMgLmdpdGF0dHJpYnV0ZXMgdG8gbWFyayBf
dmVyc2lvbi5weSBmb3IgZXhwb3J0LXN1YnN0IGtleXdvcmQKICAgICMgc3Vi
c3RpdHV0aW9uLgogICAgZG9fdmNzX2luc3RhbGwoY2ZnLnZlcnNpb25maWxl
X3NvdXJjZSwgaXB5KQogICAgcmV0dXJuIDAKCgpkZWYgc2Nhbl9zZXR1cF9w
eSgpOgogICAgIiIiVmFsaWRhdGUgdGhlIGNvbnRlbnRzIG9mIHNldHVwLnB5
IGFnYWluc3QgVmVyc2lvbmVlcidzIGV4cGVjdGF0aW9ucy4iIiIKICAgIGZv
dW5kID0gc2V0KCkKICAgIHNldHRlcnMgPSBGYWxzZQogICAgZXJyb3JzID0g
MAogICAgd2l0aCBvcGVuKCJzZXR1cC5weSIsICJyIikgYXMgZjoKICAgICAg
ICBmb3IgbGluZSBpbiBmLnJlYWRsaW5lcygpOgogICAgICAgICAgICBpZiAi
aW1wb3J0IHZlcnNpb25lZXIiIGluIGxpbmU6CiAgICAgICAgICAgICAgICBm
b3VuZC5hZGQoImltcG9ydCIpCiAgICAgICAgICAgIGlmICJ2ZXJzaW9uZWVy
LmdldF9jbWRjbGFzcygpIiBpbiBsaW5lOgogICAgICAgICAgICAgICAgZm91
bmQuYWRkKCJjbWRjbGFzcyIpCiAgICAgICAgICAgIGlmICJ2ZXJzaW9uZWVy
LmdldF92ZXJzaW9uKCkiIGluIGxpbmU6CiAgICAgICAgICAgICAgICBmb3Vu
ZC5hZGQoImdldF92ZXJzaW9uIikKICAgICAgICAgICAgaWYgInZlcnNpb25l
ZXIuVkNTIiBpbiBsaW5lOgogICAgICAgICAgICAgICAgc2V0dGVycyA9IFRy
dWUKICAgICAgICAgICAgaWYgInZlcnNpb25lZXIudmVyc2lvbmZpbGVfc291
cmNlIiBpbiBsaW5lOgogICAgICAgICAgICAgICAgc2V0dGVycyA9IFRydWUK
ICAgIGlmIGxlbihmb3VuZCkgIT0gMzoKICAgICAgICBwcmludCgiIikKICAg
ICAgICBwcmludCgiWW91ciBzZXR1cC5weSBhcHBlYXJzIHRvIGJlIG1pc3Np
bmcgc29tZSBpbXBvcnRhbnQgaXRlbXMiKQogICAgICAgIHByaW50KCIoYnV0
IEkgbWlnaHQgYmUgd3JvbmcpLiBQbGVhc2UgbWFrZSBzdXJlIGl0IGhhcyBz
b21ldGhpbmciKQogICAgICAgIHByaW50KCJyb3VnaGx5IGxpa2UgdGhlIGZv
bGxvd2luZzoiKQogICAgICAgIHByaW50KCIiKQogICAgICAgIHByaW50KCIg
aW1wb3J0IHZlcnNpb25lZXIiKQogICAgICAgIHByaW50KCIgc2V0dXAoIHZl
cnNpb249dmVyc2lvbmVlci5nZXRfdmVyc2lvbigpLCIpCiAgICAgICAgcHJp
bnQoIiAgICAgICAgY21kY2xhc3M9dmVyc2lvbmVlci5nZXRfY21kY2xhc3Mo
KSwgIC4uLikiKQogICAgICAgIHByaW50KCIiKQogICAgICAgIGVycm9ycyAr
PSAxCiAgICBpZiBzZXR0ZXJzOgogICAgICAgIHByaW50KCJZb3Ugc2hvdWxk
IHJlbW92ZSBsaW5lcyBsaWtlICd2ZXJzaW9uZWVyLlZDUyA9ICcgYW5kIikK
ICAgICAgICBwcmludCgiJ3ZlcnNpb25lZXIudmVyc2lvbmZpbGVfc291cmNl
ID0gJyAuIFRoaXMgY29uZmlndXJhdGlvbiIpCiAgICAgICAgcHJpbnQoIm5v
dyBsaXZlcyBpbiBzZXR1cC5jZmcsIGFuZCBzaG91bGQgYmUgcmVtb3ZlZCBm
cm9tIHNldHVwLnB5IikKICAgICAgICBwcmludCgiIikKICAgICAgICBlcnJv
cnMgKz0gMQogICAgcmV0dXJuIGVycm9ycwoKCmRlZiBzZXR1cF9jb21tYW5k
KCk6CiAgICAiIiJTZXQgdXAgVmVyc2lvbmVlciBhbmQgZXhpdCB3aXRoIGFw
cHJvcHJpYXRlIGVycm9yIGNvZGUuIiIiCiAgICBlcnJvcnMgPSBkb19zZXR1
cCgpCiAgICBlcnJvcnMgKz0gc2Nhbl9zZXR1cF9weSgpCiAgICBzeXMuZXhp
dCgxIGlmIGVycm9ycyBlbHNlIDApCgoKaWYgX19uYW1lX18gPT0gIl9fbWFp
bl9fIjoKICAgIGNtZCA9IHN5cy5hcmd2WzFdCiAgICBpZiBjbWQgPT0gInNl
dHVwIjoKICAgICAgICBzZXR1cF9jb21tYW5kKCkK

"""
newver = "0.25"

VERSIONEER_PEP518 = True

VERSIONEER = base64.b64decode(VERSIONEER_b64.encode('ASCII'))


# Stub overwritten by exec()
def setup_command(): ...

# Make versioneer usable via import
exec(VERSIONEER.decode(), globals())


def detect_installed_version() -> str:
    """Find version string in vendored versioneer

    Raises FileNotFoundError if missing.
    """
    with open("versioneer.py") as fobj:
        for i, line in enumerate(fobj):
            if line.startswith("# Version: "):
                return line[len("# Version: "):].strip()
            if i > 5:
                break
    return "unknown version"


def vendor():
    """Install versioneer into current directory"""
    try:
        oldver = detect_installed_version()
    except FileNotFoundError:
        pass
    else:
        print(f"replacing old versioneer.py ({oldver})")

    with open("versioneer.py", "wb") as fobj:
        fobj.write(VERSIONEER)
    print(f"versioneer.py ({newver}) installed into local tree")


def main():
    usage = "Usage: versioneer install [--vendor|--no-vendor]"
    if len(sys.argv) < 2 or len(sys.argv) > 3:
        print(usage)
        sys.exit(1)

    command = sys.argv[1]
    mode = "--vendor" if len(sys.argv) == 2 else sys.argv[2]

    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)
    elif command in ("help", "-help", "--help"):
        print(usage)
        sys.exit(0)
    elif command != "install" or mode not in ("--vendor", "--no-vendor"):
        print(usage)
        sys.exit(1)

    if mode == "--vendor":
        vendor()
        print("Now running 'versioneer.py setup' to install the generated files..")

    setup_command()


if __name__ == '__main__':
    main()
